#include "codegen.h"

const guint8 mono_burg_arity [] = {
	0,
	0, /* CONST_I4 */
	0, /* CONST_I8 */
	0, /* CONST_R4 */
	0, /* CONST_R8 */
	1, /* LDIND_I1 */
	1, /* LDIND_U1 */
	1, /* LDIND_I2 */
	1, /* LDIND_U2 */
	1, /* LDIND_I4 */
	1, /* LDIND_I8 */
	1, /* LDIND_R4 */
	1, /* LDIND_R8 */
	1, /* LDIND_OBJ */
	2, /* STIND_I1 */
	2, /* STIND_I2 */
	2, /* STIND_I4 */
	2, /* STIND_I8 */
	2, /* STIND_R4 */
	2, /* STIND_R8 */
	2, /* STIND_OBJ */
	0, /* ADDR_L */
	0, /* ADDR_G */
	1, /* ARG_I4 */
	1, /* ARG_I8 */
	1, /* ARG_R4 */
	1, /* ARG_R8 */
	1, /* ARG_OBJ */
	2, /* CALL_I4 */
	2, /* CALL_I8 */
	2, /* CALL_R8 */
	2, /* CALL_VOID */
	0, /* BREAK */
	1, /* SWITCH */
	0, /* BR */
	0, /* RET_VOID */
	1, /* RET */
	1, /* RET_OBJ */
	0, /* ENDFINALLY */
	1, /* ENDFILTER */
	0, /* JMP */
	2, /* ADD */
	2, /* ADD_OVF */
	2, /* ADD_OVF_UN */
	2, /* SUB */
	2, /* SUB_OVF */
	2, /* SUB_OVF_UN */
	2, /* MUL */
	2, /* MUL_OVF */
	2, /* MUL_OVF_UN */
	2, /* DIV */
	2, /* DIV_UN */
	2, /* REM */
	2, /* REM_UN */
	2, /* AND */
	2, /* OR */
	2, /* XOR */
	2, /* SHL */
	2, /* SHR */
	2, /* SHR_UN */
	1, /* NEG */
	1, /* NOT */
	1, /* CKFINITE */
	2, /* COMPARE */
	1, /* CBRANCH */
	1, /* BRTRUE */
	1, /* BRFALSE */
	1, /* CSET */
	1, /* CONV_I4 */
	1, /* CONV_I1 */
	1, /* CONV_I2 */
	1, /* CONV_I8 */
	1, /* CONV_U1 */
	1, /* CONV_U2 */
	1, /* CONV_U4 */
	1, /* CONV_U8 */
	1, /* CONV_R4 */
	1, /* CONV_R8 */
	1, /* CONV_R_UN */
	0, /* INTF_ADDR */
	0, /* VFUNC_ADDR */
	0, /* NOP */
	1, /* NEWARR */
	1, /* NEWARR_SPEC */
	0, /* NEWOBJ */
	0, /* NEWOBJ_SPEC */
	2, /* INITBLK */
	2, /* CPBLK */
	2, /* CPSRC */
	1, /* POP */
	1, /* INITOBJ */
	1, /* LOCALLOC */
	1, /* ISINST */
	1, /* CASTCLASS */
	1, /* UNBOX */
	1, /* CONV_OVF_I1 */
	1, /* CONV_OVF_U1 */
	1, /* CONV_OVF_I2 */
	1, /* CONV_OVF_U2 */
	1, /* CONV_OVF_U4 */
	1, /* CONV_OVF_U8 */
	1, /* CONV_OVF_I4 */
	1, /* CONV_OVF_I4_UN */
	1, /* CONV_OVF_U1_UN */
	1, /* CONV_OVF_U2_UN */
	1, /* CONV_OVF_I2_UN */
	1, /* CONV_OVF_I8_UN */
	1, /* CONV_OVF_I1_UN */
	0, /* EXCEPTION */
	1, /* THROW */
	0, /* RETHROW */
	0, /* HANDLER */
	1, /* CHECKTHIS */
	1, /* LDLEN */
	2, /* LDELEMA */
	0, /* LDFTN */
	2, /* LDVIRTFTN */
	0, /* LDSTR */
	1, /* LDSFLDA */
	1, /* REMOTE_LDFLDA */
	2, /* REMOTE_STIND_I1 */
	2, /* REMOTE_STIND_I2 */
	2, /* REMOTE_STIND_I4 */
	2, /* REMOTE_STIND_I8 */
	2, /* REMOTE_STIND_R4 */
	2, /* REMOTE_STIND_R8 */
	2, /* REMOTE_STIND_OBJ */
	1, /* SIN */
	1, /* COS */
	1, /* SQRT */
	1, /* FUNC1 */
	2, /* PROC2 */
	2, /* PROC3 */
	1, /* FREE */
	1, /* OBJADDR */
	1, /* VTADDR */
};

const char *const mono_burg_term_string [] = {
	NULL,
	"CONST_I4",
	"CONST_I8",
	"CONST_R4",
	"CONST_R8",
	"LDIND_I1",
	"LDIND_U1",
	"LDIND_I2",
	"LDIND_U2",
	"LDIND_I4",
	"LDIND_I8",
	"LDIND_R4",
	"LDIND_R8",
	"LDIND_OBJ",
	"STIND_I1",
	"STIND_I2",
	"STIND_I4",
	"STIND_I8",
	"STIND_R4",
	"STIND_R8",
	"STIND_OBJ",
	"ADDR_L",
	"ADDR_G",
	"ARG_I4",
	"ARG_I8",
	"ARG_R4",
	"ARG_R8",
	"ARG_OBJ",
	"CALL_I4",
	"CALL_I8",
	"CALL_R8",
	"CALL_VOID",
	"BREAK",
	"SWITCH",
	"BR",
	"RET_VOID",
	"RET",
	"RET_OBJ",
	"ENDFINALLY",
	"ENDFILTER",
	"JMP",
	"ADD",
	"ADD_OVF",
	"ADD_OVF_UN",
	"SUB",
	"SUB_OVF",
	"SUB_OVF_UN",
	"MUL",
	"MUL_OVF",
	"MUL_OVF_UN",
	"DIV",
	"DIV_UN",
	"REM",
	"REM_UN",
	"AND",
	"OR",
	"XOR",
	"SHL",
	"SHR",
	"SHR_UN",
	"NEG",
	"NOT",
	"CKFINITE",
	"COMPARE",
	"CBRANCH",
	"BRTRUE",
	"BRFALSE",
	"CSET",
	"CONV_I4",
	"CONV_I1",
	"CONV_I2",
	"CONV_I8",
	"CONV_U1",
	"CONV_U2",
	"CONV_U4",
	"CONV_U8",
	"CONV_R4",
	"CONV_R8",
	"CONV_R_UN",
	"INTF_ADDR",
	"VFUNC_ADDR",
	"NOP",
	"NEWARR",
	"NEWARR_SPEC",
	"NEWOBJ",
	"NEWOBJ_SPEC",
	"INITBLK",
	"CPBLK",
	"CPSRC",
	"POP",
	"INITOBJ",
	"LOCALLOC",
	"ISINST",
	"CASTCLASS",
	"UNBOX",
	"CONV_OVF_I1",
	"CONV_OVF_U1",
	"CONV_OVF_I2",
	"CONV_OVF_U2",
	"CONV_OVF_U4",
	"CONV_OVF_U8",
	"CONV_OVF_I4",
	"CONV_OVF_I4_UN",
	"CONV_OVF_U1_UN",
	"CONV_OVF_U2_UN",
	"CONV_OVF_I2_UN",
	"CONV_OVF_I8_UN",
	"CONV_OVF_I1_UN",
	"EXCEPTION",
	"THROW",
	"RETHROW",
	"HANDLER",
	"CHECKTHIS",
	"LDLEN",
	"LDELEMA",
	"LDFTN",
	"LDVIRTFTN",
	"LDSTR",
	"LDSFLDA",
	"REMOTE_LDFLDA",
	"REMOTE_STIND_I1",
	"REMOTE_STIND_I2",
	"REMOTE_STIND_I4",
	"REMOTE_STIND_I8",
	"REMOTE_STIND_R4",
	"REMOTE_STIND_R8",
	"REMOTE_STIND_OBJ",
	"SIN",
	"COS",
	"SQRT",
	"FUNC1",
	"PROC2",
	"PROC3",
	"FREE",
	"OBJADDR",
	"VTADDR",
};

const char * const mono_burg_rule_string [] = {
	NULL,
	"acon: CONST_I4",
	"acon: ADDR_G",
	"acon: ADD(ADDR_G, CONST_I4)",
	"base: acon",
	"base: reg",
	"base: ADD(reg, CONST_I4)",
	"base: ADDR_L",
	"index: reg",
	"index: SHL(reg, CONST_I4)",
	"index: MUL(reg, CONST_I4)",
	"addr: base",
	"addr: index",
	"addr: ADD(index, base)",
	"reg: EXCEPTION",
	"stmt: THROW(reg)",
	"stmt: RETHROW",
	"stmt: HANDLER",
	"stmt: ENDFINALLY",
	"stmt: ENDFILTER(reg)",
	"stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), CONST_I4))",
	"stmt: STIND_I4(ADDR_L, SUB(LDIND_I4(ADDR_L), CONST_I4))",
	"stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), reg))",
	"stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L))",
	"stmt: STIND_I4(addr, CONST_I4)",
	"stmt: STIND_I4(addr, reg)",
	"stmt: REMOTE_STIND_I4(reg, reg)",
	"stmt: STIND_I1(addr, reg)",
	"stmt: REMOTE_STIND_I1(reg, reg)",
	"stmt: STIND_I2(addr, reg)",
	"stmt: REMOTE_STIND_I2(reg, reg)",
	"reg: LDIND_I4(ADDR_L)",
	"stmt: STIND_I4(ADDR_L, CONST_I4)",
	"stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L))",
	"stmt: STIND_I4(ADDR_L, reg)",
	"reg: LDIND_I4(addr)",
	"reg: LDIND_I1(addr)",
	"reg: LDIND_U1(addr)",
	"reg: LDIND_I2(addr)",
	"reg: LDIND_U2(addr)",
	"reg: REMOTE_LDFLDA(reg)",
	"reg: ADDR_L",
	"reg: ADDR_G",
	"reg: CONV_I1(reg)",
	"reg: CONV_U1(reg)",
	"reg: CONV_I2(reg)",
	"reg: CONV_U2(reg)",
	"reg: CONST_I4",
	"reg: CONV_I4(reg)",
	"reg: CONV_U4(reg)",
	"reg: CONV_OVF_I4(reg)",
	"reg: CONV_OVF_U4(reg)",
	"reg: CONV_OVF_I4_UN(reg)",
	"reg: CONV_OVF_I1(reg)",
	"reg: CONV_OVF_I1_UN(reg)",
	"reg: CONV_OVF_U1(reg)",
	"reg: CONV_OVF_U1_UN(reg)",
	"reg: CONV_OVF_I2(reg)",
	"reg: CONV_OVF_U2(reg)",
	"reg: CONV_OVF_U2_UN(reg)",
	"reg: CONV_OVF_I2_UN(reg)",
	"reg: MUL(reg, CONST_I4)",
	"reg: MUL(reg, reg)",
	"reg: MUL_OVF(reg, reg)",
	"reg: MUL_OVF_UN(reg, reg)",
	"reg: DIV(reg, CONST_I4)",
	"reg: DIV(reg, reg)",
	"reg: DIV_UN(reg, CONST_I4)",
	"reg: DIV_UN(reg, reg)",
	"reg: REM(reg, reg)",
	"reg: REM_UN(reg, reg)",
	"reg: ADD(reg, CONST_I4)",
	"reg: ADD(reg, LDIND_I4(ADDR_L))",
	"reg: ADD(reg, reg)",
	"reg: ADD_OVF(reg, reg)",
	"reg: ADD_OVF_UN(reg, reg)",
	"reg: SUB(reg, CONST_I4)",
	"reg: SUB(reg, LDIND_I4(ADDR_L))",
	"reg: SUB(reg, reg)",
	"reg: SUB_OVF(reg, reg)",
	"reg: SUB_OVF_UN(reg, reg)",
	"reg: CSET(cflags)",
	"reg: AND(reg, CONST_I4)",
	"reg: AND(reg, reg)",
	"reg: OR(reg, CONST_I4)",
	"reg: OR(reg, reg)",
	"reg: XOR(reg, CONST_I4)",
	"reg: XOR(reg, reg)",
	"reg: NEG(reg)",
	"reg: NOT(reg)",
	"reg: SHL(reg, CONST_I4)",
	"reg: SHL(reg, reg)",
	"reg: SHR(reg, CONST_I4)",
	"reg: SHR(reg, reg)",
	"reg: SHR_UN(reg, CONST_I4)",
	"reg: SHR_UN(reg, reg)",
	"reg: LDSFLDA(CONST_I4)",
	"reg: LDLEN(reg)",
	"reg: LDELEMA(reg, CONST_I4)",
	"reg: LDELEMA(reg, reg)",
	"reg: LDSTR",
	"reg: NEWARR(reg)",
	"reg: NEWARR_SPEC(reg)",
	"reg: NEWOBJ",
	"reg: NEWOBJ_SPEC",
	"reg: OBJADDR(reg)",
	"reg: VTADDR(ADDR_L)",
	"stmt: FREE(reg)",
	"stmt: PROC2(reg, reg)",
	"stmt: PROC3(reg, CPSRC(reg, reg))",
	"reg: FUNC1(reg)",
	"reg: LOCALLOC(reg)",
	"reg: UNBOX(reg)",
	"reg: CASTCLASS(reg)",
	"reg: ISINST(reg)",
	"stmt: INITOBJ(reg)",
	"stmt: CPBLK(reg, CPSRC(reg, CONST_I4))",
	"stmt: CPBLK(reg, CPSRC(reg, reg))",
	"stmt: INITBLK(reg, CPSRC(reg, CONST_I4))",
	"stmt: INITBLK(reg, CPSRC(reg, reg))",
	"stmt: NOP",
	"stmt: POP(reg)",
	"stmt: BR",
	"cflags: COMPARE(reg, LDIND_I4(ADDR_L))",
	"cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4)",
	"cflags: COMPARE(LDIND_I4(ADDR_L), reg)",
	"cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4)",
	"cflags: COMPARE(reg, CONST_I4)",
	"cflags: COMPARE(reg, reg)",
	"stmt: CBRANCH(cflags)",
	"stmt: BRTRUE(LDIND_I4(ADDR_L))",
	"stmt: BRTRUE(reg)",
	"stmt: BRFALSE(LDIND_I4(ADDR_L))",
	"stmt: BRFALSE(reg)",
	"stmt: BREAK",
	"stmt: RET(reg)",
	"stmt: RET_VOID",
	"stmt: ARG_I4(LDIND_I4(addr))",
	"stmt: ARG_I4(LDIND_I4(ADDR_L))",
	"stmt: ARG_I4(reg)",
	"stmt: ARG_I4(ADDR_G)",
	"stmt: ARG_I4(CONST_I4)",
	"this: reg",
	"reg: CHECKTHIS(reg)",
	"stmt: CHECKTHIS(reg)",
	"stmt: JMP",
	"this: NOP",
	"reg: CALL_I4(this, reg)",
	"reg: CALL_I4(this, ADDR_G)",
	"reg: LDVIRTFTN(reg, INTF_ADDR)",
	"reg: CALL_I4(this, INTF_ADDR)",
	"reg: LDVIRTFTN(reg, VFUNC_ADDR)",
	"reg: LDFTN",
	"reg: CALL_I4(this, VFUNC_ADDR)",
	"stmt: CALL_VOID(this, ADDR_G)",
	"stmt: CALL_VOID(this, reg)",
	"stmt: CALL_VOID(this, INTF_ADDR)",
	"stmt: CALL_VOID(this, VFUNC_ADDR)",
	"stmt: SWITCH(reg)",
	"reg: CONV_I1(lreg)",
	"reg: CONV_U1(lreg)",
	"reg: CONV_I2(lreg)",
	"reg: CONV_U2(lreg)",
	"reg: CONV_I4(lreg)",
	"reg: CONV_U4(lreg)",
	"reg: CONV_OVF_I4(lreg)",
	"reg: CONV_OVF_I4(lreg)",
	"reg: CONV_OVF_U4(lreg)",
	"reg: CONV_OVF_I4_UN(lreg)",
	"stmt: POP(lreg)",
	"lreg: CONST_I8",
	"lreg: CONV_I8(CONST_I4)",
	"lreg: CONV_I8(reg)",
	"lreg: CONV_U8(CONST_I4)",
	"lreg: CONV_U8(reg)",
	"lreg: CONV_OVF_U8(CONST_I4)",
	"lreg: CONV_OVF_I8_UN(CONST_I4)",
	"lreg: CONV_OVF_U8(reg)",
	"lreg: CONV_OVF_I8_UN(reg)",
	"stmt: STIND_I8(addr, lreg)",
	"stmt: REMOTE_STIND_I8(reg, lreg)",
	"lreg: LDIND_I8(addr)",
	"lreg: SHR(lreg, CONST_I4)",
	"lreg: SHR_UN(lreg, CONST_I4)",
	"lreg: SHR(lreg, reg)",
	"lreg: SHR_UN(lreg, reg)",
	"lreg: SHL(lreg, CONST_I4)",
	"lreg: SHL(lreg, reg)",
	"lreg: ADD(lreg, lreg)",
	"lreg: ADD_OVF(lreg, lreg)",
	"lreg: ADD_OVF_UN(lreg, lreg)",
	"lreg: SUB(lreg, lreg)",
	"lreg: SUB_OVF(lreg, lreg)",
	"lreg: SUB_OVF_UN(lreg, lreg)",
	"lreg: AND(lreg, lreg)",
	"lreg: OR(lreg, lreg)",
	"lreg: XOR(lreg, lreg)",
	"lreg: NEG(lreg)",
	"lreg: NOT(lreg)",
	"lreg: MUL(lreg, lreg)",
	"lreg: MUL_OVF(lreg, lreg)",
	"lreg: MUL_OVF_UN(lreg, lreg)",
	"lreg: DIV(lreg, lreg)",
	"lreg: REM(lreg, lreg)",
	"lreg: DIV_UN(lreg, lreg)",
	"lreg: REM_UN(lreg, lreg)",
	"lreg: CALL_I8(this, reg)",
	"lreg: CALL_I8(this, ADDR_G)",
	"lreg: CALL_I8(this, VFUNC_ADDR)",
	"lreg: CALL_I8(this, INTF_ADDR)",
	"stmt: RET(lreg)",
	"stmt: ARG_I8(lreg)",
	"reg: CSET(COMPARE(lreg, lreg))",
	"stmt: CBRANCH(COMPARE(lreg, lreg))",
	"reg: CONV_I1(freg)",
	"reg: CONV_U1(freg)",
	"reg: CONV_I2(freg)",
	"reg: CONV_U2(freg)",
	"reg: CONV_I4(freg)",
	"reg: CONV_U4(freg)",
	"lreg: CONV_I8(freg)",
	"lreg: CONV_U8(freg)",
	"reg: CSET(COMPARE(freg, freg))",
	"freg: CONV_R8(freg)",
	"freg: CONV_R4(freg)",
	"freg: CONV_R8(LDIND_I4(ADDR_G))",
	"freg: CONV_R4(reg)",
	"freg: CONV_R8(reg)",
	"freg: CONV_R_UN(reg)",
	"freg: CONV_R_UN(lreg)",
	"freg: CONV_R4(lreg)",
	"freg: CONV_R8(lreg)",
	"freg: CONST_R4",
	"freg: CONST_R8",
	"freg: LDIND_R4(addr)",
	"freg: LDIND_R8(addr)",
	"freg: ADD(freg, freg)",
	"freg: SUB(freg, freg)",
	"freg: MUL(freg, freg)",
	"freg: DIV(freg, freg)",
	"freg: CKFINITE(freg)",
	"freg: REM(freg, freg)",
	"freg: NEG(freg)",
	"stmt: POP(freg)",
	"stmt: STIND_R4(addr, freg)",
	"stmt: STIND_R8(addr, freg)",
	"stmt: REMOTE_STIND_R4(reg, freg)",
	"stmt: REMOTE_STIND_R8(reg, freg)",
	"stmt: ARG_R4(freg)",
	"stmt: ARG_R8(freg)",
	"stmt: CBRANCH(COMPARE(freg, freg))",
	"freg: CALL_R8(this, reg)",
	"freg: CALL_R8(this, ADDR_G)",
	"freg: CALL_R8(this, INTF_ADDR)",
	"freg: CALL_R8(this, VFUNC_ADDR)",
	"stmt: RET(freg)",
	"freg: SIN(freg)",
	"freg: COS(freg)",
	"freg: SQRT(freg)",
	"reg: LDIND_OBJ(reg)",
	"stmt: STIND_OBJ(reg, reg)",
	"stmt: REMOTE_STIND_OBJ(reg, reg)",
	"stmt: ARG_OBJ(CONST_I4)",
	"stmt: ARG_OBJ(reg)",
	"stmt: RET_OBJ(reg)",
};

static const guint16 mono_burg_nts_0 [] = { 0 };
static const guint16 mono_burg_nts_1 [] = { MB_NTERM_acon, 0 };
static const guint16 mono_burg_nts_2 [] = { MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_3 [] = { MB_NTERM_base, 0 };
static const guint16 mono_burg_nts_4 [] = { MB_NTERM_index, 0 };
static const guint16 mono_burg_nts_5 [] = { MB_NTERM_index, MB_NTERM_base, 0 };
static const guint16 mono_burg_nts_6 [] = { MB_NTERM_addr, 0 };
static const guint16 mono_burg_nts_7 [] = { MB_NTERM_addr, MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_8 [] = { MB_NTERM_reg, MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_9 [] = { MB_NTERM_cflags, 0 };
static const guint16 mono_burg_nts_10 [] = { MB_NTERM_reg, MB_NTERM_reg, MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_11 [] = { MB_NTERM_this, MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_12 [] = { MB_NTERM_this, 0 };
static const guint16 mono_burg_nts_13 [] = { MB_NTERM_lreg, 0 };
static const guint16 mono_burg_nts_14 [] = { MB_NTERM_addr, MB_NTERM_lreg, 0 };
static const guint16 mono_burg_nts_15 [] = { MB_NTERM_reg, MB_NTERM_lreg, 0 };
static const guint16 mono_burg_nts_16 [] = { MB_NTERM_lreg, MB_NTERM_reg, 0 };
static const guint16 mono_burg_nts_17 [] = { MB_NTERM_lreg, MB_NTERM_lreg, 0 };
static const guint16 mono_burg_nts_18 [] = { MB_NTERM_freg, 0 };
static const guint16 mono_burg_nts_19 [] = { MB_NTERM_freg, MB_NTERM_freg, 0 };
static const guint16 mono_burg_nts_20 [] = { MB_NTERM_addr, MB_NTERM_freg, 0 };
static const guint16 mono_burg_nts_21 [] = { MB_NTERM_reg, MB_NTERM_freg, 0 };

const guint16 *const mono_burg_nts [] = {
	0,
	mono_burg_nts_0, /* acon: CONST_I4 */
	mono_burg_nts_0, /* acon: ADDR_G */
	mono_burg_nts_0, /* acon: ADD(ADDR_G, CONST_I4) */
	mono_burg_nts_1, /* base: acon */
	mono_burg_nts_2, /* base: reg */
	mono_burg_nts_2, /* base: ADD(reg, CONST_I4) */
	mono_burg_nts_0, /* base: ADDR_L */
	mono_burg_nts_2, /* index: reg */
	mono_burg_nts_2, /* index: SHL(reg, CONST_I4) */
	mono_burg_nts_2, /* index: MUL(reg, CONST_I4) */
	mono_burg_nts_3, /* addr: base */
	mono_burg_nts_4, /* addr: index */
	mono_burg_nts_5, /* addr: ADD(index, base) */
	mono_burg_nts_0, /* reg: EXCEPTION */
	mono_burg_nts_2, /* stmt: THROW(reg) */
	mono_burg_nts_0, /* stmt: RETHROW */
	mono_burg_nts_0, /* stmt: HANDLER */
	mono_burg_nts_0, /* stmt: ENDFINALLY */
	mono_burg_nts_2, /* stmt: ENDFILTER(reg) */
	mono_burg_nts_0, /* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), CONST_I4)) */
	mono_burg_nts_0, /* stmt: STIND_I4(ADDR_L, SUB(LDIND_I4(ADDR_L), CONST_I4)) */
	mono_burg_nts_2, /* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), reg)) */
	mono_burg_nts_0, /* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
	mono_burg_nts_6, /* stmt: STIND_I4(addr, CONST_I4) */
	mono_burg_nts_7, /* stmt: STIND_I4(addr, reg) */
	mono_burg_nts_8, /* stmt: REMOTE_STIND_I4(reg, reg) */
	mono_burg_nts_7, /* stmt: STIND_I1(addr, reg) */
	mono_burg_nts_8, /* stmt: REMOTE_STIND_I1(reg, reg) */
	mono_burg_nts_7, /* stmt: STIND_I2(addr, reg) */
	mono_burg_nts_8, /* stmt: REMOTE_STIND_I2(reg, reg) */
	mono_burg_nts_0, /* reg: LDIND_I4(ADDR_L) */
	mono_burg_nts_0, /* stmt: STIND_I4(ADDR_L, CONST_I4) */
	mono_burg_nts_0, /* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
	mono_burg_nts_2, /* stmt: STIND_I4(ADDR_L, reg) */
	mono_burg_nts_6, /* reg: LDIND_I4(addr) */
	mono_burg_nts_6, /* reg: LDIND_I1(addr) */
	mono_burg_nts_6, /* reg: LDIND_U1(addr) */
	mono_burg_nts_6, /* reg: LDIND_I2(addr) */
	mono_burg_nts_6, /* reg: LDIND_U2(addr) */
	mono_burg_nts_2, /* reg: REMOTE_LDFLDA(reg) */
	mono_burg_nts_0, /* reg: ADDR_L */
	mono_burg_nts_0, /* reg: ADDR_G */
	mono_burg_nts_2, /* reg: CONV_I1(reg) */
	mono_burg_nts_2, /* reg: CONV_U1(reg) */
	mono_burg_nts_2, /* reg: CONV_I2(reg) */
	mono_burg_nts_2, /* reg: CONV_U2(reg) */
	mono_burg_nts_0, /* reg: CONST_I4 */
	mono_burg_nts_2, /* reg: CONV_I4(reg) */
	mono_burg_nts_2, /* reg: CONV_U4(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I4(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_U4(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I4_UN(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I1(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I1_UN(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_U1(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_U1_UN(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I2(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_U2(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_U2_UN(reg) */
	mono_burg_nts_2, /* reg: CONV_OVF_I2_UN(reg) */
	mono_burg_nts_2, /* reg: MUL(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: MUL(reg, reg) */
	mono_burg_nts_8, /* reg: MUL_OVF(reg, reg) */
	mono_burg_nts_8, /* reg: MUL_OVF_UN(reg, reg) */
	mono_burg_nts_2, /* reg: DIV(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: DIV(reg, reg) */
	mono_burg_nts_2, /* reg: DIV_UN(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: DIV_UN(reg, reg) */
	mono_burg_nts_8, /* reg: REM(reg, reg) */
	mono_burg_nts_8, /* reg: REM_UN(reg, reg) */
	mono_burg_nts_2, /* reg: ADD(reg, CONST_I4) */
	mono_burg_nts_2, /* reg: ADD(reg, LDIND_I4(ADDR_L)) */
	mono_burg_nts_8, /* reg: ADD(reg, reg) */
	mono_burg_nts_8, /* reg: ADD_OVF(reg, reg) */
	mono_burg_nts_8, /* reg: ADD_OVF_UN(reg, reg) */
	mono_burg_nts_2, /* reg: SUB(reg, CONST_I4) */
	mono_burg_nts_2, /* reg: SUB(reg, LDIND_I4(ADDR_L)) */
	mono_burg_nts_8, /* reg: SUB(reg, reg) */
	mono_burg_nts_8, /* reg: SUB_OVF(reg, reg) */
	mono_burg_nts_8, /* reg: SUB_OVF_UN(reg, reg) */
	mono_burg_nts_9, /* reg: CSET(cflags) */
	mono_burg_nts_2, /* reg: AND(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: AND(reg, reg) */
	mono_burg_nts_2, /* reg: OR(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: OR(reg, reg) */
	mono_burg_nts_2, /* reg: XOR(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: XOR(reg, reg) */
	mono_burg_nts_2, /* reg: NEG(reg) */
	mono_burg_nts_2, /* reg: NOT(reg) */
	mono_burg_nts_2, /* reg: SHL(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: SHL(reg, reg) */
	mono_burg_nts_2, /* reg: SHR(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: SHR(reg, reg) */
	mono_burg_nts_2, /* reg: SHR_UN(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: SHR_UN(reg, reg) */
	mono_burg_nts_0, /* reg: LDSFLDA(CONST_I4) */
	mono_burg_nts_2, /* reg: LDLEN(reg) */
	mono_burg_nts_2, /* reg: LDELEMA(reg, CONST_I4) */
	mono_burg_nts_8, /* reg: LDELEMA(reg, reg) */
	mono_burg_nts_0, /* reg: LDSTR */
	mono_burg_nts_2, /* reg: NEWARR(reg) */
	mono_burg_nts_2, /* reg: NEWARR_SPEC(reg) */
	mono_burg_nts_0, /* reg: NEWOBJ */
	mono_burg_nts_0, /* reg: NEWOBJ_SPEC */
	mono_burg_nts_2, /* reg: OBJADDR(reg) */
	mono_burg_nts_0, /* reg: VTADDR(ADDR_L) */
	mono_burg_nts_2, /* stmt: FREE(reg) */
	mono_burg_nts_8, /* stmt: PROC2(reg, reg) */
	mono_burg_nts_10, /* stmt: PROC3(reg, CPSRC(reg, reg)) */
	mono_burg_nts_2, /* reg: FUNC1(reg) */
	mono_burg_nts_2, /* reg: LOCALLOC(reg) */
	mono_burg_nts_2, /* reg: UNBOX(reg) */
	mono_burg_nts_2, /* reg: CASTCLASS(reg) */
	mono_burg_nts_2, /* reg: ISINST(reg) */
	mono_burg_nts_2, /* stmt: INITOBJ(reg) */
	mono_burg_nts_8, /* stmt: CPBLK(reg, CPSRC(reg, CONST_I4)) */
	mono_burg_nts_10, /* stmt: CPBLK(reg, CPSRC(reg, reg)) */
	mono_burg_nts_8, /* stmt: INITBLK(reg, CPSRC(reg, CONST_I4)) */
	mono_burg_nts_10, /* stmt: INITBLK(reg, CPSRC(reg, reg)) */
	mono_burg_nts_0, /* stmt: NOP */
	mono_burg_nts_2, /* stmt: POP(reg) */
	mono_burg_nts_0, /* stmt: BR */
	mono_burg_nts_2, /* cflags: COMPARE(reg, LDIND_I4(ADDR_L)) */
	mono_burg_nts_0, /* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
	mono_burg_nts_2, /* cflags: COMPARE(LDIND_I4(ADDR_L), reg) */
	mono_burg_nts_0, /* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
	mono_burg_nts_2, /* cflags: COMPARE(reg, CONST_I4) */
	mono_burg_nts_8, /* cflags: COMPARE(reg, reg) */
	mono_burg_nts_9, /* stmt: CBRANCH(cflags) */
	mono_burg_nts_0, /* stmt: BRTRUE(LDIND_I4(ADDR_L)) */
	mono_burg_nts_2, /* stmt: BRTRUE(reg) */
	mono_burg_nts_0, /* stmt: BRFALSE(LDIND_I4(ADDR_L)) */
	mono_burg_nts_2, /* stmt: BRFALSE(reg) */
	mono_burg_nts_0, /* stmt: BREAK */
	mono_burg_nts_2, /* stmt: RET(reg) */
	mono_burg_nts_0, /* stmt: RET_VOID */
	mono_burg_nts_6, /* stmt: ARG_I4(LDIND_I4(addr)) */
	mono_burg_nts_0, /* stmt: ARG_I4(LDIND_I4(ADDR_L)) */
	mono_burg_nts_2, /* stmt: ARG_I4(reg) */
	mono_burg_nts_0, /* stmt: ARG_I4(ADDR_G) */
	mono_burg_nts_0, /* stmt: ARG_I4(CONST_I4) */
	mono_burg_nts_2, /* this: reg */
	mono_burg_nts_2, /* reg: CHECKTHIS(reg) */
	mono_burg_nts_2, /* stmt: CHECKTHIS(reg) */
	mono_burg_nts_0, /* stmt: JMP */
	mono_burg_nts_0, /* this: NOP */
	mono_burg_nts_11, /* reg: CALL_I4(this, reg) */
	mono_burg_nts_12, /* reg: CALL_I4(this, ADDR_G) */
	mono_burg_nts_2, /* reg: LDVIRTFTN(reg, INTF_ADDR) */
	mono_burg_nts_12, /* reg: CALL_I4(this, INTF_ADDR) */
	mono_burg_nts_2, /* reg: LDVIRTFTN(reg, VFUNC_ADDR) */
	mono_burg_nts_0, /* reg: LDFTN */
	mono_burg_nts_12, /* reg: CALL_I4(this, VFUNC_ADDR) */
	mono_burg_nts_12, /* stmt: CALL_VOID(this, ADDR_G) */
	mono_burg_nts_11, /* stmt: CALL_VOID(this, reg) */
	mono_burg_nts_12, /* stmt: CALL_VOID(this, INTF_ADDR) */
	mono_burg_nts_12, /* stmt: CALL_VOID(this, VFUNC_ADDR) */
	mono_burg_nts_2, /* stmt: SWITCH(reg) */
	mono_burg_nts_13, /* reg: CONV_I1(lreg) */
	mono_burg_nts_13, /* reg: CONV_U1(lreg) */
	mono_burg_nts_13, /* reg: CONV_I2(lreg) */
	mono_burg_nts_13, /* reg: CONV_U2(lreg) */
	mono_burg_nts_13, /* reg: CONV_I4(lreg) */
	mono_burg_nts_13, /* reg: CONV_U4(lreg) */
	mono_burg_nts_13, /* reg: CONV_OVF_I4(lreg) */
	mono_burg_nts_13, /* reg: CONV_OVF_I4(lreg) */
	mono_burg_nts_13, /* reg: CONV_OVF_U4(lreg) */
	mono_burg_nts_13, /* reg: CONV_OVF_I4_UN(lreg) */
	mono_burg_nts_13, /* stmt: POP(lreg) */
	mono_burg_nts_0, /* lreg: CONST_I8 */
	mono_burg_nts_0, /* lreg: CONV_I8(CONST_I4) */
	mono_burg_nts_2, /* lreg: CONV_I8(reg) */
	mono_burg_nts_0, /* lreg: CONV_U8(CONST_I4) */
	mono_burg_nts_2, /* lreg: CONV_U8(reg) */
	mono_burg_nts_0, /* lreg: CONV_OVF_U8(CONST_I4) */
	mono_burg_nts_0, /* lreg: CONV_OVF_I8_UN(CONST_I4) */
	mono_burg_nts_2, /* lreg: CONV_OVF_U8(reg) */
	mono_burg_nts_2, /* lreg: CONV_OVF_I8_UN(reg) */
	mono_burg_nts_14, /* stmt: STIND_I8(addr, lreg) */
	mono_burg_nts_15, /* stmt: REMOTE_STIND_I8(reg, lreg) */
	mono_burg_nts_6, /* lreg: LDIND_I8(addr) */
	mono_burg_nts_13, /* lreg: SHR(lreg, CONST_I4) */
	mono_burg_nts_13, /* lreg: SHR_UN(lreg, CONST_I4) */
	mono_burg_nts_16, /* lreg: SHR(lreg, reg) */
	mono_burg_nts_16, /* lreg: SHR_UN(lreg, reg) */
	mono_burg_nts_13, /* lreg: SHL(lreg, CONST_I4) */
	mono_burg_nts_16, /* lreg: SHL(lreg, reg) */
	mono_burg_nts_17, /* lreg: ADD(lreg, lreg) */
	mono_burg_nts_17, /* lreg: ADD_OVF(lreg, lreg) */
	mono_burg_nts_17, /* lreg: ADD_OVF_UN(lreg, lreg) */
	mono_burg_nts_17, /* lreg: SUB(lreg, lreg) */
	mono_burg_nts_17, /* lreg: SUB_OVF(lreg, lreg) */
	mono_burg_nts_17, /* lreg: SUB_OVF_UN(lreg, lreg) */
	mono_burg_nts_17, /* lreg: AND(lreg, lreg) */
	mono_burg_nts_17, /* lreg: OR(lreg, lreg) */
	mono_burg_nts_17, /* lreg: XOR(lreg, lreg) */
	mono_burg_nts_13, /* lreg: NEG(lreg) */
	mono_burg_nts_13, /* lreg: NOT(lreg) */
	mono_burg_nts_17, /* lreg: MUL(lreg, lreg) */
	mono_burg_nts_17, /* lreg: MUL_OVF(lreg, lreg) */
	mono_burg_nts_17, /* lreg: MUL_OVF_UN(lreg, lreg) */
	mono_burg_nts_17, /* lreg: DIV(lreg, lreg) */
	mono_burg_nts_17, /* lreg: REM(lreg, lreg) */
	mono_burg_nts_17, /* lreg: DIV_UN(lreg, lreg) */
	mono_burg_nts_17, /* lreg: REM_UN(lreg, lreg) */
	mono_burg_nts_11, /* lreg: CALL_I8(this, reg) */
	mono_burg_nts_12, /* lreg: CALL_I8(this, ADDR_G) */
	mono_burg_nts_12, /* lreg: CALL_I8(this, VFUNC_ADDR) */
	mono_burg_nts_12, /* lreg: CALL_I8(this, INTF_ADDR) */
	mono_burg_nts_13, /* stmt: RET(lreg) */
	mono_burg_nts_13, /* stmt: ARG_I8(lreg) */
	mono_burg_nts_17, /* reg: CSET(COMPARE(lreg, lreg)) */
	mono_burg_nts_17, /* stmt: CBRANCH(COMPARE(lreg, lreg)) */
	mono_burg_nts_18, /* reg: CONV_I1(freg) */
	mono_burg_nts_18, /* reg: CONV_U1(freg) */
	mono_burg_nts_18, /* reg: CONV_I2(freg) */
	mono_burg_nts_18, /* reg: CONV_U2(freg) */
	mono_burg_nts_18, /* reg: CONV_I4(freg) */
	mono_burg_nts_18, /* reg: CONV_U4(freg) */
	mono_burg_nts_18, /* lreg: CONV_I8(freg) */
	mono_burg_nts_18, /* lreg: CONV_U8(freg) */
	mono_burg_nts_19, /* reg: CSET(COMPARE(freg, freg)) */
	mono_burg_nts_18, /* freg: CONV_R8(freg) */
	mono_burg_nts_18, /* freg: CONV_R4(freg) */
	mono_burg_nts_0, /* freg: CONV_R8(LDIND_I4(ADDR_G)) */
	mono_burg_nts_2, /* freg: CONV_R4(reg) */
	mono_burg_nts_2, /* freg: CONV_R8(reg) */
	mono_burg_nts_2, /* freg: CONV_R_UN(reg) */
	mono_burg_nts_13, /* freg: CONV_R_UN(lreg) */
	mono_burg_nts_13, /* freg: CONV_R4(lreg) */
	mono_burg_nts_13, /* freg: CONV_R8(lreg) */
	mono_burg_nts_0, /* freg: CONST_R4 */
	mono_burg_nts_0, /* freg: CONST_R8 */
	mono_burg_nts_6, /* freg: LDIND_R4(addr) */
	mono_burg_nts_6, /* freg: LDIND_R8(addr) */
	mono_burg_nts_19, /* freg: ADD(freg, freg) */
	mono_burg_nts_19, /* freg: SUB(freg, freg) */
	mono_burg_nts_19, /* freg: MUL(freg, freg) */
	mono_burg_nts_19, /* freg: DIV(freg, freg) */
	mono_burg_nts_18, /* freg: CKFINITE(freg) */
	mono_burg_nts_19, /* freg: REM(freg, freg) */
	mono_burg_nts_18, /* freg: NEG(freg) */
	mono_burg_nts_18, /* stmt: POP(freg) */
	mono_burg_nts_20, /* stmt: STIND_R4(addr, freg) */
	mono_burg_nts_20, /* stmt: STIND_R8(addr, freg) */
	mono_burg_nts_21, /* stmt: REMOTE_STIND_R4(reg, freg) */
	mono_burg_nts_21, /* stmt: REMOTE_STIND_R8(reg, freg) */
	mono_burg_nts_18, /* stmt: ARG_R4(freg) */
	mono_burg_nts_18, /* stmt: ARG_R8(freg) */
	mono_burg_nts_19, /* stmt: CBRANCH(COMPARE(freg, freg)) */
	mono_burg_nts_11, /* freg: CALL_R8(this, reg) */
	mono_burg_nts_12, /* freg: CALL_R8(this, ADDR_G) */
	mono_burg_nts_12, /* freg: CALL_R8(this, INTF_ADDR) */
	mono_burg_nts_12, /* freg: CALL_R8(this, VFUNC_ADDR) */
	mono_burg_nts_18, /* stmt: RET(freg) */
	mono_burg_nts_18, /* freg: SIN(freg) */
	mono_burg_nts_18, /* freg: COS(freg) */
	mono_burg_nts_18, /* freg: SQRT(freg) */
	mono_burg_nts_2, /* reg: LDIND_OBJ(reg) */
	mono_burg_nts_8, /* stmt: STIND_OBJ(reg, reg) */
	mono_burg_nts_8, /* stmt: REMOTE_STIND_OBJ(reg, reg) */
	mono_burg_nts_0, /* stmt: ARG_OBJ(CONST_I4) */
	mono_burg_nts_2, /* stmt: ARG_OBJ(reg) */
	mono_burg_nts_2, /* stmt: RET_OBJ(reg) */
};

inline static guint16
/* base: ADDR_L */
mono_burg_cost_7 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (VARINFO (data, tree->data.i).reg < 0);
	return 0;

}

inline static guint16
/* index: SHL(reg, CONST_I4) */
mono_burg_cost_9 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (tree->right->data.i == 0 ||
		tree->right->data.i == 1 ||
		tree->right->data.i == 2 ||
		tree->right->data.i == 3);

	return 0;

}

inline static guint16
/* index: MUL(reg, CONST_I4) */
mono_burg_cost_10 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (tree->right->data.i == 1 ||
		tree->right->data.i == 2 ||
		tree->right->data.i == 4 ||
		tree->right->data.i == 8);

	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), CONST_I4)) */
mono_burg_cost_20 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (tree->right->left->left->data.i == tree->left->data.i);
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, SUB(LDIND_I4(ADDR_L), CONST_I4)) */
mono_burg_cost_21 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (tree->right->left->left->data.i == tree->left->data.i);
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), reg)) */
mono_burg_cost_22 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (tree->right->left->left->data.i == tree->left->data.i);
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
mono_burg_cost_23 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (VARINFO (data, tree->left->data.i).reg >= 0 ||
		VARINFO (data, tree->right->left->data.i).reg >= 0);
	return 0;

}

inline static guint16
/* reg: LDIND_I4(ADDR_L) */
mono_burg_cost_31 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, CONST_I4) */
mono_burg_cost_32 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
mono_burg_cost_33 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->data.i).reg >= 0));
	MBCOND ((VARINFO (data, tree->right->left->data.i).reg < 0));
	return 0;

}

inline static guint16
/* stmt: STIND_I4(ADDR_L, reg) */
mono_burg_cost_34 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* reg: ADDR_L */
mono_burg_cost_41 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (VARINFO (data, tree->data.i).reg < 0);
	return 5;

}

inline static guint16
/* reg: DIV(reg, CONST_I4) */
mono_burg_cost_65 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	unsigned int i, j, k, v;

	if (v < 0) 
		return MBMAXCOST;

	v = tree->right->data.i;
	for (i = 0, j = 1, k = 0xfffffffe; i < 32; i++, j = j << 1, k = k << 1) {
		if (v & j)
			break;
	}
	
	if (i == 32 || v & k) 
		return MBMAXCOST;

	return 0;


}

inline static guint16
/* reg: ADD(reg, LDIND_I4(ADDR_L)) */
mono_burg_cost_72 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->right->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* reg: SUB(reg, LDIND_I4(ADDR_L)) */
mono_burg_cost_77 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->right->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* stmt: CPBLK(reg, CPSRC(reg, CONST_I4)) */
mono_burg_cost_116 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (mono_inline_memcpy);
	return 0;

}

inline static guint16
/* stmt: INITBLK(reg, CPSRC(reg, CONST_I4)) */
mono_burg_cost_118 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND (mono_inline_memcpy);
	return 0;

}

inline static guint16
/* cflags: COMPARE(reg, LDIND_I4(ADDR_L)) */
mono_burg_cost_123 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->right->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
mono_burg_cost_124 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* cflags: COMPARE(LDIND_I4(ADDR_L), reg) */
mono_burg_cost_125 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->left->data.i).reg >= 0));
	return 0;

}

inline static guint16
/* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
mono_burg_cost_126 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->left->data.i).reg < 0));
	return 0;

}

inline static guint16
/* stmt: ARG_I4(LDIND_I4(ADDR_L)) */
mono_burg_cost_138 (MBTREE_TYPE *tree, MBCOST_DATA *data)
{

	MBCOND ((VARINFO (data, tree->left->left->data.i).reg >= 0));
	return 0;

}

static void /* acon: CONST_I4 */
mono_burg_emit_0 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = tree->data.i;
	tree->data.ainfo.amode = AMImmediate;

}

static void /* acon: ADDR_G */
mono_burg_emit_1 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = tree->data.i;
	tree->data.ainfo.amode = AMImmediate;

}

static void /* acon: ADD(ADDR_G, CONST_I4) */
mono_burg_emit_2 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = (unsigned)tree->left->data.p + tree->right->data.i;
	tree->data.ainfo.amode = AMImmediate;

}

static void /* base: reg */
mono_burg_emit_4 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = 0;
	tree->data.ainfo.basereg = tree->reg1;
	tree->data.ainfo.amode = AMBase;

}

static void /* base: ADD(reg, CONST_I4) */
mono_burg_emit_5 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = tree->right->data.i;
	tree->data.ainfo.basereg = tree->left->reg1;
	tree->data.ainfo.amode = AMBase;

}

static void /* base: ADDR_L */
mono_burg_emit_6 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = VARINFO (s, tree->data.i).offset;
	tree->data.ainfo.basereg = X86_EBP;
	tree->data.ainfo.amode = AMBase;

}

static void /* index: reg */
mono_burg_emit_7 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = 0;
	tree->data.ainfo.indexreg = tree->reg1;
	tree->data.ainfo.shift = 0;
	tree->data.ainfo.amode = AMIndex;

}

static void /* index: SHL(reg, CONST_I4) */
mono_burg_emit_8 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = 0;
	tree->data.ainfo.amode = AMIndex;
	tree->data.ainfo.indexreg = tree->left->reg1;
	tree->data.ainfo.shift = tree->right->data.i;

}

static void /* index: MUL(reg, CONST_I4) */
mono_burg_emit_9 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	static int fast_log2 [] = { 1, 0, 1, -1, 2, -1, -1, -1, 3 };
  
	tree->data.ainfo.offset = 0;
	tree->data.ainfo.amode = AMIndex;
	tree->data.ainfo.indexreg = tree->left->reg1;
	tree->data.ainfo.shift = fast_log2 [tree->right->data.i];

}

static void /* addr: ADD(index, base) */
mono_burg_emit_12 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	tree->data.ainfo.offset = tree->right->data.ainfo.offset;
	tree->data.ainfo.basereg = tree->right->data.ainfo.basereg;
	tree->data.ainfo.amode = tree->left->data.ainfo.amode | 
		tree->right->data.ainfo.amode;
	tree->data.ainfo.shift = tree->left->data.ainfo.shift;
	tree->data.ainfo.indexreg = tree->left->data.ainfo.indexreg;

}

static void /* reg: EXCEPTION */
mono_burg_emit_13 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = VARINFO (s, tree->data.i).offset;

	if (tree->reg1 != X86_ECX)
		x86_mov_reg_reg (s->code, tree->reg1, X86_ECX, 4);
	
	/* store it so that we can RETHROW it later */
	x86_mov_membase_reg (s->code, X86_EBP, offset, tree->reg1, 4);

}

static void /* stmt: THROW(reg) */
mono_burg_emit_14 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	gpointer target;

	x86_push_reg (s->code, tree->left->reg1);
	target = arch_get_throw_exception ();
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, target);
	x86_call_code (s->code, target);

}

static void /* stmt: RETHROW */
mono_burg_emit_15 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = VARINFO (s, tree->data.i).offset;
	gpointer target;

	x86_push_membase (s->code, X86_EBP, offset);

	target = arch_get_throw_exception ();
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, target);
	x86_call_code (s->code, target);

}

static void /* stmt: HANDLER */
mono_burg_emit_16 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* save ESP (used by ENDFINALLY) */
	x86_mov_membase_reg (s->code, X86_EBP, mono_exc_esp_offset, X86_ESP, 4);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_call_imm (s->code, 0); 

}

static void /* stmt: ENDFINALLY */
mono_burg_emit_17 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* restore ESP - which can be modified when we allocate value types
	 * in the finally handler */
	x86_mov_reg_membase (s->code, X86_ESP, X86_EBP, mono_exc_esp_offset, 4);
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
	x86_ret (s->code);

}

static void /* stmt: ENDFILTER(reg) */
mono_burg_emit_18 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* restore ESP - which can be modified when we allocate value types
	 * in the filter */
	x86_mov_reg_membase (s->code, X86_ESP, X86_EBP, mono_exc_esp_offset, 4);
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);	     
	x86_ret (s->code);

}

static void /* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), CONST_I4)) */
mono_burg_emit_19 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int vn = tree->left->data.i;
	int treg = VARINFO (s, vn).reg;
	int offset = VARINFO (s, vn).offset;
	int data = tree->right->right->data.i;

	if (data == 1) {
		if (treg >= 0)
			x86_inc_reg (s->code, treg);
		else 
			x86_inc_membase (s->code, X86_EBP, offset);
	} else {
		if (treg >= 0)
			x86_alu_reg_imm (s->code, X86_ADD, treg, data);
		else
			x86_alu_membase_imm (s->code, X86_ADD, X86_EBP, offset, data);
	}

}

static void /* stmt: STIND_I4(ADDR_L, SUB(LDIND_I4(ADDR_L), CONST_I4)) */
mono_burg_emit_20 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int vn = tree->left->data.i;
	int treg = VARINFO (s, vn).reg;
	int offset = VARINFO (s, vn).offset;
	int data = tree->right->right->data.i;

	if (data == 1) {
		if (treg >= 0)
			x86_dec_reg (s->code, treg);
		else 
			x86_dec_membase (s->code, X86_EBP, offset);
	} else {
		if (treg >= 0)
			x86_alu_reg_imm (s->code, X86_SUB, treg, data);
		else
			x86_alu_membase_imm (s->code, X86_SUB, X86_EBP, offset, data);
	}

}

static void /* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), reg)) */
mono_burg_emit_21 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int vn = tree->left->data.i;
	int treg = VARINFO (s, vn).reg;
	int sreg = tree->right->right->reg1;
	int offset = VARINFO (s, vn).offset;

	if (treg >= 0)
		x86_alu_reg_reg (s->code, X86_ADD, treg, sreg);
	else
		x86_alu_membase_reg (s->code, X86_ADD, X86_EBP, offset, sreg);


}

static void /* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
mono_burg_emit_22 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg1 = VARINFO (s, tree->left->data.i).reg;
	int treg2 = VARINFO (s, tree->right->left->data.i).reg;
	int offset1 = VARINFO (s, tree->left->data.i).offset;
	int offset2 = VARINFO (s, tree->right->left->data.i).offset;

	//{static int cx= 0; printf ("CX %5d\n", cx++);}

	if (treg1 >= 0 && treg2 >= 0) {
		x86_mov_reg_reg (s->code, treg1, treg2, 4);
		return;
	}
	if (treg1 >= 0 && treg2 < 0) {
		x86_mov_reg_membase (s->code, treg1, X86_EBP, offset2, 4);
		return;
	}
	if (treg1 < 0 && treg2 >= 0) {
		x86_mov_membase_reg (s->code, X86_EBP, offset1, treg2, 4);
		return;
	}

	g_assert_not_reached ();


}

static void /* stmt: STIND_I4(addr, CONST_I4) */
mono_burg_emit_23 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_mem_imm (s->code, tree->left->data.ainfo.offset, tree->right->data.i, 4);
		break;
		
	case AMBase:
		x86_mov_membase_imm (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, tree->right->data.i, 4);
		break;		
	case AMIndex:
		x86_mov_memindex_imm (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->data.i, 4);
		break;		
	case AMBaseIndex:
		x86_mov_memindex_imm (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->data.i, 4);
		break;		
	}

}

static void /* stmt: STIND_I4(addr, reg) */
mono_burg_emit_24 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_mem_reg (s->code, tree->left->data.ainfo.offset, tree->right->reg1, 4);
		break;
		
	case AMBase:
		x86_mov_membase_reg (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, tree->right->reg1, 4);
		break;		
	case AMIndex:
		x86_mov_memindex_reg (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 4);
		break;		
	case AMBaseIndex:
		x86_mov_memindex_reg (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 4);
		break;		
	}

}

static void /* stmt: REMOTE_STIND_I4(reg, reg) */
mono_burg_emit_25 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	int offset;

	if (lreg == treg)
		treg = X86_EDX;

	if (rreg == treg)
		treg = X86_ECX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_push_reg (s->code, rreg);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_mov_membase_reg (s->code, lreg, offset, rreg, 4);

	x86_patch (br [1], s->code);

}

static void /* stmt: STIND_I1(addr, reg) */
mono_burg_emit_26 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	PRINT_REG ("STIND_I1", tree->right->reg1);

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_mem_reg (s->code, tree->left->data.ainfo.offset, tree->right->reg1, 1);
		break;
		
	case AMBase:
		x86_mov_membase_reg (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, tree->right->reg1, 1);
		break;		
	case AMIndex:
		x86_mov_memindex_reg (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 1);
		break;		
	case AMBaseIndex:
		x86_mov_memindex_reg (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 1);
		break;		
	}

}

static void /* stmt: REMOTE_STIND_I1(reg, reg) */
mono_burg_emit_27 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	int offset;

	if (lreg == treg)
		treg = X86_EDX;

	if (rreg == treg)
		treg = X86_ECX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_push_reg (s->code, rreg);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_mov_membase_reg (s->code, lreg, offset, rreg, 1);

	x86_patch (br [1], s->code);

}

static void /* stmt: STIND_I2(addr, reg) */
mono_burg_emit_28 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	PRINT_REG ("STIND_I2", tree->right->reg1);

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_mem_reg (s->code, tree->left->data.ainfo.offset, tree->right->reg1, 2);
		break;
		
	case AMBase:
		x86_mov_membase_reg (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, tree->right->reg1, 2);
		break;		
	case AMIndex:
		x86_mov_memindex_reg (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 2);
		break;		
	case AMBaseIndex:
		x86_mov_memindex_reg (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 2);
		break;		
	}

}

static void /* stmt: REMOTE_STIND_I2(reg, reg) */
mono_burg_emit_29 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	int offset;

	if (lreg == treg)
		treg = X86_EDX;

	if (rreg == treg)
		treg = X86_ECX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_push_reg (s->code, rreg);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_mov_membase_reg (s->code, lreg, offset, rreg, 2);

	x86_patch (br [1], s->code);

}

static void /* reg: LDIND_I4(ADDR_L) */
mono_burg_emit_30 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->data.i).reg;

	if (treg != tree->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, treg, 4);


}

static void /* stmt: STIND_I4(ADDR_L, CONST_I4) */
mono_burg_emit_31 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->data.i).reg;

	x86_mov_reg_imm (s->code, treg, tree->right->data.i);


}

static void /* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
mono_burg_emit_32 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->data.i).reg;
	int offset = VARINFO (s, tree->right->left->data.i).offset;
	
	x86_mov_reg_membase (s->code, treg, X86_EBP, offset, 4);

}

static void /* stmt: STIND_I4(ADDR_L, reg) */
mono_burg_emit_33 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->data.i).reg;

	if (treg != tree->right->reg1)
		x86_mov_reg_reg (s->code, treg, tree->right->reg1, 4);


}

static void /* reg: LDIND_I4(addr) */
mono_burg_emit_34 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_reg_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, 4);
		break;

	case AMBase:
		x86_mov_reg_membase (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, 4);
		break;		
	case AMIndex:
		x86_mov_reg_memindex (s->code, tree->reg1, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift, 4);
		break;		
	case AMBaseIndex:
		x86_mov_reg_memindex (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				      tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				      tree->left->data.ainfo.shift, 4);
		break;		
	}


	PRINT_REG ("LDIND_I4", tree->reg1);

}

static void /* reg: LDIND_I1(addr) */
mono_burg_emit_35 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_widen_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, TRUE, FALSE);
		break;

	case AMBase:
		x86_widen_membase (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				   tree->left->data.ainfo.offset, TRUE, FALSE);
		break;		
	case AMIndex:
		x86_widen_memindex (s->code, tree->reg1, X86_NOBASEREG, tree->left->data.ainfo.offset,
				    tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift, TRUE, FALSE);
		break;		
	case AMBaseIndex:
		x86_widen_memindex (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				    tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				    tree->left->data.ainfo.shift, TRUE, FALSE);
		break;		
	}

	PRINT_REG ("LDIND_I1", tree->reg1);

}

static void /* reg: LDIND_U1(addr) */
mono_burg_emit_36 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_widen_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, FALSE, FALSE);
		break;

	case AMBase:
		x86_widen_membase (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				   tree->left->data.ainfo.offset, FALSE, FALSE);
		break;		
	case AMIndex:
		x86_widen_memindex (s->code, tree->reg1, X86_NOBASEREG, tree->left->data.ainfo.offset,
				    tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift, FALSE, FALSE);
		break;		
	case AMBaseIndex:
		x86_widen_memindex (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				    tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				    tree->left->data.ainfo.shift, FALSE, FALSE);
		break;		
	}

	PRINT_REG ("LDIND_U1", tree->reg1);

}

static void /* reg: LDIND_I2(addr) */
mono_burg_emit_37 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_widen_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, TRUE, TRUE);
		break;

	case AMBase:
		x86_widen_membase (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				   tree->left->data.ainfo.offset, TRUE, TRUE);
		break;		
	case AMIndex:
		x86_widen_memindex (s->code, tree->reg1, X86_NOBASEREG, tree->left->data.ainfo.offset,
				    tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift, TRUE, TRUE);
		break;		
	case AMBaseIndex:
		x86_widen_memindex (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				    tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				    tree->left->data.ainfo.shift, TRUE, TRUE);
		break;		
	}

	PRINT_REG ("LDIND_U2", tree->reg1);

}

static void /* reg: LDIND_U2(addr) */
mono_burg_emit_38 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_widen_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, FALSE, TRUE);
		break;

	case AMBase:
		x86_widen_membase (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				   tree->left->data.ainfo.offset, FALSE, TRUE);
		break;		
	case AMIndex:
		x86_widen_memindex (s->code, tree->reg1, X86_NOBASEREG, tree->left->data.ainfo.offset,
				    tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift, FALSE, TRUE);
		break;		
	case AMBaseIndex:
		x86_widen_memindex (s->code, tree->reg1, tree->left->data.ainfo.basereg, 
				    tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				    tree->left->data.ainfo.shift, FALSE, TRUE);
		break;		
	}

	PRINT_REG ("LDIND_U2", tree->reg1);

}

static void /* reg: REMOTE_LDFLDA(reg) */
mono_burg_emit_39 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;

	if (lreg == X86_EAX)
		treg = X86_EDX;

	if (tree->reg1 != treg)
		x86_push_reg (s->code, treg);

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */
	if (treg != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	if (treg != X86_EDX)
		x86_push_reg (s->code, X86_EDX);
	x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_load_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (treg != X86_EAX)
		x86_mov_reg_reg (s->code, treg, X86_EAX, 4);

	x86_pop_reg (s->code, X86_ECX);
	if (treg != X86_EDX)
		x86_pop_reg (s->code, X86_EDX);
	if (treg != X86_EAX)
		x86_pop_reg (s->code, X86_EAX);

	x86_mov_reg_reg (s->code, tree->reg1, treg, 4);

	br [1] = s->code; x86_jump8 (s->code, 0);
	
	x86_patch (br [0], s->code);
	if (tree->data.fi.klass->valuetype)
		x86_lea_membase (s->code, tree->reg1, lreg, 
				 tree->data.fi.field->offset - sizeof (MonoObject));
	else 
		x86_lea_membase (s->code, tree->reg1, lreg, tree->data.fi.field->offset);

	x86_patch (br [1], s->code);

	if (tree->reg1 != treg)
		x86_pop_reg (s->code, treg);

}

static void /* reg: ADDR_L */
mono_burg_emit_40 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = VARINFO (s, tree->data.i).offset;  

	x86_lea_membase (s->code, tree->reg1, X86_EBP, offset);
	
	PRINT_REG ("ADDR_L",  tree->reg1);

}

static void /* reg: ADDR_G */
mono_burg_emit_41 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, tree->data.p);

}

static void /* reg: CONV_I1(reg) */
mono_burg_emit_42 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, FALSE);

}

static void /* reg: CONV_U1(reg) */
mono_burg_emit_43 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, FALSE);

}

static void /* reg: CONV_I2(reg) */
mono_burg_emit_44 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, TRUE);

}

static void /* reg: CONV_U2(reg) */
mono_burg_emit_45 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, TRUE);

}

static void /* reg: CONST_I4 */
mono_burg_emit_46 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, tree->data.i);

}

static void /* reg: CONV_I4(reg) */
mono_burg_emit_47 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	PRINT_REG ("CONV_I4", tree->left->reg1);

}

static void /* reg: CONV_U4(reg) */
mono_burg_emit_48 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	PRINT_REG ("CONV_U4", tree->left->reg1);

}

static void /* reg: CONV_OVF_I4(reg) */
mono_burg_emit_49 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	PRINT_REG ("CONV_OVF_I4", tree->left->reg1);

}

static void /* reg: CONV_OVF_U4(reg) */
mono_burg_emit_50 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_I4_UN below, they are the same on 32-bit machines */
	x86_test_reg_imm (s->code, tree->left->reg1, 0x8000000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_OVF_I4_UN(reg) */
mono_burg_emit_51 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U4 above, they are the same on 32-bit machines */
	x86_test_reg_imm (s->code, tree->left->reg1, 0x8000000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_OVF_I1(reg) */
mono_burg_emit_52 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* probe value to be within -128 to 127 */
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, 127);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_LE, TRUE, "OverflowException");	
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, -128);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_GT, TRUE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, FALSE);

}

static void /* reg: CONV_OVF_I1_UN(reg) */
mono_burg_emit_53 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* probe values between 0 to 128 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffffff80);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, FALSE);

}

static void /* reg: CONV_OVF_U1(reg) */
mono_burg_emit_54 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U1_UN routine below, they are the same on 32-bit machines */
	/* probe value to be within 0 to 255 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffffff00);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, FALSE);

}

static void /* reg: CONV_OVF_U1_UN(reg) */
mono_burg_emit_55 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U1 routine above, they are the same on 32-bit machines */
	/* probe value to be within 0 to 255 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffffff00);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, FALSE);

}

static void /* reg: CONV_OVF_I2(reg) */
mono_burg_emit_56 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{
	
	/* Probe value to be within -32768 and 32767 */
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, 32767);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_LE, TRUE, "OverflowException");	
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, -32768);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_GE, TRUE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, TRUE);

}

static void /* reg: CONV_OVF_U2(reg) */
mono_burg_emit_57 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U2_UN below, they are the same on 32-bit machines */
	/* Probe value to be within 0 and 65535 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffff0000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, TRUE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, TRUE);

}

static void /* reg: CONV_OVF_U2_UN(reg) */
mono_burg_emit_58 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U2 above, they are the same on 32-bit machines */
	/* Probe value to be within 0 and 65535 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffff0000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, TRUE);

}

static void /* reg: CONV_OVF_I2_UN(reg) */
mono_burg_emit_59 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Convert uint value into short, value within 0 and 32767 */
	x86_test_reg_imm (s->code, tree->left->reg1, 0xffff8000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "OverflowException");	
	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, TRUE);

}

static void /* reg: MUL(reg, CONST_I4) */
mono_burg_emit_60 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	unsigned int i, j, k, v;

	v = tree->right->data.i;
	for (i = 0, j = 1, k = 0xfffffffe; i < 32; i++, j = j << 1, k = k << 1) {
		if (v & j)
			break;
	}

	if (v < 0 || i == 32 || v & k) {
		switch (v) {
		case 3:
			/* LEA r1, [r2 + r2*2] */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 1);
			break;
		case 5:
			/* LEA r1, [r2 + r2*4] */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 2);
			break;
		case 6:
			/* LEA r1, [r2 + r2*2] */
			/* ADD r1, r1          */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 1);
			x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
			break;
		case 9:
			/* LEA r1, [r2 + r2*8] */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 3);
			break;
		case 10:
			/* LEA r1, [r2 + r2*4] */
			/* ADD r1, r1          */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 2);
			x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
			break;
		case 12:
			/* LEA r1, [r2 + r2*2] */
			/* SHL r1, 2           */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 1);
			x86_shift_reg_imm (s->code, X86_SHL, tree->reg1, 2);
			break;
		case 25:
			/* LEA r1, [r2 + r2*4] */
			/* LEA r1, [r1 + r1*4] */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 2);
			x86_lea_memindex (s->code, tree->reg1, tree->reg1, 0, tree->reg1, 2);
			break;
		case 100:
			/* LEA r1, [r2 + r2*4] */
			/* SHL r1, 2           */
			/* LEA r1, [r1 + r1*4] */
			x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 0, tree->left->reg1, 2);
			x86_shift_reg_imm (s->code, X86_SHL, tree->reg1, 2);
			x86_lea_memindex (s->code, tree->reg1, tree->reg1, 0, tree->reg1, 2);
			break;
		default:
			x86_imul_reg_reg_imm (s->code, tree->reg1, tree->left->reg1, tree->right->data.i);
			break;
		}
	} else {
		x86_shift_reg_imm (s->code, X86_SHL, tree->left->reg1, i);
		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	}

}

static void /* reg: MUL(reg, reg) */
mono_burg_emit_61 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_imul_reg_reg (s->code, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: MUL_OVF(reg, reg) */
mono_burg_emit_62 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_imul_reg_reg (s->code, tree->left->reg1, tree->right->reg1);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");	

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: MUL_OVF_UN(reg, reg) */
mono_burg_emit_63 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->right->reg1 != X86_EAX);
	
	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	x86_mul_reg (s->code, tree->right->reg1, FALSE);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* reg: DIV(reg, CONST_I4) */
mono_burg_emit_64 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	unsigned int i, j, k, v;

	v = tree->right->data.i;
	for (i = 0, j = 1, k = 0xfffffffe; i < 32; i++, j = j << 1, k = k << 1) {
		if (v & j)
			break;
	}

	x86_shift_reg_imm (s->code, X86_SAR, tree->left->reg1, i);
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);


}

static void /* reg: DIV(reg, reg) */
mono_burg_emit_65 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->right->reg1 != X86_EAX);

	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	x86_cdq (s->code);
	x86_div_reg (s->code, tree->right->reg1, TRUE);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* reg: DIV_UN(reg, CONST_I4) */
mono_burg_emit_66 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	unsigned int i, j, k, v;
	double f, r;

	v = tree->right->data.i;
	for (i = 0, j = 1, k = 0xfffffffe; i < 32; i++, j = j << 1, k = k << 1) {
		if (v & j)
			break;
	}

	if (i == 32 || v & k)  {
		for (i = 32, j = 0x80000000; --i >= 0; j >>= 1) {
			if (v & j) break;
		}

		/* k = 32 + number of significant bits in v - 1 */
		k = 32 + i;

		f = 1.0f / v;
		for (i = 0; i < k; i++) f *= 2.0f;


		r = f - floor(f);

		if (r == 0) {
			x86_shift_reg_imm (s->code, X86_SHR, tree->left->reg1, k - 32);
			if (tree->reg1 != tree->left->reg1)
				x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
		} else if (r < 0.5f) {
			if (tree->left->reg1 != X86_EAX)
				x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);
			x86_mov_reg_imm (s->code, X86_EDX, (guint32) floor(f));
			/* x86_inc_reg (s->code, X86_EAX); */
			/* INC is faster but we have to check for overflow. */
			x86_alu_reg_imm (s->code, X86_ADD, X86_EAX, 1);
			x86_branch8(s->code, X86_CC_C, 2, FALSE);
			x86_mul_reg (s->code, X86_EDX, FALSE);
			x86_shift_reg_imm (s->code, X86_SHR, X86_EDX, k - 32);
			if (tree->reg1 != X86_EDX)
				x86_mov_reg_reg (s->code, tree->reg1, X86_EDX, 4);
		} else {
			if (tree->left->reg1 != X86_EAX)
				x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);
			x86_mov_reg_imm (s->code, X86_EDX, (guint32) ceil(f));
			x86_mul_reg (s->code, X86_EDX, FALSE);
			x86_shift_reg_imm (s->code, X86_SHR, X86_EDX, k - 32);
			if (tree->reg1 != X86_EDX)
				x86_mov_reg_reg (s->code, tree->reg1, X86_EDX, 4);
		}
	} else {
		x86_shift_reg_imm (s->code, X86_SHR, tree->left->reg1, i);
		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	}


}

static void /* reg: DIV_UN(reg, reg) */
mono_burg_emit_67 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->right->reg1 != X86_EAX);

	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	x86_mov_reg_imm (s->code, X86_EDX, 0);
	x86_div_reg (s->code, tree->right->reg1, FALSE);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* reg: REM(reg, reg) */
mono_burg_emit_68 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->right->reg1 != X86_EAX);
	mono_assert (tree->right->reg1 != X86_EDX);

	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	/* sign extend to 64bit in EAX/EDX */
	x86_cdq (s->code);
	x86_div_reg (s->code, tree->right->reg1, TRUE);
	x86_mov_reg_reg (s->code, X86_EAX, X86_EDX, 4);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* reg: REM_UN(reg, reg) */
mono_burg_emit_69 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->right->reg1 != X86_EAX);
	mono_assert (tree->right->reg1 != X86_EDX);

	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	/* zero extend to 64bit in EAX/EDX */
	x86_mov_reg_imm (s->code, X86_EDX, 0); 
	x86_div_reg (s->code, tree->right->reg1, FALSE);
	x86_mov_reg_reg (s->code, X86_EAX, X86_EDX, 4);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* reg: ADD(reg, CONST_I4) */
mono_burg_emit_70 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->data.i == 1)
		x86_inc_reg (s->code, tree->left->reg1);
	else 
		x86_alu_reg_imm (s->code, X86_ADD, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);


}

static void /* reg: ADD(reg, LDIND_I4(ADDR_L)) */
mono_burg_emit_71 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->right->left->data.i).reg;

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, treg);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: ADD(reg, reg) */
mono_burg_emit_72 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: ADD_OVF(reg, reg) */
mono_burg_emit_73 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");	

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: ADD_OVF_UN(reg, reg) */
mono_burg_emit_74 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NC, FALSE, "OverflowException");	

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SUB(reg, CONST_I4) */
mono_burg_emit_75 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->data.i == 1)
		x86_dec_reg (s->code, tree->left->reg1);
	else
		x86_alu_reg_imm (s->code, X86_SUB, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SUB(reg, LDIND_I4(ADDR_L)) */
mono_burg_emit_76 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->right->left->data.i).reg;

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, treg);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SUB(reg, reg) */
mono_burg_emit_77 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SUB_OVF(reg, reg) */
mono_burg_emit_78 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");	

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SUB_OVF_UN(reg, reg) */
mono_burg_emit_79 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NC, FALSE, "OverflowException");	

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CSET(cflags) */
mono_burg_emit_80 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->data.i) {
	case CEE_CEQ:
		x86_set_reg (s->code, X86_CC_EQ, tree->reg1, TRUE);
		break;
	case CEE_CGT:
		x86_set_reg (s->code, X86_CC_GT, tree->reg1, TRUE);
		break;
	case CEE_CGT_UN:
		x86_set_reg (s->code, X86_CC_GT, tree->reg1, FALSE);
		break;
	case CEE_CLT:
		x86_set_reg (s->code, X86_CC_LT, tree->reg1, TRUE);
		break;
	case CEE_CLT_UN:
		x86_set_reg (s->code, X86_CC_LT, tree->reg1, FALSE);
		break;
	default:
		g_assert_not_reached ();
	}

	x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, FALSE);

}

static void /* reg: AND(reg, CONST_I4) */
mono_burg_emit_81 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_imm (s->code, X86_AND, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: AND(reg, reg) */
mono_burg_emit_82 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_AND, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: OR(reg, CONST_I4) */
mono_burg_emit_83 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_imm (s->code, X86_OR, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: OR(reg, reg) */
mono_burg_emit_84 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_OR, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: XOR(reg, CONST_I4) */
mono_burg_emit_85 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_imm (s->code, X86_XOR, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: XOR(reg, reg) */
mono_burg_emit_86 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_XOR, tree->left->reg1, tree->right->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: NEG(reg) */
mono_burg_emit_87 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_neg_reg (s->code, tree->left->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: NOT(reg) */
mono_burg_emit_88 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_not_reg (s->code, tree->left->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SHL(reg, CONST_I4) */
mono_burg_emit_89 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_shift_reg_imm (s->code, X86_SHL, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SHL(reg, reg) */
mono_burg_emit_90 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->reg1 != X86_ECX) {
		x86_push_reg (s->code, X86_ECX);
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);
	}
	x86_shift_reg (s->code, X86_SHL, tree->left->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

	if (tree->right->reg1 != X86_ECX)
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 != X86_ECX &&
		     tree->left->reg1 != X86_ECX);

}

static void /* reg: SHR(reg, CONST_I4) */
mono_burg_emit_91 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_shift_reg_imm (s->code, X86_SAR, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SHR(reg, reg) */
mono_burg_emit_92 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->reg1 != X86_ECX) {
		x86_push_reg (s->code, X86_ECX);
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);
	}

	x86_shift_reg (s->code, X86_SAR, tree->left->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

	if (tree->right->reg1 != X86_ECX)
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 != X86_ECX &&
		     tree->left->reg1 != X86_ECX);

}

static void /* reg: SHR_UN(reg, CONST_I4) */
mono_burg_emit_93 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_shift_reg_imm (s->code, X86_SHR, tree->left->reg1, tree->right->data.i);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: SHR_UN(reg, reg) */
mono_burg_emit_94 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->reg1 != X86_ECX) {
		x86_push_reg (s->code, X86_ECX);
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);
	}

	x86_shift_reg (s->code, X86_SHR, tree->left->reg1);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

	if (tree->right->reg1 != X86_ECX)
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 != X86_ECX &&
		     tree->left->reg1 != X86_ECX);

}

static void /* reg: LDSFLDA(CONST_I4) */
mono_burg_emit_95 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->left->data.i);
	x86_push_imm (s->code, tree->data.klass);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_ldsflda);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);
	
	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

}

static void /* reg: LDLEN(reg) */
mono_burg_emit_96 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{
	
	x86_mov_reg_membase (s->code, tree->reg1, tree->left->reg1,  
			     G_STRUCT_OFFSET (MonoArray, max_length), 4);

}

static void /* reg: LDELEMA(reg, CONST_I4) */
mono_burg_emit_97 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int ind;

	x86_alu_membase_imm (s->code, X86_CMP, tree->left->reg1, G_STRUCT_OFFSET (MonoArray, max_length), tree->right->data.i);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_GT, FALSE, "IndexOutOfRangeException");
       
	ind = tree->data.i * tree->right->data.i + G_STRUCT_OFFSET (MonoArray, vector);
	
	x86_alu_reg_imm (s->code, X86_ADD, tree->left->reg1, ind);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);


}

static void /* reg: LDELEMA(reg, reg) */
mono_burg_emit_98 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	x86_alu_reg_membase (s->code, X86_CMP, tree->right->reg1, tree->left->reg1, G_STRUCT_OFFSET (MonoArray, max_length));
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_LT, FALSE, "IndexOutOfRangeException");

	if (tree->data.i == 1 || tree->data.i == 2 || 
	    tree->data.i == 4 || tree->data.i == 8) {
		static int fast_log2 [] = { 1, 0, 1, -1, 2, -1, -1, -1, 3 };
		x86_lea_memindex (s->code, tree->reg1, tree->left->reg1, 
				  G_STRUCT_OFFSET (MonoArray, vector), tree->right->reg1, 
				  fast_log2 [tree->data.i]);
	} else {
		x86_imul_reg_reg_imm (s->code, tree->right->reg1, tree->right->reg1, tree->data.i);
		x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->right->reg1);
		x86_alu_reg_imm (s->code, X86_ADD, tree->reg1, G_STRUCT_OFFSET (MonoArray, vector));
	}

}

static void /* reg: LDSTR */
mono_burg_emit_99 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->data.p);
	x86_push_imm (s->code, s->method->klass->image);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_ldstr_wrapper);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

	PRINT_REG ("LDSTR", tree->reg1);	

}

static void /* reg: NEWARR(reg) */
mono_burg_emit_100 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_reg (s->code, tree->left->reg1);
	x86_push_imm (s->code, tree->data.p);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_array_new_wrapper);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

	PRINT_REG ("NEWARR", tree->reg1);

}

static void /* reg: NEWARR_SPEC(reg) */
mono_burg_emit_101 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_reg (s->code, tree->left->reg1);
	x86_push_imm (s->code, tree->data.p);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_array_new_specific);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

	PRINT_REG ("NEWARR_SPEC", tree->reg1);

}

static void /* reg: NEWOBJ */
mono_burg_emit_102 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->data.klass);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_object_new_wrapper);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}
	PRINT_REG ("NEWOBJ", tree->reg1);

}

static void /* reg: NEWOBJ_SPEC */
mono_burg_emit_103 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->data.p);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_object_new_specific);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}
	PRINT_REG ("NEWOBJ_SPEC", tree->reg1);

}

static void /* reg: OBJADDR(reg) */
mono_burg_emit_104 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->left->reg1 != tree->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: VTADDR(ADDR_L) */
mono_burg_emit_105 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = VARINFO (s, tree->left->data.i).offset;

	x86_lea_membase (s->code, tree->reg1, X86_EBP, offset);

}

static void /* stmt: FREE(reg) */
mono_burg_emit_106 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, g_free);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);

}

static void /* stmt: PROC2(reg, reg) */
mono_burg_emit_107 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->data.p);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

}

static void /* stmt: PROC3(reg, CPSRC(reg, reg)) */
mono_burg_emit_108 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->right->right->reg1);
	x86_push_reg (s->code, tree->right->left->reg1);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->data.p);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

}

static void /* reg: FUNC1(reg) */
mono_burg_emit_109 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_reg (s->code, tree->left->reg1);

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->data.p);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, sizeof (gpointer));

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

}

static void /* reg: LOCALLOC(reg) */
mono_burg_emit_110 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = 0;
	/* size must be aligned to MONO_FRAME_ALIGNMENT bytes */
	x86_alu_reg_imm (s->code, X86_ADD, tree->left->reg1, MONO_FRAME_ALIGNMENT - 1);
	x86_alu_reg_imm (s->code, X86_AND, tree->left->reg1, ~(MONO_FRAME_ALIGNMENT - 1));

	/* allocate space on stack */
	x86_alu_reg_reg (s->code, X86_SUB, X86_ESP, tree->left->reg1);

	if (tree->data.i) {
		/* initialize with zero */
		if (tree->reg1 != X86_EAX && tree->left->reg1 != X86_EAX) {
			x86_push_reg (s->code, X86_EAX);
			offset += 4;
		}
		if (tree->reg1 != X86_ECX && tree->left->reg1 != X86_ECX) {
			x86_push_reg (s->code, X86_ECX);
			offset += 4;
		}
		if (tree->reg1 != X86_EDI && tree->left->reg1 != X86_EDI) {
			x86_push_reg (s->code, X86_EDI);
			offset += 4;
		}
		
		x86_shift_reg_imm (s->code, X86_SHR, tree->left->reg1, 2);
		if (tree->left->reg1 != X86_ECX)
			x86_mov_reg_imm (s->code, X86_ECX, tree->left->reg1);
		x86_alu_reg_reg (s->code, X86_XOR, X86_EAX, X86_EAX);
				
		x86_lea_membase (s->code, X86_EDI, X86_ESP, offset);
		x86_cld (s->code);
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_stosl (s->code);
		
		if (tree->reg1 != X86_EDI && tree->left->reg1 != X86_EDI)
			x86_pop_reg (s->code, X86_EDI);
		if (tree->reg1 != X86_ECX && tree->left->reg1 != X86_ECX)
			x86_pop_reg (s->code, X86_ECX);
		if (tree->reg1 != X86_EAX && tree->left->reg1 != X86_EAX)
			x86_pop_reg (s->code, X86_EAX);
	}

	x86_mov_reg_reg (s->code, tree->reg1, X86_ESP, 4);

}

static void /* reg: UNBOX(reg) */
mono_burg_emit_111 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

	x86_push_reg (s->code, tree->reg1);
	x86_mov_reg_membase (s->code, tree->reg1, tree->reg1, 0, 4); 
	x86_mov_reg_membase (s->code, tree->reg1, tree->reg1, 0, 4); 
	x86_alu_membase_imm (s->code, X86_CMP, tree->reg1, 
			     G_STRUCT_OFFSET (MonoClass, element_class), ((int)(tree->data.klass->element_class)));
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, TRUE, "InvalidCastException");
	x86_pop_reg (s->code, tree->reg1);
	x86_alu_reg_imm (s->code, X86_ADD, tree->reg1, sizeof (MonoObject));

}

static void /* reg: CASTCLASS(reg) */
mono_burg_emit_112 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	MonoClass *klass = tree->data.klass;
	guint8 *br [2];
	int lreg = tree->left->reg1;
	
	x86_push_reg (s->code, lreg);
	x86_test_reg_reg (s->code, lreg, lreg);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, FALSE);

	if (klass->flags & TYPE_ATTRIBUTE_INTERFACE) {
		/* lreg = obj->vtable */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);

		x86_alu_membase_imm (s->code, X86_CMP, lreg, G_STRUCT_OFFSET (MonoVTable, max_interface_id), 
				     klass->interface_id);
		EMIT_COND_SYSTEM_EXCEPTION (X86_CC_GE, FALSE, "InvalidCastException");
		/* lreg = obj->vtable->interface_offsets */
		x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
		x86_alu_membase_imm (s->code, X86_CMP, lreg, klass->interface_id << 2, 0);
		EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NE, FALSE, "InvalidCastException");
	} else {

		/* lreg = obj->vtable */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
		/* lreg = obj->vtable->klass */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);

		if (klass->rank) {

			x86_alu_membase_imm (s->code, X86_CMP, lreg, G_STRUCT_OFFSET (MonoClass, rank), klass->rank);
			EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, FALSE, "InvalidCastException");
			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, element_class), 4);
			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, baseval), 4);
			x86_alu_reg_mem (s->code, X86_SUB, lreg, &klass->element_class->baseval);
			x86_alu_reg_mem (s->code, X86_CMP, lreg, &klass->element_class->diffval);
			EMIT_COND_SYSTEM_EXCEPTION (X86_CC_LE, FALSE, "InvalidCastException");

		} else {

			if (klass->marshalbyref) {
				/* check for transparent_proxy */		
				x86_alu_reg_imm (s->code, X86_CMP, lreg, (int)mono_defaults.transparent_proxy_class);
				br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		
				/* lreg = obj */
				x86_mov_reg_membase (s->code, lreg, X86_ESP, 0, 4);
				x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoTransparentProxy, 
											   klass), 4);

				x86_patch (br [1], s->code);
			}

			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, baseval), 4);
			x86_alu_reg_mem (s->code, X86_SUB, lreg, &klass->baseval);
			x86_alu_reg_mem (s->code, X86_CMP, lreg, &klass->diffval);
			EMIT_COND_SYSTEM_EXCEPTION (X86_CC_LE, FALSE, "InvalidCastException");		
		}
	}

	x86_patch (br [0], s->code);
	x86_pop_reg (s->code, tree->reg1);

}

static void /* reg: ISINST(reg) */
mono_burg_emit_113 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	MonoClass *klass = tree->data.klass;
	guint8 *br [3];
	int lreg = tree->left->reg1;
	
	x86_push_reg (s->code, lreg);
	x86_test_reg_reg (s->code, lreg, lreg);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, FALSE);

	if (klass->flags & TYPE_ATTRIBUTE_INTERFACE) {
		/* lreg = obj->vtable */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);

		x86_alu_membase_imm (s->code, X86_CMP, lreg, G_STRUCT_OFFSET (MonoVTable, max_interface_id), 
				     klass->interface_id);
		br [1] = s->code; x86_branch8 (s->code, X86_CC_LT, 0, FALSE);
		/* lreg = obj->vtable->interface_offsets */
		x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
		x86_alu_membase_imm (s->code, X86_CMP, lreg, klass->interface_id << 2, 0);
		br [2] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_patch (br [1], s->code);
		x86_mov_membase_imm (s->code, X86_ESP, 0, 0, 4);
		x86_patch (br [2], s->code);

	} else {

		/* lreg = obj->vtable */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
		/* lreg = obj->vtable->klass */
		x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);

		if (klass->rank) {

			x86_alu_membase_imm (s->code, X86_CMP, lreg, G_STRUCT_OFFSET (MonoClass, rank), klass->rank);
			br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, element_class), 4);
			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, baseval), 4);
			x86_alu_reg_mem (s->code, X86_SUB, lreg, &klass->element_class->baseval);
			x86_alu_reg_mem (s->code, X86_CMP, lreg, &klass->element_class->diffval);
			br [2] = s->code; x86_branch8 (s->code, X86_CC_LE, 0, FALSE);
			x86_patch (br [1], s->code);
			x86_mov_membase_imm (s->code, X86_ESP, 0, 0, 4);
			x86_patch (br [2], s->code);

		} else {

			if (klass->marshalbyref) {
				/* check for transparent_proxy */		
				x86_alu_reg_imm (s->code, X86_CMP, lreg, (int)mono_defaults.transparent_proxy_class);
				br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		
				/* lreg = obj */
				x86_mov_reg_membase (s->code, lreg, X86_ESP, 0, 4);
				x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoTransparentProxy, 
											   klass), 4);
				x86_patch (br [1], s->code);
			}

			x86_mov_reg_membase (s->code, lreg, lreg, G_STRUCT_OFFSET (MonoClass, baseval), 4);
			x86_alu_reg_mem (s->code, X86_SUB, lreg, &klass->baseval);
			x86_alu_reg_mem (s->code, X86_CMP, lreg, &klass->diffval);
			br [2] = s->code; x86_branch8 (s->code, X86_CC_LE, 0, FALSE);
			x86_mov_membase_imm (s->code, X86_ESP, 0, 0, 4);
			x86_patch (br [2], s->code);
		}
	}

	x86_patch (br [0], s->code);
	x86_pop_reg (s->code, tree->reg1);

}

static void /* stmt: INITOBJ(reg) */
mono_burg_emit_114 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int i, j;

	if (!(i = tree->data.i))
		return;

	if (i == 1 || i == 2 || i == 4) {
		x86_mov_membase_imm (s->code, tree->left->reg1, 0, 0, i);
		return;
	}

	i = tree->data.i / 4;
	j = tree->data.i % 4;

	if (tree->left->reg1 != X86_EDI) {
		x86_push_reg (s->code, X86_EDI);
		x86_mov_reg_reg (s->code, X86_EDI, tree->left->reg1, 4);
	}

	if (i) {
		x86_alu_reg_reg (s->code, X86_XOR, X86_EAX, X86_EAX);
		x86_mov_reg_imm (s->code, X86_ECX, i);
		x86_cld (s->code);
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_stosl (s->code);

		for (i = 0; i < j; i++)
			x86_stosb (s->code);

	} else {
		g_assert (j == 3);
		x86_mov_membase_imm (s->code, X86_EDI, 0, 0, 2);
		x86_mov_membase_imm (s->code, X86_EDI, 2, 0, 1);
	}



	if (tree->left->reg1 != X86_EDI)
		x86_pop_reg (s->code, X86_EDI);

}

static void /* stmt: CPBLK(reg, CPSRC(reg, CONST_I4)) */
mono_burg_emit_115 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int dest_reg = tree->left->reg1;
	int source_reg = tree->right->left->reg1;
	int count = tree->right->right->data.i;
	int sreg = dest_reg != X86_EAX ? X86_EAX : X86_EDX;
	int spill_pos = 0, dest_offset = 0, source_offset = 0;
	int save_esi = FALSE, save_edi = FALSE;

	// TODO: handle unaligned. prefix

	switch (count) {
	case 0:
		break;
	case 1:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 1);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 1);
		break;
	case 2:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 2);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 2);
		break;
	case 3:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 2);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 2);
		x86_mov_reg_membase (s->code, sreg, source_reg, 2, 1);
		x86_mov_membase_reg (s->code, dest_reg, 2, sreg, 1);
		break;
	case 4:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 4);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 4);
		break;
	case 5:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 4);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 4, 1);
		x86_mov_membase_reg (s->code, dest_reg, 4, sreg, 1);
		break;
	case 6:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 4);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 4, 2);
		x86_mov_membase_reg (s->code, dest_reg, 4, sreg, 2);
		break;
	case 7:
		x86_mov_reg_membase (s->code, sreg, source_reg, 0, 4);
		x86_mov_membase_reg (s->code, dest_reg, 0, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 4, 2);
		x86_mov_membase_reg (s->code, dest_reg, 4, sreg, 2);
		x86_mov_reg_membase (s->code, sreg, source_reg, 6, 1);
		x86_mov_membase_reg (s->code, dest_reg, 6, sreg, 1);
		break;
	case 8:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		break;
	case 9:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 1);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 1);
		break;
	case 10:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 2);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 2);
		break;
	case 11:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 2);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 2);
		x86_mov_reg_membase (s->code, sreg, source_reg, 10, 1);
		x86_mov_membase_reg (s->code, dest_reg, 10, sreg, 1);
		break;
	case 12:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 4);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 4);
		break;
	case 13:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 4);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 12, 1);
		x86_mov_membase_reg (s->code, dest_reg, 12, sreg, 1);
		break;
	case 14:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 4);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 12, 2);
		x86_mov_membase_reg (s->code, dest_reg, 12, sreg, 2);
		break;
	case 15:
		x86_fild_membase (s->code, source_reg, 0, TRUE);
		x86_fist_pop_membase (s->code, dest_reg, 0, TRUE);
		x86_mov_reg_membase (s->code, sreg, source_reg, 8, 4);
		x86_mov_membase_reg (s->code, dest_reg, 8, sreg, 4);
		x86_mov_reg_membase (s->code, sreg, source_reg, 12, 2);
		x86_mov_membase_reg (s->code, dest_reg, 12, sreg, 2);
		x86_mov_reg_membase (s->code, sreg, source_reg, 14, 1);
		x86_mov_membase_reg (s->code, dest_reg, 14, sreg, 1);
		break;
	default: 
		g_assert (count > 15);

		if (dest_reg != X86_ESI && source_reg != X86_ESI &&
		    mono_regset_reg_used (s->rs, X86_ESI))
			save_esi = TRUE;
		if (dest_reg != X86_EDI && source_reg != X86_EDI &&
		    mono_regset_reg_used (s->rs, X86_EDI))
			save_edi = TRUE;

		if (save_esi)
			x86_push_reg (s->code, X86_ESI);
		if (save_edi)
			x86_push_reg (s->code, X86_EDI);

		if (dest_reg == X86_ESI) {
			dest_offset = ++spill_pos; 
		}	   
		if (source_reg == X86_EDI) {
			source_offset = ++spill_pos; 
		}	   

		if (source_offset)
			x86_push_reg (s->code, source_reg);
		if (dest_offset)
			x86_push_reg (s->code, dest_reg);
	
		if (source_reg != X86_ESI) {
			if (source_offset)
				x86_mov_reg_membase (s->code, X86_ESI, X86_ESP, (source_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_ESI, source_reg, 4);
		}
		if (dest_reg != X86_EDI) {
			if (dest_offset)
				x86_mov_reg_membase (s->code, X86_EDI, X86_ESP, (dest_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EDI, dest_reg, 4);
		}

		x86_mov_reg_imm (s->code, X86_ECX, count >> 2);	
		x86_cld (s->code);
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_movsd (s->code);

		switch (count & 3) {
		case 1:
			x86_mov_reg_membase (s->code, sreg, X86_ESI, 0, 1);
			x86_mov_membase_reg (s->code, X86_EDI, 0, sreg, 1);
			break;
		case 2:
			x86_mov_reg_membase (s->code, sreg, X86_ESI, 0, 2);
			x86_mov_membase_reg (s->code, X86_EDI, 0, sreg, 2);
			break;
		case 3:
			x86_mov_reg_membase (s->code, sreg, X86_ESI, 0, 2);
			x86_mov_membase_reg (s->code, X86_EDI, 0, sreg, 2);
			x86_mov_reg_membase (s->code, sreg, X86_ESI, 2, 1);
			x86_mov_membase_reg (s->code, X86_EDI, 2, sreg, 1);
			break;
		default:
			break;
		}

		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, spill_pos<<2);

		if (save_edi)
			x86_pop_reg (s->code, X86_EDI);
		if (save_esi)
			x86_pop_reg (s->code, X86_ESI);

		break;
	}

}

static void /* stmt: CPBLK(reg, CPSRC(reg, reg)) */
mono_burg_emit_116 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int dest_reg = tree->left->reg1;
	int source_reg = tree->right->left->reg1;
	int size_reg = tree->right->right->reg1;
	int spill_pos = 0, size_offset = 0, dest_offset = 0, source_offset = 0;
	int save_esi = FALSE, save_edi = FALSE;

	if (!mono_inline_memcpy) {
		x86_push_reg (s->code, size_reg);
		x86_push_reg (s->code, source_reg);
		x86_push_reg (s->code, dest_reg);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, memmove);
		x86_call_code (s->code, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);
	} else {
		if (dest_reg != X86_ESI && source_reg != X86_ESI && size_reg != X86_ESI &&
		    mono_regset_reg_used (s->rs, X86_ESI))
			save_esi = TRUE;
		if (dest_reg != X86_EDI && source_reg != X86_EDI && size_reg != X86_EDI &&
		    mono_regset_reg_used (s->rs, X86_EDI))
			save_edi = TRUE;

		if (save_esi)
			x86_push_reg (s->code, X86_ESI);
		if (save_edi)
			x86_push_reg (s->code, X86_EDI);

		if (size_reg == X86_EDI || size_reg == X86_ESI) {
			size_offset = ++spill_pos; 
		}	   
		if (dest_reg == X86_ECX || dest_reg == X86_ESI) {
			dest_offset = ++spill_pos; 
		}	   
		if (source_reg == X86_ECX || source_reg == X86_EDI) {
			source_offset = ++spill_pos; 
		}	   

		if (source_offset)
			x86_push_reg (s->code, source_reg);
		if (dest_offset)
			x86_push_reg (s->code, dest_reg);
		if (size_offset)
			x86_push_reg (s->code, size_reg);
	
		if (source_reg != X86_ESI) {
			if (source_offset)
				x86_mov_reg_membase (s->code, X86_ESI, X86_ESP, (source_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_ESI, source_reg, 4);
		}
		if (dest_reg != X86_EDI) {
			if (dest_offset)
				x86_mov_reg_membase (s->code, X86_EDI, X86_ESP, (dest_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EDI, dest_reg, 4);
		}
		if (size_reg != X86_ECX) {
			if (size_offset)
				x86_mov_reg_membase (s->code, X86_ECX, X86_ESP, (size_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_ECX, size_reg, 4);
		}

		x86_push_reg (s->code, X86_ECX);
		x86_shift_reg_imm (s->code, X86_SHR, X86_ECX, 2);

		x86_cld (s->code);
	
		// move whole dwords first
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_movsd (s->code);

		x86_pop_reg (s->code, X86_ECX);
		x86_alu_reg_imm (s->code, X86_AND, X86_ECX, 3);

		// move remaining bytes (if any)
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_movsb (s->code);

		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, spill_pos<<2);
		
		if (save_edi)
			x86_pop_reg (s->code, X86_EDI);
		if (save_esi)
			x86_pop_reg (s->code, X86_ESI);
	}

}

static void /* stmt: INITBLK(reg, CPSRC(reg, CONST_I4)) */
mono_burg_emit_117 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int dest_reg = tree->left->reg1;
	int value_reg = tree->right->left->reg1;
	int size = tree->right->right->data.i;
	int spill_pos = 0, dest_offset = 0, value_offset = 0;
	int save_edi = FALSE;
	int i, j;

	i = size / 4;
	j = size % 4;

	if (mono_inline_memcpy) {

		if (dest_reg != X86_EDI && value_reg != X86_EDI &&
		    mono_regset_reg_used (s->rs, X86_EDI)) {
			save_edi = TRUE;
			x86_push_reg (s->code, X86_EDI);
		}

		if (dest_reg == X86_ECX || dest_reg == X86_EAX) {
			dest_offset = ++spill_pos; 
		}	   
		if (value_reg == X86_ECX || value_reg == X86_EDI) {
			value_offset = ++spill_pos; 
		}	   

		if (value_offset)
			x86_push_reg (s->code, value_reg);
		if (dest_offset)
			x86_push_reg (s->code, dest_reg);

		if (value_reg != X86_EAX) {
			if (value_offset)
				x86_mov_reg_membase (s->code, X86_EAX, X86_ESP, (value_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EAX, value_reg, 4);
		}
		if (dest_reg != X86_EDI) {
			if (dest_offset)
				x86_mov_reg_membase (s->code, X86_EDI, X86_ESP, (dest_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EDI, dest_reg, 4);
		}

		x86_widen_reg (s->code, X86_EAX, X86_EAX, FALSE, FALSE);
		x86_mov_reg_reg (s->code, X86_EDX, X86_EAX, 4);
		x86_shift_reg_imm (s->code, X86_SHL, X86_EAX, 8);
		x86_alu_reg_reg (s->code, X86_OR, X86_EAX, X86_EDX);
		x86_mov_reg_reg (s->code, X86_EDX, X86_EAX, 4);
		x86_shift_reg_imm (s->code, X86_SHL, X86_EAX, 16);
		x86_alu_reg_reg (s->code, X86_OR, X86_EAX, X86_EDX);

		if (i) {
			x86_mov_reg_imm (s->code, X86_ECX, i);
			x86_cld (s->code);
			x86_prefix (s->code, X86_REP_PREFIX);
			x86_stosd (s->code);
		}

		for (i = 0; i < j; i++)
			x86_stosb (s->code);
	
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, spill_pos<<2);

		if (save_edi)
			x86_pop_reg (s->code, X86_EDI);

	} else {
		x86_push_imm (s->code, size);
		x86_push_reg (s->code, value_reg);
		x86_push_reg (s->code, dest_reg);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, memset);
		x86_call_code (s->code, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);
	}

}

static void /* stmt: INITBLK(reg, CPSRC(reg, reg)) */
mono_burg_emit_118 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int dest_reg = tree->left->reg1;
	int value_reg = tree->right->left->reg1;
	int size_reg = tree->right->right->reg1;
	int spill_pos = 0, size_offset = 0, dest_offset = 0, value_offset = 0;
	int save_edi = FALSE;

	if (mono_inline_memcpy) {

		if (dest_reg != X86_EDI && size_reg != X86_EDI && size_reg != X86_EDI &&
		    mono_regset_reg_used (s->rs, X86_EDI)) {
			save_edi = TRUE;
			x86_push_reg (s->code, X86_EDI);
		}

		if (size_reg == X86_EDI || size_reg == X86_EAX) {
			size_offset = ++spill_pos; 
		}	   
		if (dest_reg == X86_ECX || dest_reg == X86_EAX) {
			dest_offset = ++spill_pos; 
		}	   
		if (value_reg == X86_ECX || value_reg == X86_EDI) {
			value_offset = ++spill_pos; 
		}	   

		if (value_offset)
			x86_push_reg (s->code, value_reg);
		if (dest_offset)
			x86_push_reg (s->code, dest_reg);
		if (size_offset)
			x86_push_reg (s->code, size_reg);

		if (value_reg != X86_EAX) {
			if (value_offset)
				x86_mov_reg_membase (s->code, X86_EAX, X86_ESP, (value_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EAX, value_reg, 4);
		}
		if (dest_reg != X86_EDI) {
			if (dest_offset)
				x86_mov_reg_membase (s->code, X86_EDI, X86_ESP, (dest_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_EDI, dest_reg, 4);
		}
		if (size_reg != X86_ECX) {
			if (size_offset)
				x86_mov_reg_membase (s->code, X86_ECX, X86_ESP, (size_offset-1)<<2, 4);
			else
				x86_mov_reg_reg (s->code, X86_ECX, size_reg, 4);
		}

		x86_widen_reg (s->code, X86_EAX, X86_EAX, FALSE, FALSE);
		x86_mov_reg_reg (s->code, X86_EDX, X86_EAX, 4);
		x86_shift_reg_imm (s->code, X86_SHL, X86_EAX, 8);
		x86_alu_reg_reg (s->code, X86_OR, X86_EAX, X86_EDX);
		x86_mov_reg_reg (s->code, X86_EDX, X86_EAX, 4);
		x86_shift_reg_imm (s->code, X86_SHL, X86_EAX, 16);
		x86_alu_reg_reg (s->code, X86_OR, X86_EAX, X86_EDX);

		x86_push_reg (s->code, X86_ECX);
		x86_shift_reg_imm (s->code, X86_SHR, X86_ECX, 2);
		x86_cld (s->code);

		// init whole dwords first
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_stosd (s->code);

		x86_pop_reg (s->code, X86_ECX);
		x86_alu_reg_imm (s->code, X86_AND, X86_ECX, 3);

		// init remaining bytes (if any)
		x86_prefix (s->code, X86_REP_PREFIX);
		x86_stosb (s->code);

		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, spill_pos<<2);

		if (save_edi)
			x86_pop_reg (s->code, X86_EDI);

	} else {
		x86_push_reg (s->code, size_reg);
		x86_push_reg (s->code, value_reg);
		x86_push_reg (s->code, dest_reg);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, memset);
		x86_call_code (s->code, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);
	}

}

static void /* stmt: BR */
mono_burg_emit_121 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_jump32 (s->code, 0); 

}

static void /* cflags: COMPARE(reg, LDIND_I4(ADDR_L)) */
mono_burg_emit_122 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->right->left->data.i).reg;
	x86_alu_reg_reg (s->code, X86_CMP, tree->left->reg1, treg);

}

static void /* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
mono_burg_emit_123 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->left->data.i).reg;
	x86_alu_reg_imm (s->code, X86_CMP, treg, tree->right->data.i);

}

static void /* cflags: COMPARE(LDIND_I4(ADDR_L), reg) */
mono_burg_emit_124 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->left->data.i).reg;
	x86_alu_reg_reg (s->code, X86_CMP, treg, tree->right->reg1);

}

static void /* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
mono_burg_emit_125 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int offset = VARINFO (s, tree->left->left->data.i).offset;
	x86_alu_membase_imm (s->code, X86_CMP, X86_EBP, offset,  tree->right->data.i);

}

static void /* cflags: COMPARE(reg, CONST_I4) */
mono_burg_emit_126 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, tree->right->data.i);

}

static void /* cflags: COMPARE(reg, reg) */
mono_burg_emit_127 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_CMP, tree->left->reg1, tree->right->reg1);

}

static void /* stmt: CBRANCH(cflags) */
mono_burg_emit_128 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);

	switch (tree->data.bi.cond) {
	case CEE_BLT:
		x86_branch32 (s->code, X86_CC_LT, 0, TRUE); 
		break;
	case CEE_BLT_UN:
		x86_branch32 (s->code, X86_CC_LT, 0, FALSE); 
		break;
	case CEE_BGT:
		x86_branch32 (s->code, X86_CC_GT, 0, TRUE); 
		break;
	case CEE_BGT_UN:
		x86_branch32 (s->code, X86_CC_GT, 0, FALSE); 
		break;
	case CEE_BEQ:
		x86_branch32 (s->code, X86_CC_EQ, 0, TRUE);
		break;
	case CEE_BNE_UN:
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BGE:
		x86_branch32 (s->code, X86_CC_GE, 0, TRUE);
		break;
	case CEE_BGE_UN:
		x86_branch32 (s->code, X86_CC_GE, 0, FALSE);
		break;
	case CEE_BLE:
		x86_branch32 (s->code, X86_CC_LE, 0, TRUE);
		break;
	case CEE_BLE_UN:
		x86_branch32 (s->code, X86_CC_LE, 0, FALSE);
		break;
	default:
		g_assert_not_reached ();
	}

}

static void /* stmt: BRTRUE(LDIND_I4(ADDR_L)) */
mono_burg_emit_129 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->left->data.i).reg;
	int offset = VARINFO (s, tree->left->left->data.i).offset;

	if (treg >= 0)
		x86_test_reg_reg (s->code, treg, treg);
	else
		x86_alu_membase_imm (s->code, X86_CMP, X86_EBP, offset, 0);

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_branch32 (s->code, X86_CC_NE, 0, TRUE);

}

static void /* stmt: BRTRUE(reg) */
mono_burg_emit_130 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_test_reg_reg (s->code, tree->left->reg1, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_branch32 (s->code, X86_CC_NE, 0, TRUE);

}

static void /* stmt: BRFALSE(LDIND_I4(ADDR_L)) */
mono_burg_emit_131 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->left->data.i).reg;
	int offset = VARINFO (s, tree->left->left->data.i).offset;

	if (treg >= 0)
		x86_test_reg_reg (s->code, treg, treg);
	else
		x86_alu_membase_imm (s->code, X86_CMP, X86_EBP, offset, 0);

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_branch32 (s->code, X86_CC_EQ, 0, TRUE);

	//{static int cx= 0; printf ("CX1 %5d\n", cx++);}

}

static void /* stmt: BRFALSE(reg) */
mono_burg_emit_132 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_test_reg_reg (s->code, tree->left->reg1, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bb);
	x86_branch32 (s->code, X86_CC_EQ, 0, TRUE);

}

static void /* stmt: BREAK */
mono_burg_emit_133 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_breakpoint (s->code);

}

static void /* stmt: RET(reg) */
mono_burg_emit_134 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->left->reg1 != X86_EAX)
		x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);

	if (!tree->last_instr) {
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_EPILOG, NULL);
		x86_jump32 (s->code, 0);      
	}

}

static void /* stmt: RET_VOID */
mono_burg_emit_135 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (!tree->last_instr) {
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_EPILOG, NULL);
		x86_jump32 (s->code, 0);      
	} 

}

static void /* stmt: ARG_I4(LDIND_I4(addr)) */
mono_burg_emit_136 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	MBTree *at = tree->left->left;
	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);

	switch (at->data.ainfo.amode) {

	case AMImmediate:
		x86_push_mem (s->code, at->data.ainfo.offset);
		break;

	case AMBase:
		x86_push_membase (s->code, at->data.ainfo.basereg, at->data.ainfo.offset);
		break;		
	case AMIndex:
		x86_push_memindex (s->code, X86_NOBASEREG, at->data.ainfo.offset,
				   at->data.ainfo.indexreg, at->data.ainfo.shift);
		break;		
	case AMBaseIndex:
		x86_push_memindex (s->code, at->data.ainfo.basereg, 
				   at->data.ainfo.offset, at->data.ainfo.indexreg, 
				   at->data.ainfo.shift);
		break;		
	}

}

static void /* stmt: ARG_I4(LDIND_I4(ADDR_L)) */
mono_burg_emit_137 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = VARINFO (s, tree->left->left->data.i).reg;
	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_reg (s->code, treg);

}

static void /* stmt: ARG_I4(reg) */
mono_burg_emit_138 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_reg (s->code, tree->left->reg1);

}

static void /* stmt: ARG_I4(ADDR_G) */
mono_burg_emit_139 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_imm (s->code, tree->left->data.p);

}

static void /* stmt: ARG_I4(CONST_I4) */
mono_burg_emit_140 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_imm (s->code, tree->left->data.i);

}

static void /* this: reg */
mono_burg_emit_141 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	PRINT_REG ("THIS", tree->reg1);

}

static void /* reg: CHECKTHIS(reg) */
mono_burg_emit_142 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* try to access the vtable - this will raise an exception
	 * if the object is NULL */
	x86_alu_membase_imm (s->code, X86_CMP, tree->left->reg1, 0, 0);
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* stmt: CHECKTHIS(reg) */
mono_burg_emit_143 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_membase_imm (s->code, X86_CMP, tree->left->reg1, 0, 0);

}

static void /* stmt: JMP */
mono_burg_emit_144 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pos = -4;

	/* restore callee saved registers */
	if (mono_regset_reg_used (s->rs, X86_EBX)) {
		x86_mov_reg_membase (s->code, X86_EBX, X86_EBP, pos, 4);
		pos -= 4;
	}
	if (mono_regset_reg_used (s->rs, X86_EDI)) {
		x86_mov_reg_membase (s->code, X86_EDI, X86_EBP, pos, 4);
		pos -= 4;
	}
	if (mono_regset_reg_used (s->rs, X86_ESI)) {
		x86_mov_reg_membase (s->code, X86_ESI, X86_EBP, pos, 4);
		pos -= 4;
	}
	/* restore ESP/EBP */
	x86_leave (s->code);

	/* jump to the method */
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->data.p);
	x86_jump32 (s->code, 0);

}

static void /* reg: CALL_I4(this, reg) */
mono_burg_emit_146 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	
	if (lreg == treg || rreg == treg) 
		treg = X86_EDX;
	if (lreg == treg || rreg == treg) 
		treg = X86_ECX;
	if (lreg == treg || rreg == treg) 
		mono_assert_not_reached ();

	X86_CALL_BEGIN;

	x86_call_reg (s->code, rreg);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);

}

static void /* reg: CALL_I4(this, ADDR_G) */
mono_burg_emit_147 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;
	
	X86_CALL_BEGIN;

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->right->data.p);
	x86_call_code (s->code, 0);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);

}

static void /* reg: LDVIRTFTN(reg, INTF_ADDR) */
mono_burg_emit_148 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* we cant return the value in the vtable, because it can be
	 * a magic trampoline, and we cant pass that to the outside world */
	
	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->right->data.m->klass->interface_id);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_ldintftn);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

}

static void /* reg: CALL_I4(this, INTF_ADDR) */
mono_burg_emit_149 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_mov_reg_membase (s->code, lreg, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
	x86_mov_reg_membase (s->code, lreg, lreg, tree->right->data.m->klass->interface_id << 2, 4);
	x86_call_virtual (s->code, lreg, tree->right->data.m->slot << 2);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);

}

static void /* reg: LDVIRTFTN(reg, VFUNC_ADDR) */
mono_burg_emit_150 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* we cant return the value in the vtable, because it can be
	 * a magic trampoline, and we cant pass that to the outside world */
	
	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->right->data.m->slot);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_ldvirtftn);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

}

static void /* reg: LDFTN */
mono_burg_emit_151 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != X86_EAX)
		x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_ECX);
	x86_push_reg (s->code, X86_EDX);

	x86_push_imm (s->code, tree->data.m);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_ldftn);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, sizeof (gpointer));

	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_ECX);
	if (tree->reg1 != X86_EAX) {
		x86_mov_reg_reg (s->code, tree->reg1, X86_EAX, 4);
		x86_pop_reg (s->code, X86_EAX);
	}

}

static void /* reg: CALL_I4(this, VFUNC_ADDR) */
mono_burg_emit_152 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);	
	x86_call_virtual (s->code, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, vtable) + (tree->right->data.m->slot << 2));

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);

}

static void /* stmt: CALL_VOID(this, ADDR_G) */
mono_burg_emit_153 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;
	
	X86_CALL_BEGIN;

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->right->data.p);
	x86_call_code (s->code, 0);

	X86_CALL_END;

}

static void /* stmt: CALL_VOID(this, reg) */
mono_burg_emit_154 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;

	if (lreg == treg || rreg == treg) 
		treg = X86_EDX;
	if (lreg == treg || rreg == treg) 
		treg = X86_ECX;
	if (lreg == treg || rreg == treg) 
		mono_assert_not_reached ();
	
	X86_CALL_BEGIN;

	x86_call_reg (s->code, tree->right->reg1);

	X86_CALL_END;

}

static void /* stmt: CALL_VOID(this, INTF_ADDR) */
mono_burg_emit_155 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_mov_reg_membase (s->code, lreg, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
	x86_mov_reg_membase (s->code, lreg, lreg, tree->right->data.m->klass->interface_id << 2, 4);
	x86_call_virtual (s->code, lreg, tree->right->data.m->slot << 2);

	X86_CALL_END;

}

static void /* stmt: CALL_VOID(this, VFUNC_ADDR) */
mono_burg_emit_156 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_call_virtual (s->code, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, vtable) + (tree->right->data.m->slot << 2));

	X86_CALL_END;

}

static void /* stmt: SWITCH(reg) */
mono_burg_emit_157 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint32 offset;
	guint32 *jt = (guint32 *)tree->data.p;

	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, jt [0]);
	offset = 6 + (guint32)s->code;
	x86_branch32 (s->code, X86_CC_GE, jt [jt [0] + 1] - offset, FALSE);

	x86_mov_reg_memindex (s->code, X86_EAX, X86_NOBASEREG, 
			      tree->data.i + 4, tree->left->reg1, 2, 4);	
	x86_jump_reg (s->code, X86_EAX);

}

static void /* reg: CONV_I1(lreg) */
mono_burg_emit_158 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, FALSE);

}

static void /* reg: CONV_U1(lreg) */
mono_burg_emit_159 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, FALSE);

}

static void /* reg: CONV_I2(lreg) */
mono_burg_emit_160 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, TRUE, TRUE);

}

static void /* reg: CONV_U2(lreg) */
mono_burg_emit_161 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_widen_reg (s->code, tree->reg1, tree->left->reg1, FALSE, TRUE);

}

static void /* reg: CONV_I4(lreg) */
mono_burg_emit_162 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_U4(lreg) */
mono_burg_emit_163 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_OVF_I4(lreg) */
mono_burg_emit_164 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *start = s->code;
	guchar* o1, *o2, *o3, *o4, *o5;
	int i;

	/* 
	 * Valid ints: 0xffffffff:8000000 to 00000000:0x7f000000
	 */
	for (i = 0; i < 2; i++) {
		s->code = start;

		x86_test_reg_reg (s->code, tree->left->reg1, tree->left->reg1);

		/* If the low word top bit is set, see if we are negative */
		x86_branch8 (s->code, X86_CC_LT, o3 - o1, TRUE);
		o1 = s->code;

		/* We are not negative (no top bit set, check for our top word to be zero */
		x86_test_reg_reg (s->code, tree->left->reg2, tree->left->reg2);
		x86_branch8 (s->code, X86_CC_EQ, o4 - o2, TRUE);
		o2 = s->code;

		/* throw exception */
		x86_push_imm (s->code, "OverflowException");
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, 
				    arch_get_throw_exception_by_name ());
		x86_call_code (s->code, 0);
	
		o3 = s->code;
		/* our top bit is set, check that top word is 0xfffffff */
		x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg2, 0xffffffff);
		
		o4 = s->code;
		/* nope, emit exception */
		x86_branch8 (s->code, X86_CC_NE, o2 - o5, TRUE);
		o5 = s->code;

		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	}

}

static void /* reg: CONV_OVF_I4(lreg) */
mono_burg_emit_165 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [3], *label [1];

	/* 
	 * Valid ints: 0xffffffff:8000000 to 00000000:0x7f000000
	 */
	x86_test_reg_reg (s->code, tree->left->reg1, tree->left->reg1);

	/* If the low word top bit is set, see if we are negative */
	br [0] = s->code; x86_branch8 (s->code, X86_CC_LT, 0, TRUE);

	/* We are not negative (no top bit set, check for our top word to be zero */
	x86_test_reg_reg (s->code, tree->left->reg2, tree->left->reg2);
	br [1] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, TRUE);
	label [0] = s->code;

	/* throw exception */
	x86_push_imm (s->code, "OverflowException");
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, 
			    arch_get_throw_exception_by_name ());
	x86_call_code (s->code, 0);
	
	x86_patch (br [0], s->code);
	/* our top bit is set, check that top word is 0xfffffff */
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg2, 0xffffffff);
		
	x86_patch (br [1], s->code);
	/* nope, emit exception */
	br [2] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
	x86_patch (br [2], label [0]);

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_OVF_U4(lreg) */
mono_burg_emit_166 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_I4_UN below, they are the same on 32-bit machines */
	/* top word must be 0 */
	x86_test_reg_reg (s->code, tree->left->reg2, tree->left->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, TRUE, "OverflowException");
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* reg: CONV_OVF_I4_UN(lreg) */
mono_burg_emit_167 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Keep in sync with CONV_OVF_U4 above, they are the same on 32-bit machines */
	/* top word must be 0 */
	x86_test_reg_reg (s->code, tree->left->reg2, tree->left->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, TRUE, "OverflowException");
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* lreg: CONST_I8 */
mono_burg_emit_169 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, *((gint32 *)&tree->data.p));
	x86_mov_reg_imm (s->code, tree->reg2, *((gint32 *)&tree->data.p + 1));

}

static void /* lreg: CONV_I8(CONST_I4) */
mono_burg_emit_170 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, tree->left->data.i);

	if (tree->left->data.i >= 0)
		x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);
	else 
		x86_mov_reg_imm (s->code, tree->reg2, -1);		

}

static void /* lreg: CONV_I8(reg) */
mono_burg_emit_171 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *i1;

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);
	x86_alu_reg_imm (s->code, X86_CMP, tree->left->reg1, 0);
	x86_branch8 (s->code, X86_CC_GE, 5, TRUE);
	i1 = s->code;
	x86_mov_reg_imm (s->code, tree->reg2, -1); 
	mono_assert ((s->code - i1) == 5);

}

static void /* lreg: CONV_U8(CONST_I4) */
mono_burg_emit_172 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, tree->left->data.i);
	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);

}

static void /* lreg: CONV_U8(reg) */
mono_burg_emit_173 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);

}

static void /* lreg: CONV_OVF_U8(CONST_I4) */
mono_burg_emit_174 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->left->data.i < 0){
		x86_push_imm (s->code, "OverflowException");
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, 
				    arch_get_throw_exception_by_name ());
		x86_call_code (s->code, 0);
	} else {
		x86_mov_reg_imm (s->code, tree->reg1, tree->left->data.i);
		x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);
	}

}

static void /* lreg: CONV_OVF_I8_UN(CONST_I4) */
mono_burg_emit_175 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_mov_reg_imm (s->code, tree->reg1, tree->left->data.i);
	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);

}

static void /* lreg: CONV_OVF_U8(reg) */
mono_burg_emit_176 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_test_reg_imm (s->code, tree->left->reg1, 0x8000000);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_EQ, TRUE, "OverflowException");

	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);

}

static void /* lreg: CONV_OVF_I8_UN(reg) */
mono_burg_emit_177 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* Convert uint value into int64, we pass everything */
	if (tree->reg1 != tree->left->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
	x86_alu_reg_reg (s->code, X86_XOR, tree->reg2, tree->reg2);

}

static void /* stmt: STIND_I8(addr, lreg) */
mono_burg_emit_178 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_mem_reg (s->code, tree->left->data.ainfo.offset, tree->right->reg1, 4);
		x86_mov_mem_reg (s->code, tree->left->data.ainfo.offset + 4, tree->right->reg2, 4);
		break;
		
	case AMBase:
		x86_mov_membase_reg (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset, tree->right->reg1, 4);
		x86_mov_membase_reg (s->code, tree->left->data.ainfo.basereg, 
				     tree->left->data.ainfo.offset + 4, tree->right->reg2, 4);
		break;		
	case AMIndex:
		x86_mov_memindex_reg (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 4);
		x86_mov_memindex_reg (s->code, X86_NOBASEREG, tree->left->data.ainfo.offset + 4,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg2, 4);
		break;		
	case AMBaseIndex:
		x86_mov_memindex_reg (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg1, 4);
		x86_mov_memindex_reg (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset + 4,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift,
				      tree->right->reg2, 4);
		break;		
	}

}

static void /* stmt: REMOTE_STIND_I8(reg, lreg) */
mono_burg_emit_179 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int offset;

	x86_push_reg (s->code, tree->right->reg1);
	x86_mov_reg_membase (s->code, tree->right->reg1, tree->left->reg1, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, tree->right->reg1, 0, ((int)mono_defaults.transparent_proxy_class));
	x86_pop_reg (s->code, tree->right->reg1);
	
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 24);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_mov_membase_reg (s->code, tree->left->reg1, offset, tree->right->reg1, 4);
	x86_mov_membase_reg (s->code, tree->left->reg1, offset + 4, tree->right->reg2, 4);

	x86_patch (br [1], s->code);

}

static void /* lreg: LDIND_I8(addr) */
mono_burg_emit_180 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_mov_reg_mem (s->code, tree->reg1, tree->left->data.ainfo.offset, 4);
		x86_mov_reg_mem (s->code, tree->reg2, tree->left->data.ainfo.offset + 4, 4);
		break;

	case AMBase:
		x86_lea_membase (s->code, tree->reg2, tree->left->data.ainfo.basereg,
				 tree->left->data.ainfo.offset);
		x86_mov_reg_membase (s->code, tree->reg1, tree->reg2, 0, 4);
		x86_mov_reg_membase (s->code, tree->reg2, tree->reg2, 4, 4);
		break;		
	case AMIndex:
		x86_lea_memindex (s->code, tree->reg2, X86_NOBASEREG, tree->left->data.ainfo.offset,
				      tree->left->data.ainfo.indexreg, tree->left->data.ainfo.shift);
		x86_mov_reg_membase (s->code, tree->reg1, tree->reg2, 0, 4);
		x86_mov_reg_membase (s->code, tree->reg2, tree->reg2, 4, 4);
		break;		
	case AMBaseIndex:
		x86_lea_memindex (s->code, tree->reg2, tree->left->data.ainfo.basereg, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_mov_reg_membase (s->code, tree->reg1, tree->reg2, 0, 4);
		x86_mov_reg_membase (s->code, tree->reg2, tree->reg2, 4, 4);
		break;		
	}
	PRINT_REG ("LDIND_I8_0", tree->reg1);
	PRINT_REG ("LDIND_I8_1", tree->reg2);

}

static void /* lreg: SHR(lreg, CONST_I4) */
mono_burg_emit_181 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->data.i < 32) {
		x86_shrd_reg_imm (s->code, tree->left->reg1, tree->left->reg2, tree->right->data.i);
		x86_shift_reg_imm (s->code, X86_SAR, tree->left->reg2, tree->right->data.i);
		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
		if (tree->reg2 != tree->left->reg2)
			x86_mov_reg_reg (s->code, tree->reg2, tree->left->reg2, 4);
	} else if (tree->right->data.i < 64) {
		if (tree->reg1 != tree->left->reg2)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg2, 4);
		if (tree->reg2 != tree->left->reg2)
			x86_mov_reg_reg (s->code, tree->reg2, tree->left->reg2, 4);
		x86_shift_reg_imm (s->code, X86_SAR, tree->reg2, 31);
		x86_shift_reg_imm (s->code, X86_SAR, tree->reg1, (tree->right->data.i - 32));
	} /* else unspecified result */

}

static void /* lreg: SHR_UN(lreg, CONST_I4) */
mono_burg_emit_182 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->data.i < 32) {
		x86_shrd_reg_imm (s->code, tree->left->reg1, tree->left->reg2, tree->right->data.i);
		x86_shift_reg_imm (s->code, X86_SHR, tree->left->reg2, tree->right->data.i);
		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
		if (tree->reg2 != tree->left->reg2)
			x86_mov_reg_reg (s->code, tree->reg2, tree->left->reg2, 4);
	} else if (tree->right->data.i < 64) {
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg2, 4);
		x86_shift_reg_imm (s->code, X86_SHR, tree->reg1, (tree->right->data.i - 32));
		x86_mov_reg_imm (s->code, tree->reg2, 0);
	} /* else unspecified result */

}

static void /* lreg: SHR(lreg, reg) */
mono_burg_emit_183 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [1];

	if (tree->right->reg1 != X86_ECX)
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);

	x86_shrd_reg (s->code, tree->left->reg1, tree->left->reg2);
	x86_shift_reg (s->code, X86_SAR, tree->left->reg2);
	x86_test_reg_imm (s->code, X86_ECX, 32);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, FALSE);
	x86_mov_reg_reg (s->code, tree->left->reg1, tree->left->reg2, 4);
	x86_shift_reg_imm (s->code, X86_SAR, tree->reg2, 31);		
	x86_patch (br [0], s->code);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: SHR_UN(lreg, reg) */
mono_burg_emit_184 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [1];

	if (tree->right->reg1 != X86_ECX)
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);

	x86_shrd_reg (s->code, tree->left->reg1, tree->left->reg2);
	x86_shift_reg (s->code, X86_SHR, tree->left->reg2);
	x86_test_reg_imm (s->code, X86_ECX, 32);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, FALSE);
	x86_mov_reg_reg (s->code, tree->left->reg1, tree->left->reg2, 4);
	x86_shift_reg_imm (s->code, X86_SHR, tree->reg2, 31);		
	x86_patch (br [0], s->code);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: SHL(lreg, CONST_I4) */
mono_burg_emit_185 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->right->data.i < 32) {
		x86_shld_reg_imm (s->code, tree->left->reg2, tree->left->reg1, tree->right->data.i);
		x86_shift_reg_imm (s->code, X86_SHL, tree->left->reg1, tree->right->data.i);
		if (tree->reg1 != tree->left->reg1)
			x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);
		if (tree->reg2 != tree->left->reg2)
			x86_mov_reg_reg (s->code, tree->reg2, tree->left->reg2, 4);
	} else if (tree->right->data.i < 64) {
		x86_mov_reg_reg (s->code, tree->reg2, tree->left->reg1, 4);
		x86_shift_reg_imm (s->code, X86_SHL, tree->reg2, (tree->right->data.i - 32));
		x86_alu_reg_reg (s->code, X86_XOR, tree->reg1, tree->reg1);	
	} /* else unspecified result */

}

static void /* lreg: SHL(lreg, reg) */
mono_burg_emit_186 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [1];

	if (tree->right->reg1 != X86_ECX)
		x86_mov_reg_reg (s->code, X86_ECX, tree->right->reg1, 4);

	x86_shld_reg (s->code, tree->left->reg2, tree->left->reg1);
	x86_shift_reg (s->code, X86_SHL, tree->left->reg1);
	x86_test_reg_imm (s->code, X86_ECX, 32);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_EQ, 0, FALSE);
	x86_mov_reg_reg (s->code, tree->left->reg2, tree->left->reg1, 4);
	x86_alu_reg_reg (s->code, X86_XOR, tree->left->reg1, tree->left->reg1);	
	x86_patch (br [0], s->code);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: ADD(lreg, lreg) */
mono_burg_emit_187 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_ADC, tree->left->reg2, tree->right->reg2);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: ADD_OVF(lreg, lreg) */
mono_burg_emit_188 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_ADC, tree->left->reg2, tree->right->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");	

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: ADD_OVF_UN(lreg, lreg) */
mono_burg_emit_189 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_ADD, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_ADC, tree->left->reg2, tree->right->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NC, FALSE, "OverflowException");	

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: SUB(lreg, lreg) */
mono_burg_emit_190 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_SBB, tree->left->reg2, tree->right->reg2);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: SUB_OVF(lreg, lreg) */
mono_burg_emit_191 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_SBB, tree->left->reg2, tree->right->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NO, TRUE, "OverflowException");	

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: SUB_OVF_UN(lreg, lreg) */
mono_burg_emit_192 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_SUB, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_SBB, tree->left->reg2, tree->right->reg2);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NC, FALSE, "OverflowException");	

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: AND(lreg, lreg) */
mono_burg_emit_193 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_AND, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_AND, tree->left->reg2, tree->right->reg2);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: OR(lreg, lreg) */
mono_burg_emit_194 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_OR, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_OR, tree->left->reg2, tree->right->reg2);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: XOR(lreg, lreg) */
mono_burg_emit_195 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_alu_reg_reg (s->code, X86_XOR, tree->left->reg1, tree->right->reg1);
	x86_alu_reg_reg (s->code, X86_XOR, tree->left->reg2, tree->right->reg2);

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

}

static void /* lreg: NEG(lreg) */
mono_burg_emit_196 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

	x86_neg_reg (s->code, tree->reg1);
	x86_alu_reg_imm (s->code, X86_ADC, tree->reg2, 0);
	x86_neg_reg (s->code, tree->reg2);

}

static void /* lreg: NOT(lreg) */
mono_burg_emit_197 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	MOVE_LREG (tree->reg1, tree->reg2, tree->left->reg1, tree->left->reg2);

	x86_not_reg (s->code, tree->reg1);
	x86_not_reg (s->code, tree->reg2);

}

static void /* lreg: MUL(lreg, lreg) */
mono_burg_emit_198 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_llmult);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		  tree->reg2 == X86_EDX);

}

static void /* lreg: MUL_OVF(lreg, lreg) */
mono_burg_emit_199 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	/* pass a pointer to store the resulting exception -
	 * ugly, but it works */
	x86_push_reg (s->code, X86_ESP); 
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_llmult_ovf);
	x86_call_code (s->code, 0);
	x86_mov_reg_membase (s->code, X86_ECX, X86_ESP, 4, 4);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);
	x86_alu_reg_imm (s->code, X86_CMP, X86_ECX, 0);

	/* cond. emit exception */
	x86_branch8 (s->code, X86_CC_EQ, 7, FALSE);                     
	x86_push_reg (s->code, X86_ECX);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, arch_get_throw_exception ());
	x86_call_code (s->code, 0);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: MUL_OVF_UN(lreg, lreg) */
mono_burg_emit_200 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	/* pass a pointer to store the resulting exception -
	 * ugly, but it works */
	x86_push_reg (s->code, X86_ESP); 
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_llmult_ovf_un);
	x86_call_code (s->code, 0);
	x86_mov_reg_membase (s->code, X86_ECX, X86_ESP, 4, 4);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);
	x86_alu_reg_imm (s->code, X86_CMP, X86_ECX, 0);

	/* cond. emit exception */
	x86_branch8 (s->code, X86_CC_EQ, 7, FALSE);                     
	x86_push_reg (s->code, X86_ECX);                                 
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, arch_get_throw_exception ());
	x86_call_code (s->code, 0);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: DIV(lreg, lreg) */
mono_burg_emit_201 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_lldiv);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: REM(lreg, lreg) */
mono_burg_emit_202 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_llrem);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: DIV_UN(lreg, lreg) */
mono_burg_emit_203 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_lldiv_un);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: REM_UN(lreg, lreg) */
mono_burg_emit_204 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_regset_reg_used (s->rs, X86_ECX)) 
		x86_push_reg (s->code, X86_ECX);

	x86_push_reg (s->code, tree->right->reg2);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_llrem_un);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	if (mono_regset_reg_used (s->rs, X86_ECX))
		x86_pop_reg (s->code, X86_ECX);

	mono_assert (tree->reg1 == X86_EAX &&
		     tree->reg2 == X86_EDX);

}

static void /* lreg: CALL_I8(this, reg) */
mono_burg_emit_205 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	
	if (lreg == treg || rreg == treg) 
		treg = X86_EDX;
	if (lreg == treg || rreg == treg) 
		treg = X86_ECX;
	if (lreg == treg || rreg == treg) 
		mono_assert_not_reached ();

	X86_CALL_BEGIN;

	x86_call_reg (s->code, rreg);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);
	mono_assert (tree->reg2 == X86_EDX);

}

static void /* lreg: CALL_I8(this, ADDR_G) */
mono_burg_emit_206 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;
	
	X86_CALL_BEGIN;

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->right->data.p);
	x86_call_code (s->code, 0);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);
	mono_assert (tree->reg2 == X86_EDX);

}

static void /* lreg: CALL_I8(this, VFUNC_ADDR) */
mono_burg_emit_207 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_call_virtual (s->code, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, vtable) + (tree->right->data.m->slot << 2));

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);
	mono_assert (tree->reg2 == X86_EDX);

}

static void /* lreg: CALL_I8(this, INTF_ADDR) */
mono_burg_emit_208 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_mov_reg_membase (s->code, lreg, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
	x86_mov_reg_membase (s->code, lreg, lreg, tree->right->data.m->klass->interface_id << 2, 4);
	x86_call_virtual (s->code, lreg, tree->right->data.m->slot << 2);

	X86_CALL_END;

	mono_assert (tree->reg1 == X86_EAX);
	mono_assert (tree->reg2 == X86_EDX);

}

static void /* stmt: RET(lreg) */
mono_burg_emit_209 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->left->reg1 != X86_EAX) {
		if (tree->left->reg2 != X86_EAX) {
			x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);
			if (tree->left->reg2 != X86_EDX)
				x86_mov_reg_reg (s->code, X86_EDX, tree->left->reg2, 4);
		} else { 
			x86_mov_reg_reg (s->code, X86_ECX, tree->left->reg2, 4);
			x86_mov_reg_reg (s->code, X86_EAX, tree->left->reg1, 4);
			x86_mov_reg_reg (s->code, X86_EDX, X86_ECX, 4);
		}
	} else if (tree->left->reg2 != X86_EDX) {
		x86_mov_reg_reg (s->code, X86_EDX, tree->left->reg2, 4);
	}

	if (!tree->last_instr) {
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_EPILOG, NULL);
		x86_jump32 (s->code, 0);      
	}

}

static void /* stmt: ARG_I8(lreg) */
mono_burg_emit_210 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);

}

static void /* reg: CSET(COMPARE(lreg, lreg)) */
mono_burg_emit_211 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [4];
	int lreg1, lreg2, rreg1, rreg2;

	lreg1 = tree->left->left->reg1;
	lreg2 = tree->left->left->reg2;
	rreg1 = tree->left->right->reg1;
	rreg2 = tree->left->right->reg2;


	if (tree->data.i == CEE_CEQ) {
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		x86_patch (br [0], s->code);
		x86_set_reg (s->code, X86_CC_EQ, tree->reg1, FALSE);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, FALSE);
		return;
	}

	switch (tree->data.i) {
	case CEE_CGT:
		x86_alu_reg_reg (s->code, X86_CMP, rreg2, lreg2);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_GT, 0, TRUE);
		br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, rreg1, lreg1);
		br [2] = s->code; x86_branch8 (s->code, X86_CC_GE, 0, FALSE);
		break;
	case CEE_CGT_UN:
		x86_alu_reg_reg (s->code, X86_CMP, rreg2, lreg2);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_GT, 0, FALSE);
		br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, rreg1, lreg1);
		br [2] = s->code; x86_branch8 (s->code, X86_CC_GE, 0, FALSE);
		break;
	case CEE_CLT:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_GT, 0, TRUE);
		br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		br [2] = s->code; x86_branch8 (s->code, X86_CC_GE, 0, FALSE);
		break;
	case CEE_CLT_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_GT, 0, FALSE);
		br [1] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		br [2] = s->code; x86_branch8 (s->code, X86_CC_GE, 0, FALSE);
		break;
	default:
		g_assert_not_reached ();
	}

	/* set result to 1 */
	x86_patch (br [1], s->code);
	x86_mov_reg_imm (s->code, tree->reg1, 1);
	br [3] = s->code; x86_jump8 (s->code, 0);

	/* set result to 0 */
	x86_patch (br [0], s->code);
	x86_patch (br [2], s->code);
	x86_mov_reg_imm (s->code, tree->reg1, 0);	

	x86_patch (br [3], s->code);

}

static void /* stmt: CBRANCH(COMPARE(lreg, lreg)) */
mono_burg_emit_212 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br [1];
	int lreg1, lreg2, rreg1, rreg2;

	lreg1 = tree->left->left->reg1;
	lreg2 = tree->left->left->reg2;
	rreg1 = tree->left->right->reg1;
	rreg2 = tree->left->right->reg2;

	switch (tree->data.bi.cond) {
	case CEE_BLT:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, TRUE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BLT_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, FALSE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BGT:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, TRUE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BGT_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, FALSE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BEQ:
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, TRUE);
		x86_patch (br [0], s->code);
		break;
	case CEE_BNE_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BGE:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GE, 0, FALSE);
		x86_patch (br [0], s->code);
		break;
	case CEE_BGE_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GT, 0, FALSE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_GE, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BLE:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, TRUE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, TRUE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LE, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	case CEE_BLE_UN:
		x86_alu_reg_reg (s->code, X86_CMP, lreg2, rreg2);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LT, 0, FALSE);
		br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);
		x86_alu_reg_reg (s->code, X86_CMP, lreg1, rreg1);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_LE, 0, FALSE);
		x86_patch (br [0], s->code);	
		break;
	default:
		g_assert_not_reached ();
	}	

}

static void /* reg: CONV_I1(freg) */
mono_burg_emit_213 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, TRUE, FALSE);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, TRUE, FALSE);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CONV_U1(freg) */
mono_burg_emit_214 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, FALSE);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, FALSE);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CONV_I2(freg) */
mono_burg_emit_215 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, TRUE, TRUE);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, TRUE, TRUE);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CONV_U2(freg) */
mono_burg_emit_216 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, TRUE);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_widen_reg (s->code, tree->reg1, tree->reg1, FALSE, TRUE);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CONV_I4(freg) */
mono_burg_emit_217 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CONV_U4(freg) */
mono_burg_emit_218 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv(s, tree);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_push_reg (s->code, X86_EAX); // SP = SP - 4
		x86_fist_pop_membase (s->code, X86_ESP, 0, FALSE);
		x86_pop_reg (s->code, tree->reg1);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* lreg: CONV_I8(freg) */
mono_burg_emit_219 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv_i8(s, tree);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 8);
		x86_fist_pop_membase (s->code, X86_ESP, 0, TRUE);
		x86_pop_reg (s->code, tree->reg1);
		x86_pop_reg (s->code, tree->reg2);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* lreg: CONV_U8(freg) */
mono_burg_emit_220 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (mono_use_fast_iconv) {
		mono_emit_fast_iconv_i8(s, tree);
	} else {
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
		x86_fnstcw_membase(s->code, X86_ESP, 0);
		x86_mov_reg_membase (s->code, tree->reg1, X86_ESP, 0, 2);
		x86_alu_reg_imm (s->code, X86_OR, tree->reg1, 0xc00);
		x86_mov_membase_reg (s->code, X86_ESP, 2, tree->reg1, 2);
		x86_fldcw_membase (s->code, X86_ESP, 2);
		x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 8);
		x86_fist_pop_membase (s->code, X86_ESP, 0, TRUE);
		x86_pop_reg (s->code, tree->reg1);
		x86_pop_reg (s->code, tree->reg2);
		x86_fldcw_membase (s->code, X86_ESP, 0);
		x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);
	}

}

static void /* reg: CSET(COMPARE(freg, freg)) */
mono_burg_emit_221 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = tree->reg1;

	if (treg != X86_EAX)
		x86_push_reg (s->code, X86_EAX);

	x86_fcompp (s->code);
	x86_fnstsw (s->code);
	x86_alu_reg_imm (s->code, X86_AND, X86_EAX, 0x4500);

	switch (tree->data.i) {
	case CEE_CEQ:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x4000);
		x86_set_reg (s->code, X86_CC_EQ, treg, TRUE);
		x86_widen_reg (s->code, treg, treg, FALSE, FALSE);
		break;
	case CEE_CGT:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		x86_set_reg (s->code, X86_CC_EQ, treg, TRUE);
		x86_widen_reg (s->code, treg, treg, FALSE, FALSE);
		break;
	case CEE_CGT_UN:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		x86_set_reg (s->code, X86_CC_EQ, treg, TRUE);
		x86_widen_reg (s->code, treg, treg, FALSE, FALSE);
		break;
	case CEE_CLT:
		x86_set_reg (s->code, X86_CC_EQ, treg, TRUE);
		x86_widen_reg (s->code, treg, treg, FALSE, FALSE);
		break;
	case CEE_CLT_UN:
		x86_set_reg (s->code, X86_CC_EQ, tree->reg1, TRUE);
		x86_widen_reg (s->code, treg, treg, FALSE, FALSE);
		break;
	default:
		g_assert_not_reached ();
	}
	
	if (treg != X86_EAX)
		x86_pop_reg (s->code, X86_EAX);

}

static void /* freg: CONV_R8(freg) */
mono_burg_emit_222 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* nothing to do */

}

static void /* freg: CONV_R4(freg) */
mono_burg_emit_223 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	/* fixme: nothing to do ??*/

}

static void /* freg: CONV_R8(LDIND_I4(ADDR_G)) */
mono_burg_emit_224 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fild (s->code, tree->left->left->data.p, FALSE);

}

static void /* freg: CONV_R4(reg) */
mono_burg_emit_225 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, FALSE);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);

}

static void /* freg: CONV_R8(reg) */
mono_burg_emit_226 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, FALSE);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 4);

}

static void /* freg: CONV_R_UN(reg) */
mono_burg_emit_227 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_imm (s->code, 0);
	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, TRUE);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

}

static void /* freg: CONV_R_UN(lreg) */
mono_burg_emit_228 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	static guint8 mn[] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x3f, 0x40 };
	guint8 *br [1];

	/* load 64bit integer to FP stack */
	x86_push_imm (s->code, 0);
	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, TRUE);
	/* store as 80bit FP value */
	x86_fst80_membase (s->code, X86_ESP, 0);

	/* test if lreg is negative */
	x86_test_reg_reg (s->code, tree->left->reg2, tree->left->reg2);
	br [0] = s->code; x86_branch8 (s->code, X86_CC_GEZ, 0, TRUE);

	/* add correction constant mn */
	x86_fld80_mem (s->code, mn);
	x86_fld80_membase (s->code, X86_ESP, 0);
	x86_fp_op_reg (s->code, X86_FADD, 1, TRUE);
	x86_fst80_membase (s->code, X86_ESP, 0);
	//x86_breakpoint (s->code);
	x86_patch (br [0], s->code);

	x86_fld80_membase (s->code, X86_ESP, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

}

static void /* freg: CONV_R4(lreg) */
mono_burg_emit_229 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, TRUE);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

}

static void /* freg: CONV_R8(lreg) */
mono_burg_emit_230 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, tree->left->reg2);
	x86_push_reg (s->code, tree->left->reg1);
	x86_fild_membase (s->code, X86_ESP, 0, TRUE);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 8);

}

static void /* freg: CONST_R4 */
mono_burg_emit_231 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	float f = *(float *)tree->data.p;

	if (f == 0.0)
		x86_fldz (s->code);
	else if (f == 1.0)
		x86_fld1(s->code);
	else
		x86_fld (s->code, tree->data.p, FALSE);

}

static void /* freg: CONST_R8 */
mono_burg_emit_232 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	double d = *(double *)tree->data.p;

	if (d == 0.0)
		x86_fldz (s->code);
	else if (d == 1.0)
		x86_fld1(s->code);
	else
		x86_fld (s->code, tree->data.p, TRUE);

}

static void /* freg: LDIND_R4(addr) */
mono_burg_emit_233 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_fld (s->code, tree->left->data.ainfo.offset, FALSE);
		break;

	case AMBase:
		x86_fld_membase (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset, FALSE);
		break;		
	case AMIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, X86_NOBASEREG, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fld_membase (s->code, tree->left->data.ainfo.indexreg, 0, FALSE);
		break;		
	case AMBaseIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, tree->left->data.ainfo.basereg, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fld_membase (s->code, tree->left->data.ainfo.indexreg, 0, FALSE);
		break;		
	}

}

static void /* freg: LDIND_R8(addr) */
mono_burg_emit_234 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_fld (s->code, tree->left->data.ainfo.offset, TRUE);
		break;

	case AMBase:
		x86_fld_membase (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset, TRUE);
		break;		
	case AMIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, X86_NOBASEREG, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fld_membase (s->code, tree->left->data.ainfo.indexreg, 0, TRUE);
		break;		
	case AMBaseIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, tree->left->data.ainfo.basereg, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fld_membase (s->code, tree->left->data.ainfo.indexreg, 0, TRUE);
		break;		
	}

}

static void /* freg: ADD(freg, freg) */
mono_burg_emit_235 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fp_op_reg (s->code, X86_FADD, 1, TRUE);

}

static void /* freg: SUB(freg, freg) */
mono_burg_emit_236 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fp_op_reg (s->code, X86_FSUB, 1, TRUE);

}

static void /* freg: MUL(freg, freg) */
mono_burg_emit_237 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fp_op_reg (s->code, X86_FMUL, 1, TRUE);

}

static void /* freg: DIV(freg, freg) */
mono_burg_emit_238 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fp_op_reg (s->code, X86_FDIV, 1, TRUE);

}

static void /* freg: CKFINITE(freg) */
mono_burg_emit_239 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_push_reg (s->code, X86_EAX);
	x86_fxam (s->code);
	x86_fnstsw (s->code);
	x86_alu_reg_imm (s->code, X86_AND, X86_EAX, 0x4100);
	x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
	x86_pop_reg (s->code, X86_EAX);
	EMIT_COND_SYSTEM_EXCEPTION (X86_CC_NE, FALSE, "ArithmeticException");

}

static void /* freg: REM(freg, freg) */
mono_burg_emit_240 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *l1, *l2;

	/* we need to exchange ST(0) with ST(1) */
	x86_fxch (s->code, 1);

	/* this requires a loop, because fprem1 somtimes 
	 * returns a partial remainder */
	l1 = s->code;
	x86_fprem1 (s->code);
	x86_fnstsw (s->code);
	x86_alu_reg_imm (s->code, X86_AND, X86_EAX, 0x0400);
	l2 = s->code + 2;
	x86_branch8 (s->code, X86_CC_NE, l1 - l2, FALSE);

	/* pop result */
	x86_fstp (s->code, 1);

}

static void /* freg: NEG(freg) */
mono_burg_emit_241 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fchs (s->code);

}

static void /* stmt: STIND_R4(addr, freg) */
mono_burg_emit_243 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_fst (s->code, tree->left->data.ainfo.offset, FALSE, TRUE);
		break;

	case AMBase:
		x86_fst_membase (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset, 
				 FALSE, TRUE);
		break;		
	case AMIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, X86_NOBASEREG, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fst_membase (s->code, tree->left->data.ainfo.indexreg, 0, FALSE, TRUE);
		break;		
	case AMBaseIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, tree->left->data.ainfo.basereg, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fst_membase (s->code, tree->left->data.ainfo.indexreg, 0, FALSE, TRUE);
		break;		
	}

}

static void /* stmt: STIND_R8(addr, freg) */
mono_burg_emit_244 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	switch (tree->left->data.ainfo.amode) {

	case AMImmediate:
		x86_fst (s->code, tree->left->data.ainfo.offset, TRUE, TRUE);
		break;

	case AMBase:
		x86_fst_membase (s->code, tree->left->data.ainfo.basereg, tree->left->data.ainfo.offset, 
				 TRUE, TRUE);
		break;		
	case AMIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, X86_NOBASEREG, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fst_membase (s->code, tree->left->data.ainfo.indexreg, 0, TRUE, TRUE);
		break;		
	case AMBaseIndex:
		x86_lea_memindex (s->code, tree->left->data.ainfo.indexreg, tree->left->data.ainfo.basereg, 
				  tree->left->data.ainfo.offset, tree->left->data.ainfo.indexreg, 
				  tree->left->data.ainfo.shift);
		x86_fst_membase (s->code, tree->left->data.ainfo.indexreg, 0, TRUE, TRUE);
		break;		
	}

}

static void /* stmt: REMOTE_STIND_R4(reg, freg) */
mono_burg_emit_245 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int offset;

	if (lreg == treg)
		treg = X86_EDX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE); 

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4);
	x86_fst_membase (s->code, X86_ESP, 0, FALSE, TRUE);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 20);

	br [1] = s->code; x86_jump8 (s->code, 0); 

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_fst_membase (s->code, lreg, offset, FALSE, TRUE);

	x86_patch (br [1], s->code);

}

static void /* stmt: REMOTE_STIND_R8(reg, freg) */
mono_burg_emit_246 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int offset;

	if (lreg == treg)
		treg = X86_EDX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE); 

	/* this is a transparent proxy - remote the call */

	/* save value to stack */
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 8);
	x86_fst_membase (s->code, X86_ESP, 0, TRUE, TRUE);

	x86_push_reg (s->code, X86_ESP);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 24);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);
	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;
	x86_fst_membase (s->code, lreg, offset, TRUE, TRUE);

	x86_patch (br [1], s->code);

}

static void /* stmt: ARG_R4(freg) */
mono_burg_emit_247 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 4 + pad);
	x86_fst_membase (s->code, X86_ESP, 0, FALSE, TRUE);

}

static void /* stmt: ARG_R8(freg) */
mono_burg_emit_248 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 8 + pad);
	x86_fst_membase (s->code, X86_ESP, 0, TRUE, TRUE);

}

static void /* stmt: CBRANCH(COMPARE(freg, freg)) */
mono_burg_emit_249 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{


	x86_fcompp (s->code);
	x86_fnstsw (s->code);
	x86_alu_reg_imm (s->code, X86_AND, X86_EAX, 0x4500);

	switch (tree->data.bi.cond) {
	case CEE_BLT:
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, FALSE);
		break;
	case CEE_BLT_UN:
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, FALSE);
		break;
	case CEE_BGT:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, FALSE);
		break;
	case CEE_BGT_UN:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, FALSE);
		break;
	case CEE_BEQ:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x4000);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_EQ, 0, TRUE);
		break;
	case CEE_BNE_UN:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x4000);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BGE:
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BGE_UN:
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BLE:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	case CEE_BLE_UN:
		x86_alu_reg_imm (s->code, X86_CMP, X86_EAX, 0x0100);
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_BB, tree->data.bi.target);
		x86_branch32 (s->code, X86_CC_NE, 0, FALSE);
		break;
	default:
		g_assert_not_reached ();
	}

}

static void /* freg: CALL_R8(this, reg) */
mono_burg_emit_250 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	
	if (lreg == treg || rreg == treg) 
		treg = X86_EDX;
	if (lreg == treg || rreg == treg) 
		treg = X86_ECX;
	if (lreg == treg || rreg == treg) 
		mono_assert_not_reached ();

	X86_CALL_BEGIN;

	x86_call_reg (s->code, rreg);

	X86_CALL_END;

}

static void /* freg: CALL_R8(this, ADDR_G) */
mono_burg_emit_251 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;
	
	X86_CALL_BEGIN;

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, tree->right->data.p);
	x86_call_code (s->code, 0);

	X86_CALL_END;

}

static void /* freg: CALL_R8(this, INTF_ADDR) */
mono_burg_emit_252 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_mov_reg_membase (s->code, lreg, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, interface_offsets), 4);
	x86_mov_reg_membase (s->code, lreg, lreg, tree->right->data.m->klass->interface_id << 2, 4);
	x86_call_virtual (s->code, lreg, tree->right->data.m->slot << 2);

	X86_CALL_END;

}

static void /* freg: CALL_R8(this, VFUNC_ADDR) */
mono_burg_emit_253 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int lreg = tree->left->reg1;
	int treg = X86_EAX;

	if (lreg == treg) 
		treg = X86_EDX;

	X86_CALL_BEGIN;

	x86_mov_reg_membase (s->code, lreg, lreg, 0, 4);
	x86_call_virtual (s->code, lreg, 
	        G_STRUCT_OFFSET (MonoVTable, vtable) + (tree->right->data.m->slot << 2));

	X86_CALL_END;

}

static void /* stmt: RET(freg) */
mono_burg_emit_254 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (!tree->last_instr) {
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_EPILOG, NULL);
		x86_jump32 (s->code, 0);      
	}

}

static void /* freg: SIN(freg) */
mono_burg_emit_255 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fsin (s->code);

}

static void /* freg: COS(freg) */
mono_burg_emit_256 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fcos (s->code);

}

static void /* freg: SQRT(freg) */
mono_burg_emit_257 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	x86_fsqrt (s->code);

}

static void /* reg: LDIND_OBJ(reg) */
mono_burg_emit_258 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	if (tree->left->reg1 != tree->reg1)
		x86_mov_reg_reg (s->code, tree->reg1, tree->left->reg1, 4);

}

static void /* stmt: STIND_OBJ(reg, reg) */
mono_burg_emit_259 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	mono_assert (tree->data.i > 0);

	x86_push_imm (s->code, tree->data.i);
	x86_push_reg (s->code, tree->right->reg1);
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, MEMCOPY);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

}

static void /* stmt: REMOTE_STIND_OBJ(reg, reg) */
mono_burg_emit_260 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	guint8 *br[2];
	int treg = X86_EAX;
	int lreg = tree->left->reg1;
	int rreg = tree->right->reg1;
	int size, offset;

	if (lreg == treg)
		treg = X86_EDX;

	if (rreg == treg)
		treg = X86_ECX;

	x86_mov_reg_membase (s->code, treg, lreg, 0, 4);
	x86_alu_membase_imm (s->code, X86_CMP, treg, 0, ((int)mono_defaults.transparent_proxy_class));
	br [0] = s->code; x86_branch8 (s->code, X86_CC_NE, 0, FALSE);

	/* this is a transparent proxy - remote the call */

	x86_push_reg (s->code, rreg);
	x86_push_imm (s->code, tree->data.fi.field);
	x86_push_imm (s->code, tree->data.fi.klass);
	x86_push_reg (s->code, lreg);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, mono_store_remote_field);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 16);

	br [1] = s->code; x86_jump8 (s->code, 0);

	x86_patch (br [0], s->code);

	offset = tree->data.fi.klass->valuetype ? tree->data.fi.field->offset - sizeof (MonoObject) : 
		tree->data.fi.field->offset;

	size = mono_class_value_size (tree->data.fi.field->type->data.klass, NULL);
	x86_push_imm (s->code, size);
	x86_push_reg (s->code, tree->right->reg1);
	x86_alu_reg_imm (s->code, X86_ADD, tree->left->reg1, offset);	
	x86_push_reg (s->code, tree->left->reg1);
	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, MEMCOPY);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

	x86_patch (br [1], s->code);

}

static void /* stmt: ARG_OBJ(CONST_I4) */
mono_burg_emit_261 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int pad = tree->data.arg_info.pad;

	X86_ARG_PAD (pad);
	x86_push_imm (s->code, tree->left->data.i);	

}

static void /* stmt: ARG_OBJ(reg) */
mono_burg_emit_262 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int size = tree->data.arg_info.size;
	int pad = tree->data.arg_info.pad;
	int sa;
	
	if (!size) 
		return;

	sa = size + pad;

	/* reserve space for the argument */
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, sa);

	x86_push_reg (s->code, X86_EAX);
	x86_push_reg (s->code, X86_EDX);
	x86_push_reg (s->code, X86_ECX);

	x86_push_imm (s->code, size);
	x86_push_reg (s->code, tree->left->reg1);
	x86_lea_membase (s->code, X86_EAX, X86_ESP, 5*4);
	x86_push_reg (s->code, X86_EAX);

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, MEMCOPY);
	x86_call_code (s->code, 0);
	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

	x86_pop_reg (s->code, X86_ECX);
	x86_pop_reg (s->code, X86_EDX);
	x86_pop_reg (s->code, X86_EAX);

}

static void /* stmt: RET_OBJ(reg) */
mono_burg_emit_263 (MBTREE_TYPE *tree, MBCGEN_TYPE *s)
{

	int size = tree->data.i;

	x86_push_imm (s->code, size);
	x86_push_reg (s->code, tree->left->reg1);
	x86_push_membase (s->code, X86_EBP, 8);

	mono_add_jump_info (s, s->code, MONO_JUMP_INFO_ABS, MEMCOPY);
	x86_call_code (s->code, 0);

	x86_alu_reg_imm (s->code, X86_ADD, X86_ESP, 12);

	if (!tree->last_instr) {
		mono_add_jump_info (s, s->code, MONO_JUMP_INFO_EPILOG, NULL);
		x86_jump32 (s->code, 0);      
	}

}

MBEmitFunc const mono_burg_func [] = {
	NULL,
	mono_burg_emit_0,
	mono_burg_emit_1,
	mono_burg_emit_2,
	NULL,
	mono_burg_emit_4,
	mono_burg_emit_5,
	mono_burg_emit_6,
	mono_burg_emit_7,
	mono_burg_emit_8,
	mono_burg_emit_9,
	NULL,
	NULL,
	mono_burg_emit_12,
	mono_burg_emit_13,
	mono_burg_emit_14,
	mono_burg_emit_15,
	mono_burg_emit_16,
	mono_burg_emit_17,
	mono_burg_emit_18,
	mono_burg_emit_19,
	mono_burg_emit_20,
	mono_burg_emit_21,
	mono_burg_emit_22,
	mono_burg_emit_23,
	mono_burg_emit_24,
	mono_burg_emit_25,
	mono_burg_emit_26,
	mono_burg_emit_27,
	mono_burg_emit_28,
	mono_burg_emit_29,
	mono_burg_emit_30,
	mono_burg_emit_31,
	mono_burg_emit_32,
	mono_burg_emit_33,
	mono_burg_emit_34,
	mono_burg_emit_35,
	mono_burg_emit_36,
	mono_burg_emit_37,
	mono_burg_emit_38,
	mono_burg_emit_39,
	mono_burg_emit_40,
	mono_burg_emit_41,
	mono_burg_emit_42,
	mono_burg_emit_43,
	mono_burg_emit_44,
	mono_burg_emit_45,
	mono_burg_emit_46,
	mono_burg_emit_47,
	mono_burg_emit_48,
	mono_burg_emit_49,
	mono_burg_emit_50,
	mono_burg_emit_51,
	mono_burg_emit_52,
	mono_burg_emit_53,
	mono_burg_emit_54,
	mono_burg_emit_55,
	mono_burg_emit_56,
	mono_burg_emit_57,
	mono_burg_emit_58,
	mono_burg_emit_59,
	mono_burg_emit_60,
	mono_burg_emit_61,
	mono_burg_emit_62,
	mono_burg_emit_63,
	mono_burg_emit_64,
	mono_burg_emit_65,
	mono_burg_emit_66,
	mono_burg_emit_67,
	mono_burg_emit_68,
	mono_burg_emit_69,
	mono_burg_emit_70,
	mono_burg_emit_71,
	mono_burg_emit_72,
	mono_burg_emit_73,
	mono_burg_emit_74,
	mono_burg_emit_75,
	mono_burg_emit_76,
	mono_burg_emit_77,
	mono_burg_emit_78,
	mono_burg_emit_79,
	mono_burg_emit_80,
	mono_burg_emit_81,
	mono_burg_emit_82,
	mono_burg_emit_83,
	mono_burg_emit_84,
	mono_burg_emit_85,
	mono_burg_emit_86,
	mono_burg_emit_87,
	mono_burg_emit_88,
	mono_burg_emit_89,
	mono_burg_emit_90,
	mono_burg_emit_91,
	mono_burg_emit_92,
	mono_burg_emit_93,
	mono_burg_emit_94,
	mono_burg_emit_95,
	mono_burg_emit_96,
	mono_burg_emit_97,
	mono_burg_emit_98,
	mono_burg_emit_99,
	mono_burg_emit_100,
	mono_burg_emit_101,
	mono_burg_emit_102,
	mono_burg_emit_103,
	mono_burg_emit_104,
	mono_burg_emit_105,
	mono_burg_emit_106,
	mono_burg_emit_107,
	mono_burg_emit_108,
	mono_burg_emit_109,
	mono_burg_emit_110,
	mono_burg_emit_111,
	mono_burg_emit_112,
	mono_burg_emit_113,
	mono_burg_emit_114,
	mono_burg_emit_115,
	mono_burg_emit_116,
	mono_burg_emit_117,
	mono_burg_emit_118,
	NULL,
	NULL,
	mono_burg_emit_121,
	mono_burg_emit_122,
	mono_burg_emit_123,
	mono_burg_emit_124,
	mono_burg_emit_125,
	mono_burg_emit_126,
	mono_burg_emit_127,
	mono_burg_emit_128,
	mono_burg_emit_129,
	mono_burg_emit_130,
	mono_burg_emit_131,
	mono_burg_emit_132,
	mono_burg_emit_133,
	mono_burg_emit_134,
	mono_burg_emit_135,
	mono_burg_emit_136,
	mono_burg_emit_137,
	mono_burg_emit_138,
	mono_burg_emit_139,
	mono_burg_emit_140,
	mono_burg_emit_141,
	mono_burg_emit_142,
	mono_burg_emit_143,
	mono_burg_emit_144,
	NULL,
	mono_burg_emit_146,
	mono_burg_emit_147,
	mono_burg_emit_148,
	mono_burg_emit_149,
	mono_burg_emit_150,
	mono_burg_emit_151,
	mono_burg_emit_152,
	mono_burg_emit_153,
	mono_burg_emit_154,
	mono_burg_emit_155,
	mono_burg_emit_156,
	mono_burg_emit_157,
	mono_burg_emit_158,
	mono_burg_emit_159,
	mono_burg_emit_160,
	mono_burg_emit_161,
	mono_burg_emit_162,
	mono_burg_emit_163,
	mono_burg_emit_164,
	mono_burg_emit_165,
	mono_burg_emit_166,
	mono_burg_emit_167,
	NULL,
	mono_burg_emit_169,
	mono_burg_emit_170,
	mono_burg_emit_171,
	mono_burg_emit_172,
	mono_burg_emit_173,
	mono_burg_emit_174,
	mono_burg_emit_175,
	mono_burg_emit_176,
	mono_burg_emit_177,
	mono_burg_emit_178,
	mono_burg_emit_179,
	mono_burg_emit_180,
	mono_burg_emit_181,
	mono_burg_emit_182,
	mono_burg_emit_183,
	mono_burg_emit_184,
	mono_burg_emit_185,
	mono_burg_emit_186,
	mono_burg_emit_187,
	mono_burg_emit_188,
	mono_burg_emit_189,
	mono_burg_emit_190,
	mono_burg_emit_191,
	mono_burg_emit_192,
	mono_burg_emit_193,
	mono_burg_emit_194,
	mono_burg_emit_195,
	mono_burg_emit_196,
	mono_burg_emit_197,
	mono_burg_emit_198,
	mono_burg_emit_199,
	mono_burg_emit_200,
	mono_burg_emit_201,
	mono_burg_emit_202,
	mono_burg_emit_203,
	mono_burg_emit_204,
	mono_burg_emit_205,
	mono_burg_emit_206,
	mono_burg_emit_207,
	mono_burg_emit_208,
	mono_burg_emit_209,
	mono_burg_emit_210,
	mono_burg_emit_211,
	mono_burg_emit_212,
	mono_burg_emit_213,
	mono_burg_emit_214,
	mono_burg_emit_215,
	mono_burg_emit_216,
	mono_burg_emit_217,
	mono_burg_emit_218,
	mono_burg_emit_219,
	mono_burg_emit_220,
	mono_burg_emit_221,
	mono_burg_emit_222,
	mono_burg_emit_223,
	mono_burg_emit_224,
	mono_burg_emit_225,
	mono_burg_emit_226,
	mono_burg_emit_227,
	mono_burg_emit_228,
	mono_burg_emit_229,
	mono_burg_emit_230,
	mono_burg_emit_231,
	mono_burg_emit_232,
	mono_burg_emit_233,
	mono_burg_emit_234,
	mono_burg_emit_235,
	mono_burg_emit_236,
	mono_burg_emit_237,
	mono_burg_emit_238,
	mono_burg_emit_239,
	mono_burg_emit_240,
	mono_burg_emit_241,
	NULL,
	mono_burg_emit_243,
	mono_burg_emit_244,
	mono_burg_emit_245,
	mono_burg_emit_246,
	mono_burg_emit_247,
	mono_burg_emit_248,
	mono_burg_emit_249,
	mono_burg_emit_250,
	mono_burg_emit_251,
	mono_burg_emit_252,
	mono_burg_emit_253,
	mono_burg_emit_254,
	mono_burg_emit_255,
	mono_burg_emit_256,
	mono_burg_emit_257,
	mono_burg_emit_258,
	mono_burg_emit_259,
	mono_burg_emit_260,
	mono_burg_emit_261,
	mono_burg_emit_262,
	mono_burg_emit_263,
};

const int mono_burg_decode_stmt[] = {
	0,
	15,
	16,
	17,
	18,
	19,
	20,
	21,
	22,
	23,
	24,
	25,
	26,
	27,
	28,
	29,
	30,
	32,
	33,
	34,
	107,
	108,
	109,
	115,
	116,
	117,
	118,
	119,
	120,
	121,
	122,
	129,
	130,
	131,
	132,
	133,
	134,
	135,
	136,
	137,
	138,
	139,
	140,
	141,
	144,
	145,
	154,
	155,
	156,
	157,
	158,
	169,
	179,
	180,
	210,
	211,
	213,
	243,
	244,
	245,
	246,
	247,
	248,
	249,
	250,
	255,
	260,
	261,
	262,
	263,
	264,
};

const int mono_burg_decode_acon[] = {
	0,
	1,
	2,
	3,
};

const int mono_burg_decode_base[] = {
	0,
	4,
	5,
	6,
	7,
};

const int mono_burg_decode_reg[] = {
	0,
	14,
	31,
	35,
	36,
	37,
	38,
	39,
	40,
	41,
	42,
	43,
	44,
	45,
	46,
	47,
	48,
	49,
	50,
	51,
	52,
	53,
	54,
	55,
	56,
	57,
	58,
	59,
	60,
	61,
	62,
	63,
	64,
	65,
	66,
	67,
	68,
	69,
	70,
	71,
	72,
	73,
	74,
	75,
	76,
	77,
	78,
	79,
	80,
	81,
	82,
	83,
	84,
	85,
	86,
	87,
	88,
	89,
	90,
	91,
	92,
	93,
	94,
	95,
	96,
	97,
	98,
	99,
	100,
	101,
	102,
	103,
	104,
	105,
	106,
	110,
	111,
	112,
	113,
	114,
	143,
	147,
	148,
	149,
	150,
	151,
	152,
	153,
	159,
	160,
	161,
	162,
	163,
	164,
	165,
	166,
	167,
	168,
	212,
	214,
	215,
	216,
	217,
	218,
	219,
	222,
	259,
};

const int mono_burg_decode_index[] = {
	0,
	8,
	9,
	10,
};

const int mono_burg_decode_addr[] = {
	0,
	11,
	12,
	13,
};

const int mono_burg_decode_cflags[] = {
	0,
	123,
	124,
	125,
	126,
	127,
	128,
};

const int mono_burg_decode_this[] = {
	0,
	142,
	146,
};

const int mono_burg_decode_lreg[] = {
	0,
	170,
	171,
	172,
	173,
	174,
	175,
	176,
	177,
	178,
	181,
	182,
	183,
	184,
	185,
	186,
	187,
	188,
	189,
	190,
	191,
	192,
	193,
	194,
	195,
	196,
	197,
	198,
	199,
	200,
	201,
	202,
	203,
	204,
	205,
	206,
	207,
	208,
	209,
	220,
	221,
};

const int mono_burg_decode_freg[] = {
	0,
	223,
	224,
	225,
	226,
	227,
	228,
	229,
	230,
	231,
	232,
	233,
	234,
	235,
	236,
	237,
	238,
	239,
	240,
	241,
	242,
	251,
	252,
	253,
	254,
	256,
	257,
	258,
};

static void closure_acon (MBState *p, int c);
static void closure_base (MBState *p, int c);
static void closure_reg (MBState *p, int c);
static void closure_index (MBState *p, int c);

static void
closure_acon (MBState *p, int c)
{
	/* base: acon */
	if (c + 0 < p->cost[MB_NTERM_base]) {
		p->cost[MB_NTERM_base] = c + 0;
		p->rule_base = 1;
		closure_base (p, c + 0);
	}
}

static void
closure_base (MBState *p, int c)
{
	/* addr: base */
	if (c + 0 < p->cost[MB_NTERM_addr]) {
		p->cost[MB_NTERM_addr] = c + 0;
		p->rule_addr = 1;
	}
}

static void
closure_reg (MBState *p, int c)
{
	/* base: reg */
	if (c + 0 < p->cost[MB_NTERM_base]) {
		p->cost[MB_NTERM_base] = c + 0;
		p->rule_base = 2;
		closure_base (p, c + 0);
	}
	/* index: reg */
	if (c + 0 < p->cost[MB_NTERM_index]) {
		p->cost[MB_NTERM_index] = c + 0;
		p->rule_index = 1;
		closure_index (p, c + 0);
	}
	/* this: reg */
	if (c + 0 < p->cost[MB_NTERM_this]) {
		p->cost[MB_NTERM_this] = c + 0;
		p->rule_this = 1;
	}
}

static void
closure_index (MBState *p, int c)
{
	/* addr: index */
	if (c + 0 < p->cost[MB_NTERM_addr]) {
		p->cost[MB_NTERM_addr] = c + 0;
		p->rule_addr = 2;
	}
}

static MBState *
mono_burg_label_priv (MBTREE_TYPE *tree, MBCOST_DATA *data) {
	int arity;
	int c;
	MBState *p, *left, *right;

	switch (mono_burg_arity [MBTREE_OP(tree)]) {
	case 0:
		left = NULL;
		right = NULL;
		break;
	case 1:
		left = mono_burg_label_priv (MBTREE_LEFT(tree), data);
		right = NULL;
		break;
	case 2:
		left = mono_burg_label_priv (MBTREE_LEFT(tree), data);
		right = mono_burg_label_priv (MBTREE_RIGHT(tree), data);
	}

	arity = (left != NULL) + (right != NULL);
	g_assert (arity == mono_burg_arity [MBTREE_OP(tree)]);

	p = MBALLOC_STATE;
	memset (p, 0, sizeof (MBState));
	p->op = MBTREE_OP(tree);
	p->left = left;
	p->right = right;
	p->cost [1] = 32767;
	p->cost [2] = 32767;
	p->cost [3] = 32767;
	p->cost [4] = 32767;
	p->cost [5] = 32767;
	p->cost [6] = 32767;
	p->cost [7] = 32767;
	p->cost [8] = 32767;
	p->cost [9] = 32767;
	p->cost [10] = 32767;

	switch (MBTREE_OP(tree)) {
	case 1: /* CONST_I4 */
		/* acon: CONST_I4 */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_acon]) {
				p->cost[MB_NTERM_acon] = c;
				p->rule_acon = 1;
				closure_acon (p, c);
			}
		}
		/* reg: CONST_I4 */
		{
			c = 1;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 15;
				closure_reg (p, c);
			}
		}
		break;
	case 2: /* CONST_I8 */
		/* lreg: CONST_I8 */
		{
			c = 1;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 1;
			}
		}
		break;
	case 3: /* CONST_R4 */
		/* freg: CONST_R4 */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 10;
			}
		}
		break;
	case 4: /* CONST_R8 */
		/* freg: CONST_R8 */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 11;
			}
		}
		break;
	case 5: /* LDIND_I1 */
		/* reg: LDIND_I1(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 4;
				closure_reg (p, c);
			}
		}
		break;
	case 6: /* LDIND_U1 */
		/* reg: LDIND_U1(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 5;
				closure_reg (p, c);
			}
		}
		break;
	case 7: /* LDIND_I2 */
		/* reg: LDIND_I2(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 6;
				closure_reg (p, c);
			}
		}
		break;
	case 8: /* LDIND_U2 */
		/* reg: LDIND_U2(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 7;
				closure_reg (p, c);
			}
		}
		break;
	case 9: /* LDIND_I4 */
		/* reg: LDIND_I4(ADDR_L) */
		if (
			p->op == 9 /* LDIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */
		)
		{
			c = mono_burg_cost_31 (tree, data);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 2;
				closure_reg (p, c);
			}
		}
		/* reg: LDIND_I4(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 3;
				closure_reg (p, c);
			}
		}
		break;
	case 10: /* LDIND_I8 */
		/* lreg: LDIND_I8(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 10;
			}
		}
		break;
	case 11: /* LDIND_R4 */
		/* freg: LDIND_R4(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 12;
			}
		}
		break;
	case 12: /* LDIND_R8 */
		/* freg: LDIND_R8(addr) */
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 13;
			}
		}
		break;
	case 13: /* LDIND_OBJ */
		/* reg: LDIND_OBJ(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 106;
				closure_reg (p, c);
			}
		}
		break;
	case 14: /* STIND_I1 */
		/* stmt: STIND_I1(addr, reg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 13;
			}
		}
		break;
	case 15: /* STIND_I2 */
		/* stmt: STIND_I2(addr, reg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 15;
			}
		}
		break;
	case 16: /* STIND_I4 */
		/* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), CONST_I4)) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 41 /* ADD */ &&
			p->right->left->op == 9 /* LDIND_I4 */ &&
			p->right->left->left->op == 21 /* ADDR_L */ &&
			p->right->right->op == 1 /* CONST_I4 */
		)
		{
			c = mono_burg_cost_20 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 6;
			}
		}
		/* stmt: STIND_I4(ADDR_L, SUB(LDIND_I4(ADDR_L), CONST_I4)) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 44 /* SUB */ &&
			p->right->left->op == 9 /* LDIND_I4 */ &&
			p->right->left->left->op == 21 /* ADDR_L */ &&
			p->right->right->op == 1 /* CONST_I4 */
		)
		{
			c = mono_burg_cost_21 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 7;
			}
		}
		/* stmt: STIND_I4(ADDR_L, ADD(LDIND_I4(ADDR_L), reg)) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 41 /* ADD */ &&
			p->right->left->op == 9 /* LDIND_I4 */ &&
			p->right->left->left->op == 21 /* ADDR_L */
		)
		{
			c = right->right->cost[MB_NTERM_reg] + mono_burg_cost_22 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 8;
			}
		}
		/* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 9 /* LDIND_I4 */ &&
			p->right->left->op == 21 /* ADDR_L */
		)
		{
			c = mono_burg_cost_23 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 9;
			}
		}
		/* stmt: STIND_I4(addr, CONST_I4) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 10;
			}
		}
		/* stmt: STIND_I4(addr, reg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 11;
			}
		}
		/* stmt: STIND_I4(ADDR_L, CONST_I4) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = mono_burg_cost_32 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 17;
			}
		}
		/* stmt: STIND_I4(ADDR_L, LDIND_I4(ADDR_L)) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */ &&
			p->right->op == 9 /* LDIND_I4 */ &&
			p->right->left->op == 21 /* ADDR_L */
		)
		{
			c = mono_burg_cost_33 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 18;
			}
		}
		/* stmt: STIND_I4(ADDR_L, reg) */
		if (
			p->op == 16 /* STIND_I4 */ &&
			p->left->op == 21 /* ADDR_L */
		)
		{
			c = right->cost[MB_NTERM_reg] + mono_burg_cost_34 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 19;
			}
		}
		break;
	case 17: /* STIND_I8 */
		/* stmt: STIND_I8(addr, lreg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 52;
			}
		}
		break;
	case 18: /* STIND_R4 */
		/* stmt: STIND_R4(addr, freg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 58;
			}
		}
		break;
	case 19: /* STIND_R8 */
		/* stmt: STIND_R8(addr, freg) */
		{
			c = left->cost[MB_NTERM_addr] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 59;
			}
		}
		break;
	case 20: /* STIND_OBJ */
		/* stmt: STIND_OBJ(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 66;
			}
		}
		break;
	case 21: /* ADDR_L */
		/* base: ADDR_L */
		{
			c = mono_burg_cost_7 (tree, data);
			if (c < p->cost[MB_NTERM_base]) {
				p->cost[MB_NTERM_base] = c;
				p->rule_base = 4;
				closure_base (p, c);
			}
		}
		/* reg: ADDR_L */
		{
			c = mono_burg_cost_41 (tree, data);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 9;
				closure_reg (p, c);
			}
		}
		break;
	case 22: /* ADDR_G */
		/* acon: ADDR_G */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_acon]) {
				p->cost[MB_NTERM_acon] = c;
				p->rule_acon = 2;
				closure_acon (p, c);
			}
		}
		/* reg: ADDR_G */
		{
			c = 5;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 10;
				closure_reg (p, c);
			}
		}
		break;
	case 23: /* ARG_I4 */
		/* stmt: ARG_I4(LDIND_I4(addr)) */
		if (
			p->op == 23 /* ARG_I4 */ &&
			p->left->op == 9 /* LDIND_I4 */
		)
		{
			c = left->left->cost[MB_NTERM_addr] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 39;
			}
		}
		/* stmt: ARG_I4(LDIND_I4(ADDR_L)) */
		if (
			p->op == 23 /* ARG_I4 */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */
		)
		{
			c = mono_burg_cost_138 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 40;
			}
		}
		/* stmt: ARG_I4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 41;
			}
		}
		/* stmt: ARG_I4(ADDR_G) */
		if (
			p->op == 23 /* ARG_I4 */ &&
			p->left->op == 22 /* ADDR_G */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 42;
			}
		}
		/* stmt: ARG_I4(CONST_I4) */
		if (
			p->op == 23 /* ARG_I4 */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 43;
			}
		}
		break;
	case 24: /* ARG_I8 */
		/* stmt: ARG_I8(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 55;
			}
		}
		break;
	case 25: /* ARG_R4 */
		/* stmt: ARG_R4(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 62;
			}
		}
		break;
	case 26: /* ARG_R8 */
		/* stmt: ARG_R8(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 63;
			}
		}
		break;
	case 27: /* ARG_OBJ */
		/* stmt: ARG_OBJ(CONST_I4) */
		if (
			p->op == 27 /* ARG_OBJ */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 68;
			}
		}
		/* stmt: ARG_OBJ(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 69;
			}
		}
		break;
	case 28: /* CALL_I4 */
		/* reg: CALL_I4(this, reg) */
		{
			c = left->cost[MB_NTERM_this] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 81;
				closure_reg (p, c);
			}
		}
		/* reg: CALL_I4(this, ADDR_G) */
		if (
			p->op == 28 /* CALL_I4 */ &&
			p->right->op == 22 /* ADDR_G */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 82;
				closure_reg (p, c);
			}
		}
		/* reg: CALL_I4(this, INTF_ADDR) */
		if (
			p->op == 28 /* CALL_I4 */ &&
			p->right->op == 79 /* INTF_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 84;
				closure_reg (p, c);
			}
		}
		/* reg: CALL_I4(this, VFUNC_ADDR) */
		if (
			p->op == 28 /* CALL_I4 */ &&
			p->right->op == 80 /* VFUNC_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 87;
				closure_reg (p, c);
			}
		}
		break;
	case 29: /* CALL_I8 */
		/* lreg: CALL_I8(this, reg) */
		{
			c = left->cost[MB_NTERM_this] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 35;
			}
		}
		/* lreg: CALL_I8(this, ADDR_G) */
		if (
			p->op == 29 /* CALL_I8 */ &&
			p->right->op == 22 /* ADDR_G */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 36;
			}
		}
		/* lreg: CALL_I8(this, VFUNC_ADDR) */
		if (
			p->op == 29 /* CALL_I8 */ &&
			p->right->op == 80 /* VFUNC_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 37;
			}
		}
		/* lreg: CALL_I8(this, INTF_ADDR) */
		if (
			p->op == 29 /* CALL_I8 */ &&
			p->right->op == 79 /* INTF_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 38;
			}
		}
		break;
	case 30: /* CALL_R8 */
		/* freg: CALL_R8(this, reg) */
		{
			c = left->cost[MB_NTERM_this] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 21;
			}
		}
		/* freg: CALL_R8(this, ADDR_G) */
		if (
			p->op == 30 /* CALL_R8 */ &&
			p->right->op == 22 /* ADDR_G */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 22;
			}
		}
		/* freg: CALL_R8(this, INTF_ADDR) */
		if (
			p->op == 30 /* CALL_R8 */ &&
			p->right->op == 79 /* INTF_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 23;
			}
		}
		/* freg: CALL_R8(this, VFUNC_ADDR) */
		if (
			p->op == 30 /* CALL_R8 */ &&
			p->right->op == 80 /* VFUNC_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 24;
			}
		}
		break;
	case 31: /* CALL_VOID */
		/* stmt: CALL_VOID(this, ADDR_G) */
		if (
			p->op == 31 /* CALL_VOID */ &&
			p->right->op == 22 /* ADDR_G */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 46;
			}
		}
		/* stmt: CALL_VOID(this, reg) */
		{
			c = left->cost[MB_NTERM_this] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 47;
			}
		}
		/* stmt: CALL_VOID(this, INTF_ADDR) */
		if (
			p->op == 31 /* CALL_VOID */ &&
			p->right->op == 79 /* INTF_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 48;
			}
		}
		/* stmt: CALL_VOID(this, VFUNC_ADDR) */
		if (
			p->op == 31 /* CALL_VOID */ &&
			p->right->op == 80 /* VFUNC_ADDR */
		)
		{
			c = left->cost[MB_NTERM_this] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 49;
			}
		}
		break;
	case 32: /* BREAK */
		/* stmt: BREAK */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 36;
			}
		}
		break;
	case 33: /* SWITCH */
		/* stmt: SWITCH(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 50;
			}
		}
		break;
	case 34: /* BR */
		/* stmt: BR */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 30;
			}
		}
		break;
	case 35: /* RET_VOID */
		/* stmt: RET_VOID */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 38;
			}
		}
		break;
	case 36: /* RET */
		/* stmt: RET(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 37;
			}
		}
		/* stmt: RET(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 54;
			}
		}
		/* stmt: RET(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 65;
			}
		}
		break;
	case 37: /* RET_OBJ */
		/* stmt: RET_OBJ(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 70;
			}
		}
		break;
	case 38: /* ENDFINALLY */
		/* stmt: ENDFINALLY */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 4;
			}
		}
		break;
	case 39: /* ENDFILTER */
		/* stmt: ENDFILTER(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 5;
			}
		}
		break;
	case 40: /* JMP */
		/* stmt: JMP */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 45;
			}
		}
		break;
	case 41: /* ADD */
		/* acon: ADD(ADDR_G, CONST_I4) */
		if (
			p->op == 41 /* ADD */ &&
			p->left->op == 22 /* ADDR_G */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_acon]) {
				p->cost[MB_NTERM_acon] = c;
				p->rule_acon = 3;
				closure_acon (p, c);
			}
		}
		/* base: ADD(reg, CONST_I4) */
		if (
			p->op == 41 /* ADD */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_base]) {
				p->cost[MB_NTERM_base] = c;
				p->rule_base = 3;
				closure_base (p, c);
			}
		}
		/* addr: ADD(index, base) */
		{
			c = left->cost[MB_NTERM_index] + right->cost[MB_NTERM_base] + 0;
			if (c < p->cost[MB_NTERM_addr]) {
				p->cost[MB_NTERM_addr] = c;
				p->rule_addr = 3;
			}
		}
		/* reg: ADD(reg, CONST_I4) */
		if (
			p->op == 41 /* ADD */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 39;
				closure_reg (p, c);
			}
		}
		/* reg: ADD(reg, LDIND_I4(ADDR_L)) */
		if (
			p->op == 41 /* ADD */ &&
			p->right->op == 9 /* LDIND_I4 */ &&
			p->right->left->op == 21 /* ADDR_L */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_72 (tree, data);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 40;
				closure_reg (p, c);
			}
		}
		/* reg: ADD(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 41;
				closure_reg (p, c);
			}
		}
		/* lreg: ADD(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 17;
			}
		}
		/* freg: ADD(freg, freg) */
		{
			c = left->cost[MB_NTERM_freg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 14;
			}
		}
		break;
	case 42: /* ADD_OVF */
		/* reg: ADD_OVF(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 42;
				closure_reg (p, c);
			}
		}
		/* lreg: ADD_OVF(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 18;
			}
		}
		break;
	case 43: /* ADD_OVF_UN */
		/* reg: ADD_OVF_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 43;
				closure_reg (p, c);
			}
		}
		/* lreg: ADD_OVF_UN(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 19;
			}
		}
		break;
	case 44: /* SUB */
		/* reg: SUB(reg, CONST_I4) */
		if (
			p->op == 44 /* SUB */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 44;
				closure_reg (p, c);
			}
		}
		/* reg: SUB(reg, LDIND_I4(ADDR_L)) */
		if (
			p->op == 44 /* SUB */ &&
			p->right->op == 9 /* LDIND_I4 */ &&
			p->right->left->op == 21 /* ADDR_L */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_77 (tree, data);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 45;
				closure_reg (p, c);
			}
		}
		/* reg: SUB(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 46;
				closure_reg (p, c);
			}
		}
		/* lreg: SUB(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 20;
			}
		}
		/* freg: SUB(freg, freg) */
		{
			c = left->cost[MB_NTERM_freg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 15;
			}
		}
		break;
	case 45: /* SUB_OVF */
		/* reg: SUB_OVF(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 47;
				closure_reg (p, c);
			}
		}
		/* lreg: SUB_OVF(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 21;
			}
		}
		break;
	case 46: /* SUB_OVF_UN */
		/* reg: SUB_OVF_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 48;
				closure_reg (p, c);
			}
		}
		/* lreg: SUB_OVF_UN(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 22;
			}
		}
		break;
	case 47: /* MUL */
		/* index: MUL(reg, CONST_I4) */
		if (
			p->op == 47 /* MUL */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_10 (tree, data);
			if (c < p->cost[MB_NTERM_index]) {
				p->cost[MB_NTERM_index] = c;
				p->rule_index = 3;
				closure_index (p, c);
			}
		}
		/* reg: MUL(reg, CONST_I4) */
		if (
			p->op == 47 /* MUL */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 29;
				closure_reg (p, c);
			}
		}
		/* reg: MUL(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 30;
				closure_reg (p, c);
			}
		}
		/* lreg: MUL(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 28;
			}
		}
		/* freg: MUL(freg, freg) */
		{
			c = left->cost[MB_NTERM_freg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 16;
			}
		}
		break;
	case 48: /* MUL_OVF */
		/* reg: MUL_OVF(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 31;
				closure_reg (p, c);
			}
		}
		/* lreg: MUL_OVF(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 29;
			}
		}
		break;
	case 49: /* MUL_OVF_UN */
		/* reg: MUL_OVF_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 32;
				closure_reg (p, c);
			}
		}
		/* lreg: MUL_OVF_UN(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 30;
			}
		}
		break;
	case 50: /* DIV */
		/* reg: DIV(reg, CONST_I4) */
		if (
			p->op == 50 /* DIV */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_65 (tree, data);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 33;
				closure_reg (p, c);
			}
		}
		/* reg: DIV(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 34;
				closure_reg (p, c);
			}
		}
		/* lreg: DIV(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 31;
			}
		}
		/* freg: DIV(freg, freg) */
		{
			c = left->cost[MB_NTERM_freg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 17;
			}
		}
		break;
	case 51: /* DIV_UN */
		/* reg: DIV_UN(reg, CONST_I4) */
		if (
			p->op == 51 /* DIV_UN */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 35;
				closure_reg (p, c);
			}
		}
		/* reg: DIV_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 36;
				closure_reg (p, c);
			}
		}
		/* lreg: DIV_UN(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 33;
			}
		}
		break;
	case 52: /* REM */
		/* reg: REM(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 37;
				closure_reg (p, c);
			}
		}
		/* lreg: REM(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 32;
			}
		}
		/* freg: REM(freg, freg) */
		{
			c = left->cost[MB_NTERM_freg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 19;
			}
		}
		break;
	case 53: /* REM_UN */
		/* reg: REM_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 38;
				closure_reg (p, c);
			}
		}
		/* lreg: REM_UN(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 34;
			}
		}
		break;
	case 54: /* AND */
		/* reg: AND(reg, CONST_I4) */
		if (
			p->op == 54 /* AND */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 50;
				closure_reg (p, c);
			}
		}
		/* reg: AND(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 51;
				closure_reg (p, c);
			}
		}
		/* lreg: AND(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 23;
			}
		}
		break;
	case 55: /* OR */
		/* reg: OR(reg, CONST_I4) */
		if (
			p->op == 55 /* OR */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 52;
				closure_reg (p, c);
			}
		}
		/* reg: OR(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 53;
				closure_reg (p, c);
			}
		}
		/* lreg: OR(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 24;
			}
		}
		break;
	case 56: /* XOR */
		/* reg: XOR(reg, CONST_I4) */
		if (
			p->op == 56 /* XOR */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + MB_USE_OPT1(0);
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 54;
				closure_reg (p, c);
			}
		}
		/* reg: XOR(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 55;
				closure_reg (p, c);
			}
		}
		/* lreg: XOR(lreg, lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 25;
			}
		}
		break;
	case 57: /* SHL */
		/* index: SHL(reg, CONST_I4) */
		if (
			p->op == 57 /* SHL */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_9 (tree, data);
			if (c < p->cost[MB_NTERM_index]) {
				p->cost[MB_NTERM_index] = c;
				p->rule_index = 2;
				closure_index (p, c);
			}
		}
		/* reg: SHL(reg, CONST_I4) */
		if (
			p->op == 57 /* SHL */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 58;
				closure_reg (p, c);
			}
		}
		/* reg: SHL(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 59;
				closure_reg (p, c);
			}
		}
		/* lreg: SHL(lreg, CONST_I4) */
		if (
			p->op == 57 /* SHL */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 15;
			}
		}
		/* lreg: SHL(lreg, reg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 16;
			}
		}
		break;
	case 58: /* SHR */
		/* reg: SHR(reg, CONST_I4) */
		if (
			p->op == 58 /* SHR */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 60;
				closure_reg (p, c);
			}
		}
		/* reg: SHR(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 61;
				closure_reg (p, c);
			}
		}
		/* lreg: SHR(lreg, CONST_I4) */
		if (
			p->op == 58 /* SHR */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 11;
			}
		}
		/* lreg: SHR(lreg, reg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 13;
			}
		}
		break;
	case 59: /* SHR_UN */
		/* reg: SHR_UN(reg, CONST_I4) */
		if (
			p->op == 59 /* SHR_UN */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 62;
				closure_reg (p, c);
			}
		}
		/* reg: SHR_UN(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 63;
				closure_reg (p, c);
			}
		}
		/* lreg: SHR_UN(lreg, CONST_I4) */
		if (
			p->op == 59 /* SHR_UN */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 12;
			}
		}
		/* lreg: SHR_UN(lreg, reg) */
		{
			c = left->cost[MB_NTERM_lreg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 14;
			}
		}
		break;
	case 60: /* NEG */
		/* reg: NEG(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 56;
				closure_reg (p, c);
			}
		}
		/* lreg: NEG(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 26;
			}
		}
		/* freg: NEG(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 20;
			}
		}
		break;
	case 61: /* NOT */
		/* reg: NOT(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 57;
				closure_reg (p, c);
			}
		}
		/* lreg: NOT(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 27;
			}
		}
		break;
	case 62: /* CKFINITE */
		/* freg: CKFINITE(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 18;
			}
		}
		break;
	case 63: /* COMPARE */
		/* cflags: COMPARE(reg, LDIND_I4(ADDR_L)) */
		if (
			p->op == 63 /* COMPARE */ &&
			p->right->op == 9 /* LDIND_I4 */ &&
			p->right->left->op == 21 /* ADDR_L */
		)
		{
			c = left->cost[MB_NTERM_reg] + mono_burg_cost_123 (tree, data);
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 1;
			}
		}
		/* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
		if (
			p->op == 63 /* COMPARE */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = mono_burg_cost_124 (tree, data);
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 2;
			}
		}
		/* cflags: COMPARE(LDIND_I4(ADDR_L), reg) */
		if (
			p->op == 63 /* COMPARE */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */
		)
		{
			c = right->cost[MB_NTERM_reg] + mono_burg_cost_125 (tree, data);
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 3;
			}
		}
		/* cflags: COMPARE(LDIND_I4(ADDR_L), CONST_I4) */
		if (
			p->op == 63 /* COMPARE */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = mono_burg_cost_126 (tree, data);
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 4;
			}
		}
		/* cflags: COMPARE(reg, CONST_I4) */
		if (
			p->op == 63 /* COMPARE */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 5;
			}
		}
		/* cflags: COMPARE(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_cflags]) {
				p->cost[MB_NTERM_cflags] = c;
				p->rule_cflags = 6;
			}
		}
		break;
	case 64: /* CBRANCH */
		/* stmt: CBRANCH(cflags) */
		{
			c = left->cost[MB_NTERM_cflags] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 31;
			}
		}
		/* stmt: CBRANCH(COMPARE(lreg, lreg)) */
		if (
			p->op == 64 /* CBRANCH */ &&
			p->left->op == 63 /* COMPARE */
		)
		{
			c = left->left->cost[MB_NTERM_lreg] + left->right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 56;
			}
		}
		/* stmt: CBRANCH(COMPARE(freg, freg)) */
		if (
			p->op == 64 /* CBRANCH */ &&
			p->left->op == 63 /* COMPARE */
		)
		{
			c = left->left->cost[MB_NTERM_freg] + left->right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 64;
			}
		}
		break;
	case 65: /* BRTRUE */
		/* stmt: BRTRUE(LDIND_I4(ADDR_L)) */
		if (
			p->op == 65 /* BRTRUE */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 32;
			}
		}
		/* stmt: BRTRUE(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 33;
			}
		}
		break;
	case 66: /* BRFALSE */
		/* stmt: BRFALSE(LDIND_I4(ADDR_L)) */
		if (
			p->op == 66 /* BRFALSE */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 21 /* ADDR_L */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 34;
			}
		}
		/* stmt: BRFALSE(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 35;
			}
		}
		break;
	case 67: /* CSET */
		/* reg: CSET(cflags) */
		{
			c = left->cost[MB_NTERM_cflags] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 49;
				closure_reg (p, c);
			}
		}
		/* reg: CSET(COMPARE(lreg, lreg)) */
		if (
			p->op == 67 /* CSET */ &&
			p->left->op == 63 /* COMPARE */
		)
		{
			c = left->left->cost[MB_NTERM_lreg] + left->right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 98;
				closure_reg (p, c);
			}
		}
		/* reg: CSET(COMPARE(freg, freg)) */
		if (
			p->op == 67 /* CSET */ &&
			p->left->op == 63 /* COMPARE */
		)
		{
			c = left->left->cost[MB_NTERM_freg] + left->right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 105;
				closure_reg (p, c);
			}
		}
		break;
	case 68: /* CONV_I4 */
		/* reg: CONV_I4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 16;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 92;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I4(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 103;
				closure_reg (p, c);
			}
		}
		break;
	case 69: /* CONV_I1 */
		/* reg: CONV_I1(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 11;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I1(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 88;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I1(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 99;
				closure_reg (p, c);
			}
		}
		break;
	case 70: /* CONV_I2 */
		/* reg: CONV_I2(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 13;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I2(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 90;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_I2(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 101;
				closure_reg (p, c);
			}
		}
		break;
	case 71: /* CONV_I8 */
		/* lreg: CONV_I8(CONST_I4) */
		if (
			p->op == 71 /* CONV_I8 */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 2;
			}
		}
		/* lreg: CONV_I8(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 3;
			}
		}
		/* lreg: CONV_I8(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 39;
			}
		}
		break;
	case 72: /* CONV_U1 */
		/* reg: CONV_U1(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 12;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U1(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 89;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U1(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 100;
				closure_reg (p, c);
			}
		}
		break;
	case 73: /* CONV_U2 */
		/* reg: CONV_U2(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 14;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U2(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 91;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U2(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 102;
				closure_reg (p, c);
			}
		}
		break;
	case 74: /* CONV_U4 */
		/* reg: CONV_U4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 17;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 93;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_U4(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 104;
				closure_reg (p, c);
			}
		}
		break;
	case 75: /* CONV_U8 */
		/* lreg: CONV_U8(CONST_I4) */
		if (
			p->op == 75 /* CONV_U8 */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 1;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 4;
			}
		}
		/* lreg: CONV_U8(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 5;
			}
		}
		/* lreg: CONV_U8(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 40;
			}
		}
		break;
	case 76: /* CONV_R4 */
		/* freg: CONV_R4(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 2;
			}
		}
		/* freg: CONV_R4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 4;
			}
		}
		/* freg: CONV_R4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 8;
			}
		}
		break;
	case 77: /* CONV_R8 */
		/* freg: CONV_R8(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 1;
			}
		}
		/* freg: CONV_R8(LDIND_I4(ADDR_G)) */
		if (
			p->op == 77 /* CONV_R8 */ &&
			p->left->op == 9 /* LDIND_I4 */ &&
			p->left->left->op == 22 /* ADDR_G */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 3;
			}
		}
		/* freg: CONV_R8(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 5;
			}
		}
		/* freg: CONV_R8(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 9;
			}
		}
		break;
	case 78: /* CONV_R_UN */
		/* freg: CONV_R_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 6;
			}
		}
		/* freg: CONV_R_UN(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 7;
			}
		}
		break;
	case 79: /* INTF_ADDR */
		break;
	case 80: /* VFUNC_ADDR */
		break;
	case 81: /* NOP */
		/* stmt: NOP */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 28;
			}
		}
		/* this: NOP */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_this]) {
				p->cost[MB_NTERM_this] = c;
				p->rule_this = 2;
			}
		}
		break;
	case 82: /* NEWARR */
		/* reg: NEWARR(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 69;
				closure_reg (p, c);
			}
		}
		break;
	case 83: /* NEWARR_SPEC */
		/* reg: NEWARR_SPEC(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 70;
				closure_reg (p, c);
			}
		}
		break;
	case 84: /* NEWOBJ */
		/* reg: NEWOBJ */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 71;
				closure_reg (p, c);
			}
		}
		break;
	case 85: /* NEWOBJ_SPEC */
		/* reg: NEWOBJ_SPEC */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 72;
				closure_reg (p, c);
			}
		}
		break;
	case 86: /* INITBLK */
		/* stmt: INITBLK(reg, CPSRC(reg, CONST_I4)) */
		if (
			p->op == 86 /* INITBLK */ &&
			p->right->op == 88 /* CPSRC */ &&
			p->right->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + right->left->cost[MB_NTERM_reg] + mono_burg_cost_118 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 26;
			}
		}
		/* stmt: INITBLK(reg, CPSRC(reg, reg)) */
		if (
			p->op == 86 /* INITBLK */ &&
			p->right->op == 88 /* CPSRC */
		)
		{
			c = left->cost[MB_NTERM_reg] + right->left->cost[MB_NTERM_reg] + right->right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 27;
			}
		}
		break;
	case 87: /* CPBLK */
		/* stmt: CPBLK(reg, CPSRC(reg, CONST_I4)) */
		if (
			p->op == 87 /* CPBLK */ &&
			p->right->op == 88 /* CPSRC */ &&
			p->right->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + right->left->cost[MB_NTERM_reg] + mono_burg_cost_116 (tree, data);
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 24;
			}
		}
		/* stmt: CPBLK(reg, CPSRC(reg, reg)) */
		if (
			p->op == 87 /* CPBLK */ &&
			p->right->op == 88 /* CPSRC */
		)
		{
			c = left->cost[MB_NTERM_reg] + right->left->cost[MB_NTERM_reg] + right->right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 25;
			}
		}
		break;
	case 88: /* CPSRC */
		break;
	case 89: /* POP */
		/* stmt: POP(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 29;
			}
		}
		/* stmt: POP(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 51;
			}
		}
		/* stmt: POP(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 57;
			}
		}
		break;
	case 90: /* INITOBJ */
		/* stmt: INITOBJ(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 23;
			}
		}
		break;
	case 91: /* LOCALLOC */
		/* reg: LOCALLOC(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 76;
				closure_reg (p, c);
			}
		}
		break;
	case 92: /* ISINST */
		/* reg: ISINST(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 79;
				closure_reg (p, c);
			}
		}
		break;
	case 93: /* CASTCLASS */
		/* reg: CASTCLASS(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 78;
				closure_reg (p, c);
			}
		}
		break;
	case 94: /* UNBOX */
		/* reg: UNBOX(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 77;
				closure_reg (p, c);
			}
		}
		break;
	case 95: /* CONV_OVF_I1 */
		/* reg: CONV_OVF_I1(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 21;
				closure_reg (p, c);
			}
		}
		break;
	case 96: /* CONV_OVF_U1 */
		/* reg: CONV_OVF_U1(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 23;
				closure_reg (p, c);
			}
		}
		break;
	case 97: /* CONV_OVF_I2 */
		/* reg: CONV_OVF_I2(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 25;
				closure_reg (p, c);
			}
		}
		break;
	case 98: /* CONV_OVF_U2 */
		/* reg: CONV_OVF_U2(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 26;
				closure_reg (p, c);
			}
		}
		break;
	case 99: /* CONV_OVF_U4 */
		/* reg: CONV_OVF_U4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 19;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_OVF_U4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 96;
				closure_reg (p, c);
			}
		}
		break;
	case 100: /* CONV_OVF_U8 */
		/* lreg: CONV_OVF_U8(CONST_I4) */
		if (
			p->op == 100 /* CONV_OVF_U8 */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 6;
			}
		}
		/* lreg: CONV_OVF_U8(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 8;
			}
		}
		break;
	case 101: /* CONV_OVF_I4 */
		/* reg: CONV_OVF_I4(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 18;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_OVF_I4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 94;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_OVF_I4(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 95;
				closure_reg (p, c);
			}
		}
		break;
	case 102: /* CONV_OVF_I4_UN */
		/* reg: CONV_OVF_I4_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 20;
				closure_reg (p, c);
			}
		}
		/* reg: CONV_OVF_I4_UN(lreg) */
		{
			c = left->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 97;
				closure_reg (p, c);
			}
		}
		break;
	case 103: /* CONV_OVF_U1_UN */
		/* reg: CONV_OVF_U1_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 24;
				closure_reg (p, c);
			}
		}
		break;
	case 104: /* CONV_OVF_U2_UN */
		/* reg: CONV_OVF_U2_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 27;
				closure_reg (p, c);
			}
		}
		break;
	case 105: /* CONV_OVF_I2_UN */
		/* reg: CONV_OVF_I2_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 28;
				closure_reg (p, c);
			}
		}
		break;
	case 106: /* CONV_OVF_I8_UN */
		/* lreg: CONV_OVF_I8_UN(CONST_I4) */
		if (
			p->op == 106 /* CONV_OVF_I8_UN */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 7;
			}
		}
		/* lreg: CONV_OVF_I8_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_lreg]) {
				p->cost[MB_NTERM_lreg] = c;
				p->rule_lreg = 9;
			}
		}
		break;
	case 107: /* CONV_OVF_I1_UN */
		/* reg: CONV_OVF_I1_UN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 22;
				closure_reg (p, c);
			}
		}
		break;
	case 108: /* EXCEPTION */
		/* reg: EXCEPTION */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 1;
				closure_reg (p, c);
			}
		}
		break;
	case 109: /* THROW */
		/* stmt: THROW(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 1;
			}
		}
		break;
	case 110: /* RETHROW */
		/* stmt: RETHROW */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 2;
			}
		}
		break;
	case 111: /* HANDLER */
		/* stmt: HANDLER */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 3;
			}
		}
		break;
	case 112: /* CHECKTHIS */
		/* reg: CHECKTHIS(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 80;
				closure_reg (p, c);
			}
		}
		/* stmt: CHECKTHIS(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 44;
			}
		}
		break;
	case 113: /* LDLEN */
		/* reg: LDLEN(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 65;
				closure_reg (p, c);
			}
		}
		break;
	case 114: /* LDELEMA */
		/* reg: LDELEMA(reg, CONST_I4) */
		if (
			p->op == 114 /* LDELEMA */ &&
			p->right->op == 1 /* CONST_I4 */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 66;
				closure_reg (p, c);
			}
		}
		/* reg: LDELEMA(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 67;
				closure_reg (p, c);
			}
		}
		break;
	case 115: /* LDFTN */
		/* reg: LDFTN */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 86;
				closure_reg (p, c);
			}
		}
		break;
	case 116: /* LDVIRTFTN */
		/* reg: LDVIRTFTN(reg, INTF_ADDR) */
		if (
			p->op == 116 /* LDVIRTFTN */ &&
			p->right->op == 79 /* INTF_ADDR */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 83;
				closure_reg (p, c);
			}
		}
		/* reg: LDVIRTFTN(reg, VFUNC_ADDR) */
		if (
			p->op == 116 /* LDVIRTFTN */ &&
			p->right->op == 80 /* VFUNC_ADDR */
		)
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 85;
				closure_reg (p, c);
			}
		}
		break;
	case 117: /* LDSTR */
		/* reg: LDSTR */
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 68;
				closure_reg (p, c);
			}
		}
		break;
	case 118: /* LDSFLDA */
		/* reg: LDSFLDA(CONST_I4) */
		if (
			p->op == 118 /* LDSFLDA */ &&
			p->left->op == 1 /* CONST_I4 */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 64;
				closure_reg (p, c);
			}
		}
		break;
	case 119: /* REMOTE_LDFLDA */
		/* reg: REMOTE_LDFLDA(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 8;
				closure_reg (p, c);
			}
		}
		break;
	case 120: /* REMOTE_STIND_I1 */
		/* stmt: REMOTE_STIND_I1(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 14;
			}
		}
		break;
	case 121: /* REMOTE_STIND_I2 */
		/* stmt: REMOTE_STIND_I2(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 16;
			}
		}
		break;
	case 122: /* REMOTE_STIND_I4 */
		/* stmt: REMOTE_STIND_I4(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 12;
			}
		}
		break;
	case 123: /* REMOTE_STIND_I8 */
		/* stmt: REMOTE_STIND_I8(reg, lreg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_lreg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 53;
			}
		}
		break;
	case 124: /* REMOTE_STIND_R4 */
		/* stmt: REMOTE_STIND_R4(reg, freg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 60;
			}
		}
		break;
	case 125: /* REMOTE_STIND_R8 */
		/* stmt: REMOTE_STIND_R8(reg, freg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 61;
			}
		}
		break;
	case 126: /* REMOTE_STIND_OBJ */
		/* stmt: REMOTE_STIND_OBJ(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 67;
			}
		}
		break;
	case 127: /* SIN */
		/* freg: SIN(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 25;
			}
		}
		break;
	case 128: /* COS */
		/* freg: COS(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 26;
			}
		}
		break;
	case 129: /* SQRT */
		/* freg: SQRT(freg) */
		{
			c = left->cost[MB_NTERM_freg] + 0;
			if (c < p->cost[MB_NTERM_freg]) {
				p->cost[MB_NTERM_freg] = c;
				p->rule_freg = 27;
			}
		}
		break;
	case 130: /* FUNC1 */
		/* reg: FUNC1(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 75;
				closure_reg (p, c);
			}
		}
		break;
	case 131: /* PROC2 */
		/* stmt: PROC2(reg, reg) */
		{
			c = left->cost[MB_NTERM_reg] + right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 21;
			}
		}
		break;
	case 132: /* PROC3 */
		/* stmt: PROC3(reg, CPSRC(reg, reg)) */
		if (
			p->op == 132 /* PROC3 */ &&
			p->right->op == 88 /* CPSRC */
		)
		{
			c = left->cost[MB_NTERM_reg] + right->left->cost[MB_NTERM_reg] + right->right->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 22;
			}
		}
		break;
	case 133: /* FREE */
		/* stmt: FREE(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_stmt]) {
				p->cost[MB_NTERM_stmt] = c;
				p->rule_stmt = 20;
			}
		}
		break;
	case 134: /* OBJADDR */
		/* reg: OBJADDR(reg) */
		{
			c = left->cost[MB_NTERM_reg] + 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 73;
				closure_reg (p, c);
			}
		}
		break;
	case 135: /* VTADDR */
		/* reg: VTADDR(ADDR_L) */
		if (
			p->op == 135 /* VTADDR */ &&
			p->left->op == 21 /* ADDR_L */
		)
		{
			c = 0;
			if (c < p->cost[MB_NTERM_reg]) {
				p->cost[MB_NTERM_reg] = c;
				p->rule_reg = 74;
				closure_reg (p, c);
			}
		}
		break;
	default:
		g_error ("unknown operator");
	}

	MBTREE_STATE(tree) = p;
	return p;
}

MBState *
mono_burg_label (MBTREE_TYPE *tree, MBCOST_DATA *data)
{
	MBState *p = mono_burg_label_priv (tree, data);
	return p->rule_stmt ? p : NULL;
}

int
mono_burg_rule (MBState *state, int goal)
{
	g_return_val_if_fail (state != NULL, 0);
	g_return_val_if_fail (goal > 0, 0);

	switch (goal) {
	case MB_NTERM_stmt:
		return mono_burg_decode_stmt [state->rule_stmt];
	case MB_NTERM_acon:
		return mono_burg_decode_acon [state->rule_acon];
	case MB_NTERM_base:
		return mono_burg_decode_base [state->rule_base];
	case MB_NTERM_reg:
		return mono_burg_decode_reg [state->rule_reg];
	case MB_NTERM_index:
		return mono_burg_decode_index [state->rule_index];
	case MB_NTERM_addr:
		return mono_burg_decode_addr [state->rule_addr];
	case MB_NTERM_cflags:
		return mono_burg_decode_cflags [state->rule_cflags];
	case MB_NTERM_this:
		return mono_burg_decode_this [state->rule_this];
	case MB_NTERM_lreg:
		return mono_burg_decode_lreg [state->rule_lreg];
	case MB_NTERM_freg:
		return mono_burg_decode_freg [state->rule_freg];
	default: g_assert_not_reached ();
	}
	return 0;
}

MBTREE_TYPE **
mono_burg_kids (MBTREE_TYPE *tree, int rulenr, MBTREE_TYPE *kids [])
{
	g_return_val_if_fail (tree != NULL, NULL);
	g_return_val_if_fail (MBTREE_STATE(tree) != NULL, NULL);
	g_return_val_if_fail (kids != NULL, NULL);

	switch (rulenr) {
	case 1:
	case 2:
	case 3:
	case 7:
	case 14:
	case 16:
	case 17:
	case 18:
	case 20:
	case 21:
	case 23:
	case 31:
	case 32:
	case 33:
	case 41:
	case 42:
	case 47:
	case 96:
	case 100:
	case 103:
	case 104:
	case 106:
	case 120:
	case 122:
	case 124:
	case 126:
	case 130:
	case 132:
	case 134:
	case 136:
	case 138:
	case 140:
	case 141:
	case 145:
	case 146:
	case 152:
	case 170:
	case 171:
	case 173:
	case 175:
	case 176:
	case 225:
	case 232:
	case 233:
	case 262:
		break;
	case 4:
	case 5:
	case 8:
	case 11:
	case 12:
	case 142:
		kids[0] = tree;
		break;
	case 6:
	case 9:
	case 10:
	case 15:
	case 19:
	case 24:
	case 35:
	case 36:
	case 37:
	case 38:
	case 39:
	case 40:
	case 43:
	case 44:
	case 45:
	case 46:
	case 48:
	case 49:
	case 50:
	case 51:
	case 52:
	case 53:
	case 54:
	case 55:
	case 56:
	case 57:
	case 58:
	case 59:
	case 60:
	case 61:
	case 65:
	case 67:
	case 71:
	case 72:
	case 76:
	case 77:
	case 81:
	case 82:
	case 84:
	case 86:
	case 88:
	case 89:
	case 90:
	case 92:
	case 94:
	case 97:
	case 98:
	case 101:
	case 102:
	case 105:
	case 107:
	case 110:
	case 111:
	case 112:
	case 113:
	case 114:
	case 115:
	case 121:
	case 123:
	case 127:
	case 129:
	case 131:
	case 133:
	case 135:
	case 139:
	case 143:
	case 144:
	case 148:
	case 149:
	case 150:
	case 151:
	case 153:
	case 154:
	case 156:
	case 157:
	case 158:
	case 159:
	case 160:
	case 161:
	case 162:
	case 163:
	case 164:
	case 165:
	case 166:
	case 167:
	case 168:
	case 169:
	case 172:
	case 174:
	case 177:
	case 178:
	case 181:
	case 182:
	case 183:
	case 186:
	case 197:
	case 198:
	case 207:
	case 208:
	case 209:
	case 210:
	case 211:
	case 214:
	case 215:
	case 216:
	case 217:
	case 218:
	case 219:
	case 220:
	case 221:
	case 223:
	case 224:
	case 226:
	case 227:
	case 228:
	case 229:
	case 230:
	case 231:
	case 234:
	case 235:
	case 240:
	case 242:
	case 243:
	case 248:
	case 249:
	case 252:
	case 253:
	case 254:
	case 255:
	case 256:
	case 257:
	case 258:
	case 259:
	case 263:
	case 264:
		kids[0] = MBTREE_LEFT(tree);
		break;
	case 13:
	case 25:
	case 26:
	case 27:
	case 28:
	case 29:
	case 30:
	case 62:
	case 63:
	case 64:
	case 66:
	case 68:
	case 69:
	case 70:
	case 73:
	case 74:
	case 75:
	case 78:
	case 79:
	case 80:
	case 83:
	case 85:
	case 87:
	case 91:
	case 93:
	case 95:
	case 99:
	case 108:
	case 128:
	case 147:
	case 155:
	case 179:
	case 180:
	case 184:
	case 185:
	case 187:
	case 188:
	case 189:
	case 190:
	case 191:
	case 192:
	case 193:
	case 194:
	case 195:
	case 196:
	case 199:
	case 200:
	case 201:
	case 202:
	case 203:
	case 204:
	case 205:
	case 206:
	case 236:
	case 237:
	case 238:
	case 239:
	case 241:
	case 244:
	case 245:
	case 246:
	case 247:
	case 251:
	case 260:
	case 261:
		kids[0] = MBTREE_LEFT(tree);
		kids[1] = MBTREE_RIGHT(tree);
		break;
	case 22:
		kids[0] = MBTREE_RIGHT(MBTREE_RIGHT(tree));
		break;
	case 34:
	case 125:
		kids[0] = MBTREE_RIGHT(tree);
		break;
	case 109:
	case 117:
	case 119:
		kids[0] = MBTREE_LEFT(tree);
		kids[1] = MBTREE_LEFT(MBTREE_RIGHT(tree));
		kids[2] = MBTREE_RIGHT(MBTREE_RIGHT(tree));
		break;
	case 116:
	case 118:
		kids[0] = MBTREE_LEFT(tree);
		kids[1] = MBTREE_LEFT(MBTREE_RIGHT(tree));
		break;
	case 137:
		kids[0] = MBTREE_LEFT(MBTREE_LEFT(tree));
		break;
	case 212:
	case 213:
	case 222:
	case 250:
		kids[0] = MBTREE_LEFT(MBTREE_LEFT(tree));
		kids[1] = MBTREE_RIGHT(MBTREE_LEFT(tree));
		break;
	default:
		g_assert_not_reached ();
	}
	return kids;
}


#include "jit.h"

gint64 
mono_llmult (gint64 a, gint64 b)
{
	return a * b;
}

guint64  
mono_llmult_ovf_un (gpointer *exc, guint32 al, guint32 ah, guint32 bl, guint32 bh)
{
	guint64 res, t1;

	// fixme: this is incredible slow

	if (ah && bh)
		goto raise_exception;

	res = (guint64)al * (guint64)bl;

	t1 = (guint64)ah * (guint64)bl + (guint64)al * (guint64)bh;

	if (t1 > 0xffffffff)
		goto raise_exception;

	res += ((guint64)t1) << 32; 

	*exc = NULL;
	return res;

 raise_exception:
	*exc = mono_get_exception_overflow ();
	return 0;
}

guint64  
mono_llmult_ovf (gpointer *exc, guint32 al, gint32 ah, guint32 bl, gint32 bh)
{
	gint64 res, t1;

	// fixme: check for overflow

	res = (gint64)al * (gint64)bl;

	t1 = (gint64)ah * bl + al * (gint64)bh;

	res += ((gint64)t1) << 32; 

	*exc = NULL;
	return res;
/*
 raise_exception:
	*exc = mono_get_exception_overflow ();
	return 0;
*/
}

gint64 
mono_lldiv (gint64 a, gint64 b)
{
	return a / b;
}

gint64 
mono_llrem (gint64 a, gint64 b)
{
	return a % b;
}

guint64 
mono_lldiv_un (guint64 a, guint64 b)
{
	return a / b;
}

guint64 
mono_llrem_un (guint64 a, guint64 b)
{
	return a % b;
}

MonoArray*
mono_array_new_wrapper  (MonoClass *eclass, guint32 n)
{
	MonoDomain *domain = mono_domain_get ();

	return mono_array_new (domain, eclass, n);
}

MonoObject *
mono_object_new_wrapper (MonoClass *klass)
{
	MonoDomain *domain = mono_domain_get ();

	return mono_object_new (domain, klass);
}

MonoString*
mono_ldstr_wrapper (MonoImage *image, guint32 ind)
{
	MonoDomain *domain = mono_domain_get ();

	return mono_ldstr (domain, image, ind);
}

gpointer 
mono_ldsflda (MonoClass *klass, int offset)
{
	MonoDomain *domain = mono_domain_get ();
	MonoVTable *vt;
	gpointer addr;
	
	vt = mono_class_vtable (domain, klass);
	addr = (char*)(vt->data) + offset;

	return addr;
}

void *
debug_memcopy (void *dest, const void *src, size_t n)
{
	int i, l = n;

	printf ("MEMCPY(%p to %p [%d]) ", src, dest, n);

	for (i = 0; i < l; i++)
		printf ("%02x ", *((guint8 *)src + i));
	printf ("\n");
	
	return memcpy (dest, src, n);
}

void mono_emit_fast_iconv (MBCGEN_TYPE* s, MBTREE_TYPE* tree)
{
	guint8* br [3];
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 12);
	x86_fist_membase (s->code, X86_ESP, 8, TRUE); // rounded value
	x86_fst_membase (s->code, X86_ESP, 0, FALSE, FALSE); // float value
	x86_fp_int_op_membase (s->code, X86_FSUB, X86_ESP, 8, TRUE);
	x86_fst_membase (s->code, X86_ESP, 4, FALSE, TRUE); // diff

	x86_pop_reg (s->code, tree->reg1); // float value
	x86_test_reg_reg (s->code, tree->reg1, tree->reg1);
	br[0] = s->code; x86_branch8 (s->code, X86_CC_S, 0, TRUE);

	x86_pop_reg (s->code, tree->reg1); // diff
	x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
	x86_pop_reg (s->code, tree->reg1); // rounded value
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg1, 0);
	br[1] = s->code; x86_jump8 (s->code, 0);

	// freg is negative
	x86_patch (br[0], s->code);

	x86_pop_reg (s->code, tree->reg1); // diff
	x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
	x86_pop_reg (s->code, tree->reg1); // rounded value
	br[2] = s->code; x86_branch8 (s->code, X86_CC_Z, 0, FALSE);
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg1, -1);
	x86_patch (br[1], s->code);
	x86_patch (br[2], s->code);
}

void mono_emit_fast_iconv_i8 (MBCGEN_TYPE* s, MBTREE_TYPE* tree)
{
	guint8* br [3];
	x86_alu_reg_imm (s->code, X86_SUB, X86_ESP, 16);
	x86_fld_reg (s->code, 0);
	x86_fist_pop_membase (s->code, X86_ESP, 8, TRUE); // rounded value (qword)
	x86_fst_membase (s->code, X86_ESP, 0, FALSE, FALSE); // float value
	x86_fild_membase (s->code, X86_ESP, 8, TRUE);
	x86_fp_op_reg (s->code, X86_FSUB, 1, TRUE); // diff
	x86_fst_membase (s->code, X86_ESP, 4, FALSE, TRUE); // diff

	x86_pop_reg (s->code, tree->reg1); // float value
	x86_test_reg_reg (s->code, tree->reg1, tree->reg1);
	br[0] = s->code; x86_branch8 (s->code, X86_CC_S, 0, TRUE);

	x86_pop_reg (s->code, tree->reg1); // diff
	x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
	x86_pop_reg (s->code, tree->reg1); // rounded value
	x86_pop_reg (s->code, tree->reg2);
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg1, 0);
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg2, 0);
	br[1] = s->code; x86_jump8 (s->code, 0);

	// freg is negative
	x86_patch (br[0], s->code);

	x86_pop_reg (s->code, tree->reg1); // diff
	x86_alu_reg_reg (s->code, X86_ADD, tree->reg1, tree->reg1);
	x86_pop_reg (s->code, tree->reg1); // rounded value
	x86_pop_reg (s->code, tree->reg2);
	br[2] = s->code; x86_branch8 (s->code, X86_CC_Z, 0, FALSE);
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg1, -1);
	x86_alu_reg_imm (s->code, X86_SBB, tree->reg2, -1);
	x86_patch (br[1], s->code);
	x86_patch (br[2], s->code);
}

gpointer 
mono_ldvirtftn (MonoObject *this, int slot)
{
	MonoClass *class;
	MonoMethod *m;
	gpointer addr;
	gboolean is_proxy = FALSE;
	g_assert (this);

	if ((class = this->vtable->klass) == mono_defaults.transparent_proxy_class) {
		class = ((MonoTransparentProxy *)this)->klass;
		is_proxy = TRUE;
	}

	
	g_assert (slot <= class->vtable_size);

	m = class->vtable [slot];

	if (is_proxy) {
		return mono_jit_create_remoting_trampoline (m);
	} else {
		EnterCriticalSection (metadata_section);
		addr = mono_compile_method (m);
		LeaveCriticalSection (metadata_section);
		return addr;
	}
}

gpointer 
mono_ldintftn (MonoObject *this, int slot)
{
	MonoClass *class;
	MonoMethod *m;
	gpointer addr;
	gboolean is_proxy = FALSE;
	g_assert (this);

	if ((class = this->vtable->klass) == mono_defaults.transparent_proxy_class) {
		class = ((MonoTransparentProxy *)this)->klass;
		is_proxy = TRUE;
	}

	g_assert (slot < class->interface_count);

	slot = class->interface_offsets [slot];

	m = class->vtable [slot];

	if (is_proxy) {
		return mono_jit_create_remoting_trampoline (m);
	} else {
		EnterCriticalSection (metadata_section);
		addr = mono_compile_method (m);
		LeaveCriticalSection (metadata_section);
		return addr;
	}
}

gpointer mono_ldftn (MonoMethod *method)
{
	gpointer addr;

	EnterCriticalSection (metadata_section);
	addr = mono_compile_method (method);
	LeaveCriticalSection (metadata_section);

	return addr;
}
